#pragma once

#include "./VideoNetClientDemo_Common.h"
#include "afxwin.h"

// CSelectFontDlg Ի
//С
#define MIN_FONT_SIZE	8
//
#define MAX_FONT_SIZE	24

typedef list<LOGFONT>	FONTLIST;

class CSelectFontDlg : public CDialog
{
	DECLARE_DYNAMIC(CSelectFontDlg)

public:
	CSelectFontDlg(CString &str, CWnd* pParent = NULL);   // ׼캯
	virtual ~CSelectFontDlg();

	//ȡѡ
	int GetSelectFont(LOGFONT &lfont);
	//ѡ
	int SetSelectFont(LOGFONT &lfont);
	//
	bool ValidData();
	//öϵͳ
	int EnumSystemFont(HDC dc);
	//ˢϵͳ嵽Ի
	int RefreshFont();
	//ˢԤ
	int RefreshPreview(bool bUseCurrent = true);
	//ȡѡ
	int GetCurrentSelectFont(LOGFONT &lfont);
	//öϵͳص
	static int CALLBACK EnumFontProc(const ENUMLOGFONTEX *lpelfe, const NEWTEXTMETRICEX *lpntme, DWORD FontType, LPARAM lParam);
	//ǰϢ
	LOGFONT			m_curFont;
	//ǰ
	CFont			*m_hCurFont;
	CFont			m_hFont;
	//Ϣ
	FONTLIST	m_lsFonts;
// Ի
	enum { IDD = IDD_SELECT_FONT };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	CListBox m_lsFontSizeBox;
	CListBox m_lsFontsBox;
	CString m_strPreview;
	afx_msg void OnPaint();
	afx_msg void OnBnClickedOk();
	afx_msg void OnLbnSelchangeList1();
	afx_msg void OnLbnSelchangeList2();
};
