// SelectFontDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemoDlg.h"
#include "../inc/SelectFontDlg.h"


// CSelectFontDlg Ի

IMPLEMENT_DYNAMIC(CSelectFontDlg, CDialog)

CSelectFontDlg::CSelectFontDlg(CString &str, CWnd* pParent /*=NULL*/)
	: CDialog(CSelectFontDlg::IDD, pParent)
{
	m_strPreview = str;
}

CSelectFontDlg::~CSelectFontDlg()
{
}

void CSelectFontDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST2, m_lsFontSizeBox);
	DDX_Control(pDX, IDC_LIST1, m_lsFontsBox);
	DDX_Text(pDX, IDC_STATIC1, m_strPreview);
}


BEGIN_MESSAGE_MAP(CSelectFontDlg, CDialog)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDOK, &CSelectFontDlg::OnBnClickedOk)
	ON_LBN_SELCHANGE(IDC_LIST1, &CSelectFontDlg::OnLbnSelchangeList1)
	ON_LBN_SELCHANGE(IDC_LIST2, &CSelectFontDlg::OnLbnSelchangeList2)
END_MESSAGE_MAP()


// CSelectFontDlg Ϣ

BOOL CSelectFontDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ

	CString strTemp;
	for (int iCount = MIN_FONT_SIZE; iCount <= MAX_FONT_SIZE; iCount++)
	{
		strTemp.Format(_T("%d"), iCount);
		m_lsFontSizeBox.AddString(strTemp);
	}
	this->SendMessage(WM_PAINT, 0, 0);
	//ˢԤ
	RefreshPreview();

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CSelectFontDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: ڴ˴Ϣ
	// ΪͼϢ CDialog::OnPaint()
	if (0 == m_lsFonts.size())
	{
		//öϵͳ
		EnumSystemFont(GetDC()->GetSafeHdc());
		//ˢϢ
		RefreshFont();
		if (-1 == m_lsFontsBox.GetCurSel())
		{
			if ('\0' == m_curFont.lfFaceName[0])
			{
				m_lsFontsBox.SetCurSel(0);
			}else{
				int iCount = 0;
				for (;iCount < m_lsFontsBox.GetCount(); iCount++)
				{
					CString strName;
					m_lsFontsBox.GetText(iCount, strName);
					//ѡַ
					if (strName == m_curFont.lfFaceName)
					{
						m_lsFontsBox.SetCurSel(iCount);
						break;
					}
				}
			}
		}
		if (-1 == m_lsFontSizeBox.GetCurSel())
		{
			if ('\0' == m_curFont.lfFaceName[0])
			{
				m_lsFontSizeBox.SetCurSel(m_lsFontSizeBox.GetCount() - 1);
			}else{
				m_lsFontSizeBox.SetCurSel(m_curFont.lfHeight);
			}
		}
	}
}

void CSelectFontDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	if (!ValidData())
	{
		return;
	}
	OnOK();
}

void CSelectFontDlg::OnLbnSelchangeList1()
{
	// TODO: ڴӿؼ֪ͨ
	//ˢԤ
	RefreshPreview();
}

void CSelectFontDlg::OnLbnSelchangeList2()
{
	// TODO: ڴӿؼ֪ͨ
	//ˢԤ
	RefreshPreview();
}

//ˢԤ
int CSelectFontDlg::RefreshPreview(bool bUseCurrent)
{
	return 0;
	if (bUseCurrent)
	{
		//ȡѡ
		GetCurrentSelectFont(m_curFont);
		LOGFONT lfont;
		memcpy(&lfont, &m_curFont, sizeof(lfont));
		lfont.lfHeight = MIN_FONT_SIZE + lfont.lfHeight;//lfont.lfHeight + lfont.lfClipPrecision * lfont.lfHeight;//MIN_FONT_SIZE + 
		//lfont.lfWidth = lfont.lfHeight;
		//µ
		//m_hCurFont = ::CreateFontIndirect(&lfont);
		m_hCurFont = &m_hFont;
		m_hCurFont->CreateFontIndirect(&lfont);
	}else{
		//ȡǰ
		m_hCurFont = GetDlgItem(IDC_STATIC1)->GetFont();
	}
	//ô
	GetDlgItem(IDC_STATIC1)->SetFont(m_hCurFont);
	GetDlgItem(IDC_STATIC1)->SetWindowText(m_strPreview);
	return 0;
}

//ȡѡ
int CSelectFontDlg::GetCurrentSelectFont(LOGFONT &lfont)
{
	memset(&lfont, 0, sizeof(lfont));
	int iSelFont = m_lsFontsBox.GetCurSel();
	if (-1 == iSelFont)
	{
		iSelFont = 0;
		m_lsFontsBox.SetCurSel(0);
	}
	int iCount = 0;
	//ѡ
	for (FONTLIST::iterator iIter = m_lsFonts.begin(); iIter != m_lsFonts.end(); iIter++, iCount++)
	{
		if (iCount == iSelFont)
		{
			memcpy(&lfont, &(*iIter), sizeof(lfont));
			break;
		}
	}
	//ѡС,ҪÿλС
	iSelFont = m_lsFontSizeBox.GetCurSel();//MIN_FONT_SIZE + m_lsFontSizeBox.GetCurSel() + lfont.lfClipPrecision * m_lsFontSizeBox.GetCurSel();
	if (-1 == iSelFont)
	{
		iSelFont = 0;
		m_lsFontSizeBox.SetCurSel(0);
	}
	lfont.lfHeight = iSelFont;
	lfont.lfWidth = 0;//iSelFont;
	return 0;
}

//ȡѡ
int CSelectFontDlg::GetSelectFont(LOGFONT &lfont)
{
	memcpy(&lfont, &m_curFont, sizeof(lfont));
	//IndexתΪʵֵ
	lfont.lfHeight = lfont.lfHeight + MIN_FONT_SIZE;
	return 0;
}

//ѡ
int CSelectFontDlg::SetSelectFont(LOGFONT &lfont)
{
	memcpy(&m_curFont, &lfont, sizeof(m_curFont));
	//ʵֵתΪIndex
	m_curFont.lfHeight = m_curFont.lfHeight - MIN_FONT_SIZE;
	return 0;
}

//öϵͳ
int CSelectFontDlg::EnumSystemFont(HDC dc)
{
	LOGFONT lsFont;
	memset(&lsFont, 0, sizeof(lsFont));
	lsFont.lfCharSet = DEFAULT_CHARSET;
	lsFont.lfPitchAndFamily = 0;
	return ::EnumFontFamiliesEx(dc, &lsFont, (FONTENUMPROC)EnumFontProc, (LPARAM)this, 0);
}

//ˢϵͳ嵽Ի
int CSelectFontDlg::RefreshFont()
{
	//Ϣ
	m_lsFontsBox.ResetContent();
	//ӵ
	for (FONTLIST::iterator iIter = m_lsFonts.begin(); iIter != m_lsFonts.end(); iIter++)
	{
		m_lsFontsBox.AddString((*iIter).lfFaceName);
	}
	return 0;
}

bool CSelectFontDlg::ValidData()
{
	GetCurrentSelectFont(m_curFont);
	return true;
}

//öϵͳص
int CALLBACK CSelectFontDlg::EnumFontProc(const ENUMLOGFONTEX *lpelfe, const NEWTEXTMETRICEX *lpntme, DWORD FontType, LPARAM lParam)
{
	CSelectFontDlg *pDlg = (CSelectFontDlg*)(lParam);
	if (NULL != pDlg)
	{
		//BYTEתCHAR
		CString strName1;
		CString strName2;
		CString strDbg;
		strName1.Format(_T("%s"), lpelfe->elfLogFont.lfFaceName);
		//ǷѴ
		for (FONTLIST::iterator iIter = pDlg->m_lsFonts.begin(); iIter != pDlg->m_lsFonts.end(); iIter++)
		{
			strName2.Format(_T("%s"), (*iIter).lfFaceName);
			//if ((0 == strcmp((char*)lpelfe->elfLogFont.lfFaceName, (char*)(*iIter).lfFaceName)))
			if (strName1 == strName2)
			{
				return 1;
			}
		}
		pDlg->m_lsFonts.push_back(lpelfe->elfLogFont);
		//pDlg->m_lsFonts.push_back(lpelfe->elfLogFont);
	}
	return 1;
}
