// UserEventDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/UserEventDlg.h"


// CUserEventDlg Ի

IMPLEMENT_DYNAMIC(CUserEventDlg, CDialog)

CUserEventDlg::CUserEventDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserEventDlg::IDD, pParent)
{

}

CUserEventDlg::~CUserEventDlg()
{
}

void CUserEventDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_EVENT, m_LSUserEvent);
}


BEGIN_MESSAGE_MAP(CUserEventDlg, CDialog)
//	ON_NOTIFY(NM_RDBLCLK, IDC_LIST_EVENT, &CUserEventDlg::OnNMRDblclkListEvent)
	ON_BN_CLICKED(IDOK, &CUserEventDlg::OnBnClickedOk)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_EVENT, &CUserEventDlg::OnNMDblclkListEvent)
END_MESSAGE_MAP()


// CUserEventDlg Ϣ

BOOL CUserEventDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	ListView_SetExtendedListViewStyle(m_LSUserEvent.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSUserEvent.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSUserEvent.InsertColumn(0, "Event", LVCFMT_LEFT, 195);//ʼб
	m_LSUserEvent.InsertColumn(1, "Status", LVCFMT_LEFT, 120);

	CString str;
	int iListCount = 0;
	CString cEvent[] = {"Alarm", "Heart"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cEvent); count++)
	{
		iListCount = m_LSUserEvent.InsertItem(0xFFFF, "");
		m_LSUserEvent.SetItem(iListCount, 0, 1 , cEvent[count], NULL, 0, 0, 0);
		m_LSUserEvent.SetItemData(count, ((m_cEventInfo.m_EventSubscribe[count]) ? 1 : 0));
	}
	RefreshList();
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

int CUserEventDlg::RefreshList()
{
	CString cStatus[] = {"None", "Event"};
	for (int count = 0; count < m_LSUserEvent.GetItemCount(); count++)
	{
		DWORD dwValue = m_LSUserEvent.GetItemData(count);
		m_LSUserEvent.SetItem(count, 1, 1 , cStatus[((0 != dwValue) ? 1 : 0)], NULL, 0, 0, 0);
	}
	return 0;
}
void CUserEventDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	OnOK();
}

void CUserEventDlg::OnNMDblclkListEvent(NMHDR *pNMHDR, LRESULT *pResult)
{
	int count = m_LSUserEvent.GetSelectionMark();
	if (-1 == count)
	{
		return;
	}
	DWORD dwValue = m_LSUserEvent.GetItemData(count);
	dwValue = ((0 == dwValue) ? 1 : 0);
	m_LSUserEvent.SetItemData(count, dwValue);
	m_cEventInfo.m_EventSubscribe[count] = (0 == dwValue ? false : true);
	RefreshList();
	// TODO: ڴӿؼ֪ͨ
	*pResult = 0;
}
