#-------------------------------------------------
#
# Project created by QtCreator 2019-11-08T16:23:29
#
#-------------------------------------------------

QT       += core gui xml network concurrent

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = AIFaceDemo
TEMPLATE = app

# The following define makes your compiler emit warnings if you use
# any feature of Qt which has been marked as deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if you use deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

DEFINES += SYSTEM_WIN32
DEFINES += _CRT_SECURE_NO_WARNINGS

QMAKE_CXXFLAGS_WARN_ON += -wd4819

CONFIG(debug,debug|release)
{
    MOC_DIR = bin/debug/moc
    RCC_DIR = bin/debug/rcc
    UI_DIR = bin/debug/ui
    OBJECTS_DIR = bin/debug/obj
    DESTDIR = bin/debug
}
CONFIG(release,debug|release)
{
    MOC_DIR = bin/release/moc
    RCC_DIR = bin/release/rcc
    UI_DIR = bin/release/ui
    OBJECTS_DIR = bin/release/obj
    DESTDIR = bin/release
}

SOURCES += \
    src/src/gui/facedetect/dxregion.cpp \
    src/src/gui/facelibrary/facelibraryitemshowwidget.cpp \
    src/src/gui/facelibrary/facelibraryitemwidget.cpp \
    src/src/gui/facelibrary/namewidget.cpp \
    src/src/gui/facelibrary/personitemaddwidget.cpp \
    src/src/gui/facelibrary/personitemeditwidget.cpp \
    src/src/gui/facerecognition/facerecognizewidget.cpp \
    src/src/gui/facerecognition/recordplanwidget.cpp \
    src/src/gui/recognizerecord/recognizerecordwidget.cpp \
    src/src/gui/recognizerecord/recorddetail.cpp \
    src/src/gui/snapshot/snapshotitemwidget.cpp \
    src/src/gui/snapshot/snapshotwidget.cpp \
    src/src/gui/status/statuswidget.cpp \
    src/src/httpmanager/aifacepackage.cpp \
    src/src/gui/facedetect/aifaceconfigwidget.cpp \
    src/src/gui/facedetect/aifaceregion.cpp \
    src/src/gui/facedetect/aifaceregionitem.cpp \
    src/src/gui/facedetect/snapconfigwidget.cpp \
    src/src/gui/facelibrary/facelibrary.cpp \
    src/src/httpmanager/facelibrarypackage.cpp \
    src/src/httpmanager/facerecognizepackage.cpp \
    src/src/httpmanager/httpmanagerpch.cpp \
    src/src/httpmanager/recognizerecordpackage.cpp \
        src/src/main.cpp \
    src/src/package/videopackage.cpp \
    src/src/restclient/restclient.cpp \
    src/src/restclient/xmlreader.cpp \
    src/src/restclient/xmlwritter.cpp \
    src/src/gui/widget.cpp \
    src/src/aifacepch.cpp \
    src/src/devicemanager/deviceanalysiser.cpp \
    src/src/devicemanager/devicemanager.cpp \
    src/src/usermanager/userinfo.cpp

HEADERS += \
    src/inc/gui/facelibrary/facelibraryitemwidget.h \
    src/inc/gui/facelibrary/namewidget.h \
    src/inc/gui/facelibrary/personitemeditwidget.h \
    src/inc/gui/facerecognition/facerecognizewidget.h \
    src/inc/gui/facerecognition/recordplanwidget.h \
    src/inc/gui/recognizerecord/recognizerecordwidget.h \
    src/inc/gui/recognizerecord/recorddetail.h \
    src/inc/gui/snapshot/snapshotwidget.h \
    src/inc/httpmanager/aifacepackage.h \
    src/inc/gui/facedetect/aifaceconfigwidget.h \
    src/inc/gui/facedetect/aifaceregion.h \
    src/inc/gui/facedetect/aifaceregionitem.h \
    src/inc/gui/facedetect/snapconfigwidget.h \
    src/inc/gui/facelibrary/facelibrary.h \
    src/inc/httpmanager/facelibrarypackage.h \
    src/inc/httpmanager/facerecognizepackage.h \
    src/inc/httpmanager/httpmanagerpch.h \
    src/inc/httpmanager/recognizerecordpackage.h \
    src/inc/package/videopackage.h \
    src/inc/restclient/restclient.h \
    src/inc/restclient/restobject.h \
    src/inc/restclient/xmlreader.h \
    src/inc/restclient/xmlwritter.h \
    src/inc/gui/widget.h \
    lib/sdk/VideoNetClient/include/VideoNetClient.h \
    lib/sdk/VideoNetClient/include/VideoNetClient_Common.h \
    lib/sdk/VideoNetClient/include/VideoNetClient_Configure.h \
    src/inc/aifacepch.h \
    src/inc/package/videonetcallback.h \
    src/inc/devicemanager/deviceanalysiser.h \
    src/inc/devicemanager/devicemanager.h \
    src/inc/aifaceobject.h \
    lib/sdk/VideoPlay/include/VideoPlay.h \
    src/inc/usermanager/userinfo.h \
    src/inc/gui/facelibrary/personitemaddwidget.h \
    src/inc/gui/facedetect/dxregion.h \
    src/inc/gui/snapshot/snapshotitemwidget.h \
    src/inc/gui/facelibrary/facelibraryitemshowwidget.h \
    src/inc/gui/status/statuswidget.h

DISTFILES += \
    ReadMe
