﻿#ifndef ADDWIDGET_H
#define ADDWIDGET_H

#include <QDialog>

class NameWidget : public QDialog
{
	Q_OBJECT
public:
	explicit NameWidget(QWidget *parent = nullptr);

	/**
	 * @brief addExistFaceLibraryName		添加已经存在的脸库名称
	 * @param name									[in]脸库名称
	 */
	void addExistFaceLibraryName(const QString &name);

private:
	/**
	 * @brief initGui	初始化GUI
	 */
	void initGui();

private:
	QVector<QString> m_allFaceLibraryNames;

signals:
	void signal_name(QString);

public slots:
};

#endif // ADDWIDGET_H
