﻿#ifndef HTTPMANAGERPCH_H
#define HTTPMANAGERPCH_H

#include <QByteArray>

using HttpManagerErcode = enum HttpManagerErcode
{
	HttpErcode_None,

	HttpErcode_AuthFailed,

	HttpErcode_Less1Failed,
	HttpErcode_Less2Failed,
	HttpErcode_Less3Failed,
	HttpErcode_Less4Failed,
	HttpErcode_Less5Failed,
	HttpErcode_Less6Failed,
	HttpErcode_Less7Failed,
	HttpErcode_Less8Failed,
	HttpErcode_Less9Failed,
	HttpErcode_Less10Failed,
	HttpErcode_Less11Failed,
	HttpErcode_Less12Failed,
	HttpErcode_Less13Failed,
	HttpErcode_ImageFormatError,
	HttpErcode_FaceNotFound,
	HttpErcode_MultiFaceInImage,
	HttpErcode_FacePropertyIllegal,
	HttpErcode_FaceRecognizeAlgorithmNotInit,
	HttpErcode_CreateFaceGroupFailed,
	HttpErcode_AlgorithmFeatureNotSuit,
	HttpErcode_FaceGroupNotExist,
	HttpErcode_FaceGroupNumArriveUplimitByKS,
	HttpErcode_FaceTooBig,
	HttpErcode_FaceTooDim,
	HttpErcode_FaceAngleWrong,
	HttpErcode_FaceTooSmall,
	HttpErcode_FaceDetectFailed,
	HttpErcode_FaceImageAlreadyExist,
	HttpErcode_FaceGroupNameAlreadyExist,
	HttpErcode_PeopleNameAlreadyExist,
	HttpErcode_FaceGroupNumArriveUplimit,
	HttpErcode_PeopleNumArriveUplimit,

	HttpErcode_CannotAnalysisResponse,
	HttpErcode_OtherFailed,
};

#define check_status_code(x)	\
if(401 == statusCode)		\
	return HttpErcode_AuthFailed;	\
if(200 != statusCode && 0!= statusCode)	\
	return HttpErcode_OtherFailed;	\

HttpManagerErcode analysisResponseStatusCode(const QByteArray &response);

//#define check_response_code(x)	\
//if(-1 == x)	\
//	return HttpErcode_Less1Failed;	\
//else if(-2 == x)	\
//	return HttpErcode_Less2Failed;	\
//else if(-3 == x)	\
//	return HttpErcode_Less3Failed;	\
//else if(-4 == x)	\
//	return HttpErcode_Less4Failed;	\
//else if(-5 == x)	\
//	return HttpErcode_Less5Failed;	\
//else if(-6 == x)	\
//	return HttpErcode_Less6Failed;	\
//else if(-7 == x)	\
//	return HttpErcode_Less7Failed;	\
//else if(-8 == x)	\
//	return HttpErcode_Less8Failed;	\
//else if(-9 == x)	\
//	return HttpErcode_Less9Failed;	\
//else if(-10 == x)	\
//	return HttpErcode_Less10Failed;	\
//else if(-11 == x)	\
//	return HttpErcode_Less11Failed;	\
//else if(-12 == x)	\
//	return HttpErcode_Less12Failed;	\
//else if(-13 == x)	\
//	return HttpErcode_Less13Failed;	\
//else if(0x1001 == x)	\
//	return HttpErcode_ImageFormatError;	\
//else if(0x1002 == x)	\
//	return HttpErcode_FaceNotFound;	\
//else if(0x1003 == x)	\
//	return HttpErcode_MultiFaceInImage;	\
//else if(0x1004 == x)	\
//	return HttpErcode_FacePropertyIllegal;	\
//else if(0x1005 == x)	\
//	return HttpErcode_FaceRecognizeAlgorithmNotInit;	\
//else if(0x1006 == x)	\
//	return HttpErcode_CreateFaceGroupFailed;	\
//else if(0x1007 == x)	\
//	return HttpErcode_AlgorithmFeatureNotSuit;	\
//else if(0x1008 == x)	\
//	return HttpErcode_FaceGroupNotExist;	\
//else if(0x1009 == x)	\
//	return HttpErcode_FaceGroupNumArriveUplimitByKS;	\
//else if(0x100a == x)	\
//	return HttpErcode_FaceTooBig;	\
//if(0x100b == x)	\
//	return HttpErcode_FaceTooDim;	\
//else if(0x100c == x)	\
//	return HttpErcode_FaceAngleWrong;	\
//else if(0x100d == x)	\
//	return HttpErcode_FaceTooSmall;	\
//else if(0x100e == x)	\
//	return HttpErcode_FaceNotFound;	\
//else if(0x100f == x)	\
//	return HttpErcode_FaceImageAlreadyExist;	\
//else if(0x1064 == x)	\
//	return HttpErcode_FaceGroupNameAlreadyExist;	\
//else if(0x1065 == x)	\
//	return HttpErcode_PeopleNameAlreadyExist;	\
//else if(0x1066 == x)	\
//	return HttpErcode_FaceGroupNumArriveUplimit;	\
//else if(0x1067 == x)	\
//	return HttpErcode_PeopleNumArriveUplimit;

constexpr int httpWaitTime{10000};

#endif // HTTPMANAGERPCH_H
