
// DeviceRegisterCenterDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "DeviceRegisterCenter.h"
#include "DeviceRegisterCenterDlg.h"

#include <Shlwapi.h>
#pragma comment(lib,"shlwapi.lib")

#include <string>
#include <sstream>
#include <fstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define CONFIG_FILE		"config.ini"

#define TIMER_UPDATE_DEVICES				(WM_USER + 1000)
#define INTERVAL_UPDATE_DEVICES				(1 * 1000)

#define TIMER_UPDATE_LOG_MESSAGE			(WM_USER + 1001)
#define INTERVAL_UPDATE_LOG_MESSAGE			(1 * 300)
// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDeviceRegisterCenterDlg Ի




CDeviceRegisterCenterDlg::CDeviceRegisterCenterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceRegisterCenterDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hGuardDevice = INVALID_HANDLE_VALUE;
}

void CDeviceRegisterCenterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEVICE_LIST, m_LSDevices);
	DDX_Control(pDX, IDC_LIST1, m_LSMessage);
}

BEGIN_MESSAGE_MAP(CDeviceRegisterCenterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_SERVICE_START, &CDeviceRegisterCenterDlg::OnMenuServiceStart)
	ON_COMMAND(ID_SERVICE_STOP, &CDeviceRegisterCenterDlg::OnMenuServiceStop)
	ON_COMMAND(ID_SERVICE_EXIT, &CDeviceRegisterCenterDlg::OnMenuServiceExit)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_COMMAND(ID_CONFIG_DEVICECAP, &CDeviceRegisterCenterDlg::OnConfigCaptcity)
	ON_COMMAND(ID_CONFIG_SYSTEMTIME, &CDeviceRegisterCenterDlg::OnConfigSystemtime)
	ON_COMMAND(ID_CONTROL_REMOTEOPEN, &CDeviceRegisterCenterDlg::OnControlRemoteopen)
	ON_COMMAND(ID_FACE_ADDFACE, &CDeviceRegisterCenterDlg::OnFaceAddface)
END_MESSAGE_MAP()


// CDeviceRegisterCenterDlg Ϣ

BOOL CDeviceRegisterCenterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ

	ListView_SetExtendedListViewStyle(m_LSDevices.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSDevices.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSDevices.InsertColumn(0, "id", LVCFMT_LEFT, 36);//ʼб
	m_LSDevices.InsertColumn(1, "address", LVCFMT_LEFT, 100);
	m_LSDevices.InsertColumn(2, "mac", LVCFMT_LEFT, 120);

	m_lUpdateListCount = 0;
	m_lUpdateListBack = 0;
	m_hGuardDevice = ::CreateMutex(NULL, FALSE, NULL);
	m_hGuardMessage = ::CreateMutex(NULL, FALSE, NULL);

	if (0 != VideoNetClient_Start())
	{
		AfxMessageBox("SDK Start failed.");
	}

	VideoNetClient_SetAttribute(eAttributeCommandTimeOut, 30 * 1000);

	OnMenuServiceStart();

	SetTimer(TIMER_UPDATE_DEVICES, INTERVAL_UPDATE_DEVICES, NULL);
	SetTimer(TIMER_UPDATE_LOG_MESSAGE, INTERVAL_UPDATE_LOG_MESSAGE, NULL);
	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CDeviceRegisterCenterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CDeviceRegisterCenterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CDeviceRegisterCenterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CDeviceRegisterCenterDlg::Log(const char *message)
{
	SYSTEMTIME systime;
	GetLocalTime(&systime);
	CString strText;
	strText.Format("[%02d:%02d:%02d.%03d] %s", systime.wHour, systime.wMinute, systime.wSecond, systime.wMilliseconds, message);
	::WaitForSingleObject(m_hGuardMessage, INFINITE);
	m_lsMessage.push_back(strText.GetBuffer());
	::ReleaseMutex(m_hGuardMessage);
}

static int CALLBACK CBDeviceRegisterV1(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister, void *user)
{
	if (NULL == user)
	{
		return 1;
	}
	CDeviceRegisterCenterDlg *cObject = (CDeviceRegisterCenterDlg*)user;
	return cObject->DeviceRegisterV1(hUser, pDeviceRegister);
}

static int CALLBACK CBDeviceHeartbeat(IN HUSER hUser, IN PDevicePerformanceStatus pSystemStatus, IN void *user)
{
	if (NULL == user)
	{
		return 1;
	}
	CDeviceRegisterCenterDlg *cObject = (CDeviceRegisterCenterDlg*)user;
	return cObject->DeviceHeartbeat(hUser, pSystemStatus);
}

static int CALLBACK CBDeviceHeartbeatLost(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister, IN void *user)
{
	if (NULL == user)
	{
		return 1;
	}
	CDeviceRegisterCenterDlg *cObject = (CDeviceRegisterCenterDlg*)user;
	return cObject->DeviceHeartbeatLost(hUser, pDeviceRegister);
}

static int CALLBACK CBDeviceEventEx(IN HUSER hUser, IN DWORD dwEventType, IN DWORD dwSubEventType, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, IN const LPBuffer cBuffer, IN void *user)
{
	if (NULL == user)
	{
		return 1;
	}
	CDeviceRegisterCenterDlg *cObject = (CDeviceRegisterCenterDlg*)user;
	return cObject->DeviceEventEx(hUser, dwEventType, dwSubEventType, dwParam1, dwParam2, dwParam3, cBuffer, user);
}

int CDeviceRegisterCenterDlg::DeviceRegisterV1(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister)
{
	CString strText;
	strText.Format("Online device:%d mac:%02x:%02x:%02x:%02x:%02x:%02x ip:%s", hUser, pDeviceRegister->m_bytDevMac[0], pDeviceRegister->m_bytDevMac[1], pDeviceRegister->m_bytDevMac[2],
		pDeviceRegister->m_bytDevMac[3], pDeviceRegister->m_bytDevMac[4], pDeviceRegister->m_bytDevMac[5], pDeviceRegister->m_bytDevIP);
	Log(strText);
	::WaitForSingleObject(m_hGuardDevice, INFINITE);
	for (std::map<int, DeviceRegisterInfoV1>::iterator iter = m_lsDevice.begin(); iter != m_lsDevice.end(); iter++)
	{
		if (0 == memcmp(iter->second.m_bytDevMac, pDeviceRegister->m_bytDevMac, MAC_BINARY_ADDRESS_LEN))
		{
			::ReleaseMutex(m_hGuardDevice);
			return 0;
		}
	}
	m_lsDevice.insert(std::make_pair((int)hUser, *pDeviceRegister));
	m_lUpdateListCount++;
	::ReleaseMutex(m_hGuardDevice);
	return 0;
}

int CDeviceRegisterCenterDlg::DeviceHeartbeat(IN HUSER hUser, IN PDevicePerformanceStatus pSystemStatus)
{
	CString strText;
	strText.Format("Heartbeat device:%d cpu:%0.2f memory:%0.2f storage:%0.2f uptime:%d opendoor:%d", hUser, pSystemStatus->m_CPUPercent, pSystemStatus->m_MemoryPercent, pSystemStatus->m_StoragePercent, pSystemStatus->m_Uptime, pSystemStatus->m_OpenDoorCount);
	Log(strText);
	return 0;
}

int CDeviceRegisterCenterDlg::DeviceHeartbeatLost(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister)
{
	CString strText;
	strText.Format("Offline device:%d mac:%02x:%02x:%02x:%02x:%02x:%02x ip:%s", hUser, pDeviceRegister->m_bytDevMac[0], pDeviceRegister->m_bytDevMac[1], pDeviceRegister->m_bytDevMac[2],
		pDeviceRegister->m_bytDevMac[3], pDeviceRegister->m_bytDevMac[4], pDeviceRegister->m_bytDevMac[5], pDeviceRegister->m_bytDevIP);
	Log(strText);
	::WaitForSingleObject(m_hGuardDevice, INFINITE);
	for (std::map<int, DeviceRegisterInfoV1>::iterator iter = m_lsDevice.begin(); iter != m_lsDevice.end(); iter++)
	{
		if (0 == memcmp(iter->second.m_bytDevMac, pDeviceRegister->m_bytDevMac, MAC_BINARY_ADDRESS_LEN))
		{
			iter = m_lsDevice.erase(iter);
			break;
		}
	}
	m_lUpdateListCount++;
	::ReleaseMutex(m_hGuardDevice);
	return 0;
}

int CDeviceRegisterCenterDlg::DeviceEventEx(IN HUSER hUser, IN DWORD dwEventType, IN DWORD dwSubEventType, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, IN const LPBuffer cBuffer, IN void *user)
{
	if (USEREVENT_AI_EVENT_PUSH == dwEventType)
	{
		if (EVENT_AI_FACE_DETECT == dwSubEventType || EVENT_AI_FACE_RECOGNITION == dwSubEventType)
		{
			if (NULL != cBuffer)
			{
				EventFaceRecognition *cEventFace = (EventFaceRecognition*)cBuffer->pBuffer;
				FILE *fp = fopen("face.jpg", "wb+");
				if (NULL != fp)
				{
					fwrite(cBuffer->pBuffer + sizeof(EventFaceRecognition), 1, cBuffer->dwBufLen - sizeof(EventFaceRecognition), fp);
					fclose(fp);
					fp = NULL;
				}
			}
		}
	}
	CString strText;
	DWORD dwBufferLength = 0;
	if (NULL != cBuffer && NULL != cBuffer->pBuffer)
	{
		dwBufferLength = cBuffer->dwBufLen;
	}
	char *title = "";
	if (USEREVENT_AI_EVENT_PUSH == dwEventType)
	{
		if (EVENT_AI_FACE_DETECT == dwSubEventType)
		{
			title = "face detect";
		}
		if (EVENT_AI_FACE_RECOGNITION == dwSubEventType)
		{
			title = "face recognition";
		}
	}
	if (strlen(title) > 0)
	{
		strText.Format("Event device:%d main:%d sub:%d p1:%d p2:%d p3:%d buffer:%d %s", hUser, dwEventType, dwSubEventType, dwParam1, dwParam2, dwParam3, dwBufferLength, title);
	}else{
		strText.Format("Event device:%d main:%d sub:%d p1:%d p2:%d p3:%d buffer:%d", hUser, dwEventType, dwSubEventType, dwParam1, dwParam2, dwParam3, dwBufferLength);
	}
	Log(strText);
	return 0;
}

void CDeviceRegisterCenterDlg::OnMenuServiceStart()
{
	// TODO: ڴ

	char m_strModule[MAX_PATH];
	GetModuleFileName( NULL, m_strModule, _MAX_PATH);
	PathRemoveFileSpec( m_strModule );
	char cModule[MAX_PATH];
	sprintf_s(cModule, MAX_PATH, "%s\\%s", m_strModule, CONFIG_FILE);
	char cAddress[64] = {0};
	GetPrivateProfileString("Center", "Address", NULL, cAddress, sizeof(cAddress), cModule);
	char cValue[64] = {0};
	GetPrivateProfileString("Center", "Port", "6788", cValue, sizeof(cValue), cModule);
	DWORD dwPort = 0;
	if (0 < strlen(cValue))
	{
		dwPort = atoi(cValue);
	}

	int iReturn = VideoNetClient_DeviceRegisterListenStart(cAddress, dwPort);
	if (0 != iReturn)
	{
		if (1 == iReturn)
		{
			AfxMessageBox("DeviceRegisterListenStart failed, Please do not repeat the call.");
		}else{
			AfxMessageBox("DeviceRegisterListenStart failed.");
		}
		return;
	}

	if (0 != VideoNetClient_DeviceRegisterCBV1(CBDeviceRegisterV1, this))
	{
		AfxMessageBox("VideoNetClient_DeviceRegisterCBV1 failed.");
		return;
	}

	if (0 != VideoNetClient_DeviceHeartbeatCB(CBDeviceHeartbeat, CBDeviceHeartbeatLost, this))
	{
		AfxMessageBox("VideoNetClient_DeviceHeartbeatCB failed.");
		return;
	}

	if (0 != VideoNetClient_DeviceEventCB(CBDeviceEventEx, this))
	{
		AfxMessageBox("VideoNetClient_DeviceEventCB failed.");
		return;
	}
}

void CDeviceRegisterCenterDlg::OnMenuServiceStop()
{
	// TODO: ڴ
	CDialog::OnCancel();
}

void CDeviceRegisterCenterDlg::OnMenuServiceExit()
{
	// TODO: ڴ
	CDialog::OnCancel();
}

void CDeviceRegisterCenterDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ڴ˴Ϣ
	VideoNetClient_DeviceRegisterListenStop();
	VideoNetClient_Stop();

	CloseHandle(m_hGuardMessage);
	CloseHandle(m_hGuardDevice);
}

void CDeviceRegisterCenterDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ڴϢ/Ĭֵ
	if (TIMER_UPDATE_DEVICES == nIDEvent)
	{
		if (m_lUpdateListBack != m_lUpdateListCount)
		{
			m_lUpdateListBack = m_lUpdateListCount;
			std::map<int, DeviceRegisterInfoV1> lsDevice;
			::WaitForSingleObject(m_hGuardDevice, INFINITE);
			lsDevice = m_lsDevice;
			::ReleaseMutex(m_hGuardDevice);
			m_LSDevices.DeleteAllItems();
			CString strTemp;
			for (std::map<int, DeviceRegisterInfoV1>::iterator iter = lsDevice.begin(); iter != lsDevice.end(); iter++)
			{
				int iIndex = m_LSDevices.InsertItem(0xFFFF, "");
				strTemp.Format("%d", iter->first);
				m_LSDevices.SetItemText(iIndex, 0, strTemp);
				strTemp.Format("%s", iter->second.m_bytDevIP);
				m_LSDevices.SetItemText(iIndex, 1, strTemp);
				strTemp.Format("%02x:%02x:%02x:%02x:%02x:%02x", iter->second.m_bytDevMac[0], iter->second.m_bytDevMac[1], iter->second.m_bytDevMac[2],
					iter->second.m_bytDevMac[3], iter->second.m_bytDevMac[4], iter->second.m_bytDevMac[5]);
				m_LSDevices.SetItemText(iIndex, 2, strTemp);
				m_LSDevices.SetItemData(iIndex, iter->first);
				if (0 > m_LSDevices.GetSelectionMark())
				{
					m_LSDevices.SetSelectionMark(0);
				}
			}
		}
	}else if (TIMER_UPDATE_LOG_MESSAGE == nIDEvent)
	{
		if (m_lsMessage.size() > 0)
		{
			::WaitForSingleObject(m_hGuardMessage, INFINITE);
			for (std::list<std::string>::iterator iter = m_lsMessage.begin(); iter != m_lsMessage.end(); iter++)
			{
				m_LSMessage.AddString(iter->c_str());
			}
			m_lsMessage.clear();
			::ReleaseMutex(m_hGuardMessage);
			m_LSMessage.SetTopIndex(m_LSMessage.GetCount() - 1);
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void CDeviceRegisterCenterDlg::OnConfigCaptcity()
{
	// TODO: ڴ
	char *cRequest = "GET /System/DeviceCap HTTP/1.1\r\n\
Accept: application/xml, text/xml, */*; q=0.01\r\n\
If-Modified-Since: 0\r\n\
Referer: http://192.168.3.22/\r\n\
Accept-Language: zh-Hans-CN,zh-Hans;q=0.5\r\n\
Accept-Encoding: gzip, deflate\r\n\
User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko\r\n\
Host: 192.168.3.22\r\n\
Connection: Keep-Alive\r\n\
Cookie: isSupportFaceReco=TRUE; IsFaceSnapshot=false; IsFaceReco=true; userInfo=null; strem=null; commandPort=null; rtspPort=null; plugType=WebVideoPlayer\r\n\
Authorization: Basic YWRtaW46MA==\r\n\
\r\n";
	int iIndex = m_LSDevices.GetSelectionMark();
	if (0 > iIndex)
	{
		AfxMessageBox("please select device.");
		return;
	}
	iIndex = m_LSDevices.GetItemData(iIndex);
	char *cResponse = NULL;
	int iResponseLength = 0;
	int iResult = VideoNetClient_DeviceRegisterTransparentData((HUSER)iIndex, cRequest, strlen(cRequest) + 1, &cResponse, &iResponseLength);
	if (0 != iResult)
	{
		AfxMessageBox("OnConfigCaptcity DeviceRegisterTransparentData failed.");
		return;
	}
	if (NULL != cResponse)
	{
		AfxMessageBox(cResponse);
	}
	if (NULL != cResponse)
	{
		VideoNetClient_ReleaseData(cResponse);
		cResponse = NULL;
	}
}

void CDeviceRegisterCenterDlg::OnConfigSystemtime()
{
	// TODO: ڴ
	char *cRequest = "GET /System/Time HTTP/1.1\r\n\
Accept: */*\r\n\
If-Modified-Since: 0\r\n\
X-Requested-With: XMLHttpRequest\r\n\
Referer: http://192.168.3.22/common.html\r\n\
Accept-Language: zh-Hans-CN,zh-Hans;q=0.5\r\n\
Accept-Encoding: gzip, deflate\r\n\
User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko\r\n\
Host: 192.168.3.22\r\n\
Connection: Keep-Alive\r\n\
Cookie: isSupportFaceReco=TRUE; IsFaceSnapshot=false; IsFaceReco=true; userInfo=YWRtaW46MA%3D%3D; strem=1; commandPort=6060; rtspPort=554; plugType=WebVideoPlayer\r\n\
Authorization: Basic YWRtaW46MA==\r\n\
\r\n";
	int iIndex = m_LSDevices.GetSelectionMark();
	if (0 > iIndex)
	{
		AfxMessageBox("please select device.");
		return;
	}
	iIndex = m_LSDevices.GetItemData(iIndex);
	char *cResponse = NULL;
	int iResponseLength = 0;
	int iResult = VideoNetClient_DeviceRegisterTransparentData((HUSER)iIndex, cRequest, strlen(cRequest) + 1, &cResponse, &iResponseLength);
	if (0 != iResult)
	{
		AfxMessageBox("OnConfigCaptcity DeviceRegisterTransparentData failed.");
		return;
	}
	if (NULL != cResponse)
	{
		AfxMessageBox(cResponse);
	}
	if (NULL != cResponse)
	{
		VideoNetClient_ReleaseData(cResponse);
		cResponse = NULL;
	}
}

void CDeviceRegisterCenterDlg::OnFaceAddface()
{
	//HTTP
	std::string request; 

	//
	std::string requestLine = "POST /FaceGroup/AddPersonInfoAndFaceImage HTTP/1.1\r\n";

	//ͷ
	std::string requestHeader = "Accept: */*\r\n\
If-Modified-Since: 0\r\n\
X-Requested-With: XMLHttpRequest\r\n\
Referer: http://192.168.3.22/common.html\r\n\
Accept-Language: zh-Hans-CN,zh-Hans;q=0.5\r\n\
Accept-Encoding: gzip, deflate\r\n\
User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko\r\n\
Host: 192.168.3.22\r\n\
Connection: Keep-Alive\r\n\
Cookie: isSupportFaceReco=TRUE; IsFaceSnapshot=false; IsFaceReco=true; userInfo=YWRtaW46MA%3D%3D; strem=1; commandPort=6060; rtspPort=554; plugType=WebVideoPlayer\r\n\
Authorization: Basic YWRtaW46MA==\r\n\
Content-Type: multipart/form-data; boundary=---------------------------7e3d513720998\r\n";

	const std::string boundary = "---------------------------7e3d513720998";
	const std::string newLine = "\r\n";

	//
	std::string requestBody;
	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="IgnoreError"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"IgnoreError\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	false
	*/
	requestBody += "false";
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="Name"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"Name\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	name
	*/
	requestBody += "zhangsan";		//עĵĻתΪUTF-8
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="Sex"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"Sex\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	male
	*/
	requestBody += "male";
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="CertificateType"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"CertificateType\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	IC
	*/
	requestBody += "IC";
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="CertificateID"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"CertificateID\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	120000000000000000
	*/
	requestBody += "120000000000000000";
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="GroupID"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"GroupID\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	0
	*/
	requestBody += "3";
	requestBody += newLine;

	/*
	-----------------------------7e33321a613aa
	Content-Disposition: form-data; name="Country"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"Country\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	й
	*/
	requestBody += "ZhongGuo";				//עĵĻתΪUTF-8
	requestBody += newLine;
	
	/*
	-----------------------------7e3fa103093e
	Content-Disposition: form-data; name="Address"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"Address\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	ʡ#人
	*/
	requestBody += "HuBei#Wuhan";
	requestBody += newLine;

	/*
	-----------------------------7e3fa103093e
	Content-Disposition: form-data; name="Birthday"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"Birthday\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	20191112
	*/
	requestBody += "20191112";
	requestBody += newLine;

	/*
	-----------------------------7e3fa103093e
	Content-Disposition: form-data; name="FaceImageID"
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"FaceImageID\"";
	requestBody += newLine;
	requestBody += newLine;

	/*
	1
	 */
	requestBody += "1";
	requestBody += newLine;

	/*
	 -----------------------------7e3b493093e
	Content-Disposition: form-data; name="file"; filename="temp.jpeg"
	Content-Type: image/jpeg
	*/
	requestBody += boundary;
	requestBody += newLine;
	requestBody += "Content-Disposition: form-data; name=\"file\"; filename=\"temp.jpeg\"";
	requestBody += newLine;
	requestBody += "Content-Type: image/jpeg";
	requestBody += newLine;
	requestBody += newLine;

	//Image Data
	std::ifstream image;
	image.open("./temp.jpg",std::ios::in|std::ios::binary);
	if (!image.is_open())
	{
		AfxMessageBox("OnFaceAddFace the face image temp.jpg open failed.");
		return;
	}
	image.seekg(0,image.end);
	size_t length = image.tellg();
	image.seekg(0,image.beg);
	char *buffer = new char[length];
	image.read(buffer,length);
	requestBody += std::string(buffer,length);
	delete[] buffer;

	/*
	-----------------------------7e3d513720998--

	*/
	requestBody += newLine;
	requestBody += boundary;
	requestBody += "--";
	requestBody += newLine;

	//ͷӳϢ
	std::string bodyLength;
	std::stringstream trans;
	trans << requestBody.size();
	trans >> bodyLength;
	requestHeader += "Content-Length: " + bodyLength + newLine + newLine;

	//HTTP
	request = requestLine+requestHeader+requestBody;

	//
	int iIndex = m_LSDevices.GetSelectionMark();
	if (0 > iIndex)
	{
		AfxMessageBox("please select device.");
		return;
	}
	iIndex = m_LSDevices.GetItemData(iIndex);
	char *cResponse = NULL;
	int iResponseLength = 0;
	int iResult = VideoNetClient_DeviceRegisterTransparentData((HUSER)iIndex, const_cast<char *>(request.data()), request.size() + 1, &cResponse, &iResponseLength);
	if (0 != iResult)
	{
		AfxMessageBox("OnConfigCaptcity DeviceRegisterTransparentData failed.");
		return;
	}
	if (NULL != cResponse)
	{
		AfxMessageBox(cResponse);
	}
	if (NULL != cResponse)
	{
		VideoNetClient_ReleaseData(cResponse);
		cResponse = NULL;
	}
}

void CDeviceRegisterCenterDlg::OnControlRemoteopen()
{
	// TODO: ڴ
	int iIndex = m_LSDevices.GetSelectionMark();
	if (0 > iIndex)
	{
		AfxMessageBox("please select device.");
		return;
	}
	iIndex = m_LSDevices.GetItemData(iIndex);
	char *cResponse = NULL;
	int iResponseLength = 0;
	int iResult = VideoNetClient_DeviceControl((HUSER)iIndex, eDeviceOpenDoor);
	if (0 != iResult)
	{
		AfxMessageBox("OnControlRemoteopen VideoNetClient_DeviceControl failed.");
		return;
	}
}
