
#ifndef OUTPUT_TO_FILE_H

#define OUTPUT_TO_FILE_H

#pragma once

#include "./VideoNetClientDemo_Common.h"

namespace common
{

	class COutputToFile
	{
	public:
		COutputToFile();
		~COutputToFile();
	public:
		int Open(string file, bool binary = false);
		int Close();
		int Output(const char *buffer, int ilen);
		int IsValid();
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(COutputToFile);
	private:
		string	m_strFile;
		fstream m_file;
		bool	m_bOutput;
	};

}

#endif