
#ifndef UTILITY_H

#define UTILITY_H

#pragma once

#include "./VideoNetClientDemo_Common.h"

namespace common
{

	class CUtility
	{
	public:
		CUtility(void);
		~CUtility(void);
	public:
		//ѡĿ¼
		int SelectDirectory(CString &cDirectory, HWND hParent);
		//ѡļ
		int SelectFile(CString &cFile);
		//ȡ¼ļͷ
		int GetRecordFileHeader(char **buffer, int &length);
		//¼ļ(ԭ¼ļ·'\\'ַ)
		int BuildRecordFile(CString &file, const char *device, DWORD channel, const char *type);
		//Ƚʱ
		int CompareTime(const SYSTEMTIME &first, const SYSTEMTIME &second);
		//תʱ
		int TimeFormControl(SYSTEMTIME &time, const CDateTimeCtrl &control);
		//תʱ
		int TimeToControl(SYSTEMTIME &time, CDateTimeCtrl &control);
		//ʱתַ
		int TimeToString(char *str, SYSTEMTIME &time);
		//ʱתַ
		int TimeToString(CString *str, SYSTEMTIME &time);
		//ʱתʱṹ
		int TimeToTimeInfo(TimeInfo &timeinfo, SYSTEMTIME &time);
		//ʱṹתʱ
		int TimeFormTimeInfo(SYSTEMTIME &timeinfo, TimeInfo &time);
		//ʱṹתַ
		int TimeInfoToString(TimeInfo &timeinfo, CString &time);
	};

}

#endif