
#ifndef VIDEONETCLIENT_DEMO_COMMON_H

#define VIDEONETCLIENT_DEMO_COMMON_H

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <iostream>
#include <fstream>
#include <iterator>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <stack>
#include <string>
#include <algorithm>

using namespace std;

#include "../platform/win32/inc/stdafx.h"


#include "./VideoNetClient.h"
#include "./VideoNetClient_Common.h"
#include "./VideoNetClient_Configure.h"

#include "./VideoNetClientDemo.h"

#pragma warning(disable : 4996)

//////////////////////////////////////////////////////////////////////////
///////							ͨùܶ						//////
//////////////////////////////////////////////////////////////////////////
/** @brief ޿																*/
#define DISABLE_COPY_CAPABILITY_OBJECT(x)												\
	x(const x&){}																		\
	virtual x& operator=(const x&){return (*this);}

/** @brief 鲢ͷָ																*/
#define FREE_POINT_SAFE(x)																\
	{																					\
		if (NULL != x)																	\
		{																				\
			delete x;																	\
			x = NULL;																	\
		}																				\
	}

/** @brief 鲢ͷ																*/
#define FREE_ARRAY_SAFE(x)																\
	{																					\
		if (NULL != x)																	\
		{																				\
			delete[] x;																	\
			x = NULL;																	\
		}																				\
	}

/** @brief ȡԪظ																*/
#define ARRAY_ELEMENT_COUNT(x)	sizeof(x) / sizeof(x[0])

/** @brief ַԪ															*/
#define CLEAN_ARRAY_ELEMENT(x)	memset(x, 0, sizeof(x))

/** @brief 鷵ֵǷɹ															*/
#define CHECK_RET_SUCCESS(x)	0 == x
/** @brief 鷵ֵǷʧ															*/
#define CHECK_RET_FAILED(x)		0 != x

/** @brief ָǷΪ																*/
#define CHECK_POINT_NULL(x)		NULL == x
/** @brief ָǷΪǿ															*/
#define CHECK_POINT_NO_NULL(x)	NULL != x

/** @brief ǷЧ																*/
#define CHECK_HANDLE_INVALID(x)	INVALID_HANDLE_VALUE == x
/** @brief ǷЧ																*/
#define CHECK_HANDLE_VALID(x)	INVALID_HANDLE_VALUE != x


//ͨ
#define MAX_CHANNEL_NUMBER						16
//͸ͨ˿
#define MAX_TRANSPARENT_PORT					256
//͸ͨͻС
#define MAX_TRANSPARENT_SEND_BUFFER				1024
//û¼
#define MAX_USER_EVENT_NUMBER					2
//ʾϢ
#define MAX_OUTPUT_MESSAGE_NUMBER				912
//Ϣַ
#define MAX_OUTPUT_STRING_LEN					5 * 1024
//Խ֡
#define MAX_TALK_FRAME_LEN						128
//ļͷ
#define MAX_FILE_HEADER_LENGTH					19
//תʱ
#define DEFAULT_CYCLE_INTERVAL					5 * 1000

#endif