// HistoryStreamDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/HistoryStreamDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CHistoryStreamDlg Ի

IMPLEMENT_DYNAMIC(CHistoryStreamDlg, CDialog)

CHistoryStreamDlg::CHistoryStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHistoryStreamDlg::IDD, pParent)
	, m_EDRecord(_T("C:\\"))
{

}

CHistoryStreamDlg::~CHistoryStreamDlg()
{
}

void CHistoryStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBQUERYTYPE, m_CBQueryType);
	DDX_Control(pDX, IDC_CBPROTOCOL2, m_CBProtocol);
	DDX_Control(pDX, IDC_STARTDATE, m_DTStartDate);
	DDX_Control(pDX, IDC_STOPDATE, m_DTStopDate);
	DDX_Text(pDX, IDC_EDRECORD, m_EDRecord);
	DDX_Control(pDX, IDC_CBGROUP2, m_Group);
}


BEGIN_MESSAGE_MAP(CHistoryStreamDlg, CDialog)
	ON_BN_CLICKED(IDC_BTBROWSE, &CHistoryStreamDlg::OnBnClickedBtbrowse)
	ON_BN_CLICKED(IDOK, &CHistoryStreamDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CHistoryStreamDlg Ϣ

BOOL CHistoryStreamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	CString	cChannel;
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cQueryType[] = {"All", "Plan", "Manual", "Motion", "Alarm", "Motion & Alarm"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cQueryType); count++)
	{
		m_CBQueryType.AddString(cQueryType[count]);
	}
	if (0 < m_CBQueryType.GetCount())
	{
		m_CBQueryType.SetCurSel(0);
	}

	CString cProtocol[] = {"TCP", "RTP"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cProtocol); count++)
	{
		m_CBProtocol.AddString(cProtocol[count]);
	}
	if (0 < m_CBProtocol.GetCount())
	{
		m_CBProtocol.SetCurSel(0);
	}

	CString cGroup[] = {"Normal And Alram", "Redundancy", "Backup"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cGroup); count++)
	{
		m_Group.AddString(cGroup[count]);
	}
	if (0 < m_Group.GetCount())
	{
		m_Group.SetCurSel(0);
	}

	// ʱؼ
	m_DTStartDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	m_DTStopDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CHistoryStreamDlg::OnBnClickedBtbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectDirectory(m_EDRecord, GetSafeHwnd()))
	{
		UpdateData(FALSE);
	}
}

void CHistoryStreamDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	m_info.m_Channel = m_CBChannel.GetCurSel();
	m_info.m_Protocol = m_CBProtocol.GetCurSel();
	m_info.m_QueryType = m_CBQueryType.GetCurSel();
	m_info.m_Group = m_Group.GetCurSel();
	CUtility cUtility;
	cUtility.TimeFormControl(m_info.m_StartTime, m_DTStartDate);
	cUtility.TimeFormControl(m_info.m_StopTime, m_DTStopDate);
	m_info.m_Record = m_EDRecord;
	OnOK();
}
