// RealStreamDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/RealStreamDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CRealStreamDlg Ի

IMPLEMENT_DYNAMIC(CRealStreamDlg, CDialog)

CRealStreamDlg::CRealStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRealStreamDlg::IDD, pParent)
	, m_EDRecord(_T("C:\\"))
{
	TCHAR szFullPath[MAX_PATH];
	TCHAR szDir[_MAX_DIR];
	TCHAR szDrive[_MAX_DRIVE]; 
	// GetModuleFileNameõȫ·szFullPath .
	::GetModuleFileName(NULL, szFullPath, MAX_PATH);
	// ȫ·ֿMSDN szDrive̷
	_splitpath(szFullPath, szDrive, szDir, NULL, NULL);
	m_EDRecord = szDrive;
	m_EDRecord += "\\";
	m_EDRecord.MakeUpper();
}

CRealStreamDlg::~CRealStreamDlg()
{
}

void CRealStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBPROTOCOL, m_CBProtocol);
	DDX_Control(pDX, IDC_CBSTREAM, m_CBStream);
	DDX_Text(pDX, IDC_EDRECORD, m_EDRecord);
}


BEGIN_MESSAGE_MAP(CRealStreamDlg, CDialog)
ON_BN_CLICKED(IDC_BTBROWSE, &CRealStreamDlg::OnBnClickedBtbrowse)
ON_BN_CLICKED(IDOK, &CRealStreamDlg::OnBnClickedOk)
END_MESSAGE_MAP()

BOOL CRealStreamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	CString	cChannel;
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	cChannel.Format("All");
	m_CBChannel.AddString(cChannel);
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cProtocol[] = {"TCP", "RTP"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cProtocol); count++)
	{
		m_CBProtocol.AddString(cProtocol[count]);
	}
	if (0 < m_CBProtocol.GetCount())
	{
		m_CBProtocol.SetCurSel(0);
	}

	CString cStream[] = {"Video & Voice", "Video", "Voice","AssitVideo"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cStream); count++)
	{
		m_CBStream.AddString(cStream[count]);
	}
	if (0 < m_CBStream.GetCount())
	{
		m_CBStream.SetCurSel(0);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CRealStreamDlg::OnBnClickedBtbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectDirectory(m_EDRecord, GetSafeHwnd()))
	{
		UpdateData(FALSE);
	}
}

void CRealStreamDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	m_info.m_Channel = m_CBChannel.GetCurSel();
	if (0 == m_CBProtocol.GetCurSel())
	{
		m_info.m_Protocol = eGeneralTCP;
	}else{
		m_info.m_Protocol = eGeneralRTP;
	}
	m_info.m_Stream = m_CBStream.GetCurSel();
	m_info.m_cRecord = m_EDRecord;
	OnOK();
}
