// TransparentDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/TransparentDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CTransparentDlg Ի

IMPLEMENT_DYNAMIC(CTransparentDlg, CDialog)

CTransparentDlg::CTransparentDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTransparentDlg::IDD, pParent)
	, m_EDSendFile(_T("C:\\TransparentSend.txt"))
	, m_EDRecvFile(_T("C:\\"))
{

}

CTransparentDlg::~CTransparentDlg()
{
}

void CTransparentDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHTYPE, m_CBChType);
	DDX_Control(pDX, IDC_CBSERIALTYPE, m_CBSerialType);
	DDX_Control(pDX, IDC_CBSERIALPORT, m_CBSerialPort);
	DDX_Text(pDX, IDC_EDSENDFILE, m_EDSendFile);
	DDX_Text(pDX, IDC_EDRECVFILE, m_EDRecvFile);
}


BEGIN_MESSAGE_MAP(CTransparentDlg, CDialog)
	ON_BN_CLICKED(IDC_BTSENDBROWSE, &CTransparentDlg::OnBnClickedBtsendbrowse)
	ON_BN_CLICKED(IDC_BTRECVBROWSE, &CTransparentDlg::OnBnClickedBtrecvbrowse)
	ON_BN_CLICKED(IDOK, &CTransparentDlg::OnBnClickedOk)
	ON_CBN_SELCHANGE(IDC_CBSERIALTYPE, &CTransparentDlg::OnCbnSelchangeCbserialtype)
END_MESSAGE_MAP()


// CTransparentDlg Ϣ

BOOL CTransparentDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	CString cChType[] = {"Serial", "Application Message"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cChType); count++)
	{
		m_CBChType.AddString(cChType[count]);
	}
	if (0 < m_CBChType.GetCount())
	{
		m_CBChType.SetCurSel(0);
	}

	CString cSerialType[] = {"RS232", "RS485", "RS422"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cSerialType); count++)
	{
		m_CBSerialType.AddString(cSerialType[count]);
	}
	if (0 < m_CBSerialType.GetCount())
	{
		m_CBSerialType.SetCurSel(0);
	}

	CString cSerialPort;
	for (int count = 0; count < MAX_TRANSPARENT_PORT; count++)
	{
		cSerialPort.Format("%d", count + 1);
		m_CBSerialPort.AddString(cSerialPort);
	}
	if (0 < m_CBSerialPort.GetCount())
	{
		m_CBSerialPort.SetCurSel(0);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CTransparentDlg::OnBnClickedBtsendbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectFile(m_EDSendFile))
	{
		UpdateData(FALSE);
	}
}

void CTransparentDlg::OnBnClickedBtrecvbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectDirectory(m_EDRecvFile, GetSafeHwnd()))
	{
		UpdateData(FALSE);
	}
}

void CTransparentDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	m_info.m_ChannelType = m_CBChType.GetCurSel();
	m_info.m_SerialType = m_CBSerialType.GetCurSel();
	m_info.m_SerialPort = m_CBSerialPort.GetCurSel();
	m_info.m_cRecvFile = m_EDRecvFile;
	m_info.m_cSendFile = m_EDSendFile;
	OnOK();
}

void CTransparentDlg::OnCbnSelchangeCbserialtype()
{
	// TODO: Add your control notification handler code here
}
