// TransparentSendDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/TransparentSendDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CTransparentSendDlg Ի

IMPLEMENT_DYNAMIC(CTransparentSendDlg, CDialog)

CTransparentSendDlg::CTransparentSendDlg(CVideoNetClientDemoDlg *pMain, HTRANSPARENT h, CWnd* pParent /*=NULL*/)
	: CDialog(CTransparentSendDlg::IDD, pParent)
	, m_EDSendText(_T("kevin2hy"))
	, m_EDSendFile(_T("C:\\TransparentSend.txt"))
{
	m_pMainDlg = pMain;
	m_hTransparent = h;
}

CTransparentSendDlg::~CTransparentSendDlg()
{
}

void CTransparentSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDSENDTEXT, m_EDSendText);
	DDX_Text(pDX, IDC_EDSENDFILE, m_EDSendFile);
}


BEGIN_MESSAGE_MAP(CTransparentSendDlg, CDialog)
	ON_BN_CLICKED(IDC_BTSENDTEXT, &CTransparentSendDlg::OnBnClickedBtsendtext)
	ON_BN_CLICKED(IDC_BT_SENDFILE, &CTransparentSendDlg::OnBnClickedBtSendfile)
	ON_BN_CLICKED(IDC_BTBROWSESENDFILE, &CTransparentSendDlg::OnBnClickedBtbrowsesendfile)
END_MESSAGE_MAP()


// CTransparentSendDlg Ϣ
void CTransparentSendDlg::OnBnClickedBtsendtext()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	if (m_EDSendText.IsEmpty())
	{
		return;
	}
	m_pMainDlg->TransparentSend(m_hTransparent, (BYTE*)LPCSTR(m_EDSendText), m_EDSendText.GetLength());
}

void CTransparentSendDlg::OnBnClickedBtSendfile()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	if (m_EDSendFile.IsEmpty())
	{
		return;
	}
	OnOK();
}

void CTransparentSendDlg::OnBnClickedBtbrowsesendfile()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectFile(m_EDSendFile))
	{
		UpdateData(FALSE);
	}
}
