#ifndef VNCIU_CLIENT_COMMON_H

//////////////////////////////////////////////////////////////////////////
//궨
//////////////////////////////////////////////////////////////////////////
//HieClientͨϢļ
#define VNCIU_CLIENT_COMMON_H

/*!
* @file
*  VideoNetClient_Common.h
* \brief
*  ͻSDKӿڽṹͶ
* @author
*  zw
* @date
*  20140623
* @version
*  5.2.0
*/

//
/** \brief 																						*/
#define IN

/** \brief 																						*/
#define OUT

/** \brief 																					*/
#define IN_OUT

/** \brief ͨ																				*/
#ifndef BYTE
typedef unsigned long long			ULONGLONG;
#ifdef WIN32
typedef unsigned long			DWORD;
#else
typedef unsigned int			DWORD;
#endif

typedef unsigned long           VNC_USERDATA;

typedef long						LONG;
typedef int							BOOL;
typedef unsigned short				WORD;
typedef unsigned char				BYTE;
typedef unsigned int                UINT;
#endif

#if defined(_WIN32)
#ifndef SYSTEM_WIN32
#define SYSTEM_WIN32
#endif
#elif defined(_LINUX)
#define SYSTEM_LINUX
#else
#error "undefined system!"
#endif

/** \brief ͨ																				*/
#ifndef CALLBACK
#if defined(_LINUX)
#define CALLBACK
#else
#define CALLBACK					__stdcall
#endif
#endif

#ifndef HANDLE
typedef void*						HANDLE;
#endif

/** \brief û,ͨ¼ȡ																*/
#define HUSER						HANDLE

/** \brief ý,ͨýӲȡ														*/
#define HSTREAM						HANDLE

/** \brief ʷͨ,ͨʷͨȡ														*/
#define HHISTORY					HANDLE

/** \brief ʷѯ,ͨʷѯȡ													*/
#define HSTREAM_QUERY				HANDLE

/** \brief ļѯ,ͨļѯȡ														*/
#define HFILE_QUERY					HANDLE

/** \brief ʷ־ѯ,ͨʷ־ѯȡ												*/
#define HLOG_QUERY					HANDLE

/** \brief ͸ͨ,ͨ͸ͨȡ														*/
#define HTRANSPARENT				HANDLE

/** \brief ļ,ͨļ䴴ȡ														*/
#define HFILE_TRANSFER				HANDLE

/** \brief ھ,ʾͼ																*/
#define HWINDOW						HWND

/** \brief ʵʱͻ																			*/
#define REAL_STREAM_LIMIT			(8)

/** \brief ͻ																			*/
#define VOICE_STREAM_LIMIT			(REAL_STREAM_LIMIT)

/** \brief û																				*/
#define USERNAME_LEN				(32)

/** \brief û볤																				*/
#define USERPASS_LEN				(32)

/** \brief IPַ()	xxx.xxx.xxx.xxx														*/
#define IP_ADDRESS_LEN				(16)

/** \brief MACַ()																	*/
#define MAC_ADDRESS_LEN				(18)

/** \brief MACַƳ																		*/
#define MAC_BINARY_ADDRESS_LEN		(6)

/** \brief 汾Ϣ()																	*/
#define VERSION_INFO_LEN			(20)

/** \brief ļ																			*/
#define MAX_FILENAME				(256)

/** \brief ()																		*/
#define DOMAIN_ADDRESS_LEN			(256)

/** \brief ̽Ϣ󳤶										                    			*/
#define MAX_PARTNER_PROBE_CFG_LEN	(65534)

/** \brief ̽Ϣ󳤶										                    			*/
#define MAX_PARTNER_PROBE_CFG_LEN_V2	(65534)

/** \brief ַ()																		*/
#define MAX_ADDRESS_LEN				(DOMAIN_ADDRESS_LEN)

/** \brief Ĭϱֶθ																			*/
#define DEF_RESERVE_NUM				(3)

/** @brief Ϣ󳤶																			*/
#define MAX_CFG_LEN_512BYTE			(512)

/** \brief Ĭϱֶθ																			*/
#define DEF_RESERVE_NUM_V2			(1024)

/** \brief ĬHTTPñֶθ																	*/
#define DEF_HTTP_CFG_RESERVE_NUM	(16)

/** \brief Ϣ󳤶											                    			*/
#define MAX_CFG_LEN					(128 * 1024 * 4)

/** \brief Ϣ󳤶ȣV2汾								                    			*/
#define MAX_CFG_LEN_V2				(128 * 1024 * 4)

/** \brief ͸󳤶												               			*/
#define MAX_TRANSPARENT_DATA_LEN	(128 * 1024 * 4)

/** \brief ¼֪ͨ																		*/
#define	MAX_EVENT_NUM				(32)

/** \brief URLַ																				*/
#define MAX_URL_LEN					(256)

/** \brief ʱ䴮																			*/
#define DATE_TIME_LEN				(15)

/** \brief MACַַ, xx:xx:xx:xx:xx:xx														*/
#define MAC_ADDRESS_LEN				(18)

/** \brief ͨ																		*/
#define MAX_CHANNEL_NUM				(32)

/** \brief ͨ																	*/
#define MAX_DEC_CHANNEL_NUMBER		(64)

/** \brief 																		*/
#define MAX_DISPLAY_SCREEN_NUMBER	(64)

/** \brief û󳤶																			*/
#define MAX_USER_NAME_LEN			(32)

/** \brief û󳤶																			*/
#define MAX_USER_PASS_LEN			(32)

/** \brief 󳤶																			*/
#define MAX_FONT_NAME_LEN			(32)

/** \brief ļ·󳤶																			*/
#define MAX_FILE_PATH_LEN			(256)

/** \brief ѯID																		*/
#define MAX_LINK_ID_QUERY_NUM		(256)

/** \brief ſƲ																			*/
#define MAX_PLAY_CONTROL_PARAMETER	(5)

/** \brief ͨתƵԴ																			*/
#define MAX_DECODER_CHANNEL_SOURCE	(16)

/** \brief ĻƲ																			*/
#define MAX_SCREEN_CONTROL_PARAMETER	(5)

/** \brief LOGOͼƬ																			*/
#define MAX_LOGO_PICTURE_PARAMETER	(5)

/** \brief OSDıַ																			*/
#define MAX_OSD_TEXT_STRING_LENGTH	(64)

/** \brief RTSPԴַ																				*/
#define MAX_RTSP_SOURCE_STRING_LENGTH	(128)

/** @brief 豸汾Ƴ												          	 */
#define DVR_MAX_DEVICE_VERSION_LEN				(32)

/** @brief P2P UUID 												          	 */
#define DVR_MAX_P2P_UUID_LEN				(32)

/** @brief ID󳤶													          			*/
#define MAX_FACE_LIB_ID_LENGTH				(48)

/** @brief ID󳤶														          			*/
#define MAX_FACE_ID_LENGTH					(48)

/** @brief 󳤶												          				*/
#define MAX_FACE_LIB_NAME_LENGTH			(32)

/** @brief 󳤶												          	 				*/
#define MAX_FACE_NAME_LENGTH				(32)

/** @brief ID󳤶											          						*/
#define MAX_CERTIFICATE_ID_LENGTH			(32)

/** @brief ƬID󳤶												          					*/
#define MAX_CARD_ID_LENGTH					(32)

/** @brief ŽԶ̿ID󳤶												          			*/
#define MAX_GATE_REMOTE_ID_LENGTH			(32)

//////////////////////////////////////////////////////////////////////////
//ʷ֡궨
//////////////////////////////////////////////////////////////////////////
/** \brief ʷ쳣																			*/
#define HISTORY_STREAM_EXCEPTION	(0x01000000)

/** \brief ʷл֡궨																		*/
#define	HISTORY_STREAM_SWITCH_FRAME	(0x02000000)

/** \brief ʷµʱƬ																		*/
#define HISTORY_STREAM_TIME_JUMP	(0x03000000)

/** \brief ʷ֡궨																		*/
#define	HISTORY_STREAM_TIME_END		(0x04000000)

/** \brief ʷݲѯ																		*/
#define HISTORY_STREAM_TIME_CURR	(0x05000000)


//////////////////////////////////////////////////////////////////////////
//Զ¼
//////////////////////////////////////////////////////////////////////////
/** \brief ¼																					*/
#define USEREVENT_ALARM_NOTICE			(0x00000001)

/** \brief ʧ,Ͽ																		*/
#define USEREVENT_HEARTBEAT_LOST		(0x00000002)

/** \brief ɹ																				*/
#define USEREVENT_NET_RECOVER			(0x00000004)

/** \brief ԶûϿ																				*/
#define USEREVENT_USER_DISCONNECT		(0x00000008)

/** \brief ԶýϿ																			*/
#define USEREVENT_STREAM_DISCONNECT		(0x00000010)

/** \brief Ӳ¼																			*/
#define USEREVENT_DISKGROUP_MANAGE		(0x00000020)

/** \brief ʷ¼֪ͨ																			*/
#define USEREVENT_HISTORYSTREAM_NOTICE	(0x00000040)

/** \brief ʵʱID֪ͨ																		*/
#define USEREVENT_REALSTREAM_STARTLINK	(0x00000080)

/** \brief ʵʱֹͣID֪ͨ																		*/
#define USEREVENT_REALSTREAM_STOPLINK	(0x00000100)

/** \brief ID֪ͨ(δʵ)																		*/
#define USEREVENT_VOICESTREAM_STARTLINK	(0x00000200)

/** \brief ֹͣID֪ͨ(δʵ)																		*/
#define USEREVENT_VOICESTREAM_STOPLINK	(0x00000400)

/** \brief ʷ¼֪ͨ(δʵ)																		*/
#define USEREVENT_HISTORYSTREAM_DESTROYLINK		(0X00000800)

/** \brief ʷ¼֪ͨ(δʵ)																		*/
#define USEREVENT_HISTORYSTREAM_STARTLINK		(0X00001000)

/** \brief ʷֹͣ¼֪ͨ(δʵ)																		*/
#define USEREVENT_HISTORYSTREAM_STOPLINK		(0X00002000)

/** \brief ʷ¼֪ͨ(δʵ)																		*/
#define USEREVENT_HISTORYSTREAM_CREATELINK		(0X00004000)

/** @brief 豸޸¼֪ͨparam1õparam2õĴ	*/
#define USEREVENT_DEVICE_CONFIG_CHANGED			(0X00008000)

/** \brief ¼ͼeEventAIType											*/
#define USEREVENT_AI_EVENT_PUSH				(0X00010000)


//////////////////////////////////////////////////////////////////////////
//ʷ¼ͺ궨
//////////////////////////////////////////////////////////////////////////

/** @brief ͨ¼																				*/
#define GENERAL_RECORD				(0X00000001)

/** @brief ֶ¼																				*/
#define MANUAL_RECORD				(0X00000002)

/** @brief ¼																				*/
#define ALARM_RECORD				(0X00000004)

/** @brief ƶ¼																				*/
#define MOTION_RECORD				(0X00000008)

/** \brief ¼¼																				*/
#define AI_RECORD				(0X00000010)

/** \brief PIR¼																				*/
#define PIR_RECORD					(0X00000020)

/** @brief ¼																				*/
#define ALL_STREAM_MEDIA			(GENERAL_RECORD | MANUAL_RECORD | MOTION_RECORD | ALARM_RECORD|AI_RECORD|PIR_RECORD)


//////////////////////////////////////////////////////////////////////////
//ö
//////////////////////////////////////////////////////////////////////////

/*!
*  \enum	eSerialType
*  \brief	
*/
typedef enum eSerialType
{
	eTTY232 = 0,										/*!< RS232                               */
	eTTY485,											/*!< RS485                               */
	eTTY422,											/*!< RS422                               */
}eSerialType;
#ifndef DEF_ENUM_ALERT_TYPE
#define DEF_ENUM_ALERT_TYPE
/*!
*  \enum	eAlertType
*  \brief	쳣
*/
typedef enum eAlertType
{
	ALERT_ALARMIN,										/*!< 								*/
	ALERT_MOTION,										/*!< ƶ								*/
	ALERT_ENCODEERROR,									/*!< 쳣								*/
	ALERT_DISKERROR,									/*!< Ӳ̴								*/
	ALERT_DISKFULL,										/*!< Ӳ									*/
	ALERT_IPCONFLICT,									/*!< IPͻ									*/
	ALERT_ILLEGEACCESS,									/*!< Ƿ								*/
	ALERT_RETICLEDISCONNECT,							/*!< ߶									*/
	ALERT_VIDEOLOST,									/*!< Ƶʧ								*/
	ALERT_VIDEOEXCEPTION,								/*!< Ƶ쳣								*/
	ALERT_DISKGROUP_ERROR,								/*!< 쳣								*/
	ALERT_IMODE,										/*!< (ڲʹ)					    */
	ALERT_IPCHANGED,									/*!< IPַ仯,ڷHELLOϢ(ڲʹ) */
	ALERT_REMOTE_ALARMIN,       						/*!< Զ̱                       	*/
	ALERT_HUMANSHAPE,									//! μ
	ALERT_FACEDETECT,									//! 
	ALERT_FACERECO,										//! ʶ
	ALERT_PIR,											//! PIR
}eAlertType;

/*!
*  @enum	eEventAIType
*  @brief	¼
*/
typedef enum eEventAIType
{
	EVENT_AI_PEOPLE_DETECT	= 0,						/*!< ¼                          	*/
	EVENT_AI_FACE_DETECT_LITE,							/*!< 汾¼					*/
	EVENT_AI_FACE_DETECT,								/*!< ߽װ汾¼EventFaceRecognition*/
	EVENT_AI_FACE_RECOGNITION,							/*!< ʶ¼EventFaceRecognition   */

	EVENT_GATE_FACERECOGNITION_OPEN	= 100,				/*!< ȶԿ¼EventFaceRecognition*/
	EVENT_GATE_KEYBOARD_OPEN,							/*!< 뿪ţEventGateKeyboard		*/
	EVENT_GATE_CARD_OPEN,								/*!< ˢţEventGateCard			*/
	EVENT_GATE_BUTTON_OPEN,								/*!< ţޣ						*/
	EVENT_GATE_REMOTE_OPEN,								/*!< Զ̿ţEventGateRemote		*/
}eAIPushType;

#endif
/*!
*  \enum	eHieClientError
*  \brief	
*/
typedef enum eVideoNetClientError
{
	eErrorNone						= 0,				/*!< ޴									*/
	eErrorFailed,										/*!< ʧ									*/
	eErrorNoInitializeSDK,								/*!< δʼSDK							*/
	eErrorHandle,										/*!< 								*/
	eErrorParameter,									/*!< 								*/
	eErrorBufferNoEnough,								/*!< ̫С								*/
	eErrorMemory,										/*!< ڴ								*/
	eErrorSystemFailed,									/*!< ϵͳش						*/
	eErrorNoIdleResource,								/*!< ޿Դ								*/
	eErrorTimeOut,										/*!< ʱ								*/
	eErrorFunctionVersionLow,							/*!< ܰ汾ڷ						*/
	eErrorFunctionVersionHigh,							/*!< ܰ汾ڷ						*/
	eErrorTaskNoRun,									/*!< δ								*/
	eErrorAlreadyRun,									/*!< ظ								*/
	eErrorConnectFailed,								/*!< ʧ								*/
	eErrorSessionDisconnect,							/*!< ӶϿ								*/
	eErrorCommandSendFailed,							/*!< ʧ							*/
	eErrorServerReject,									/*!< ܾ								*/
	eErrorInvalidUser,									/*!< ûǷ							*/
	eErrorCallFail,										/*!< Զ̵ʧ							*/
	eErrorCallReplyError,								/*!< Զ̵Ӧ						*/
	
	eErrorUserName,										/*!< û								*/
	eErrorUserPass,										/*!< û							*/
	eErrorIPLimited,									/*!< ûIP								*/
	eErrorMACLimited,									/*!< MAC								*/
	eErrorUserNumOverflow,								/*!< ½û							*/
	eErrorUserHeartBeat,								/*!< ûʧ						*/
	eErrorGetConfigurationPort,							/*!< ½ʱȡ˿Ϣʧ				*/
	eErrorServiceReseting,								/*!< 							*/
	eErrorInvalidURL,									/*!< ЧURLַ							*/

	eErrorNoSupportCommand,								/*!< ֵ֧	                        */
	eErrorNotImplement,									/*!< δʵ									*/
	eErrorUnserialize,									/*!< лʧ							*/
	eErrorDeviceReconnecting,							/*!< 豸							*/
	eErrorManaualReconnectFailed,						/*!< 豸ʧ							*/
	eErrorDeviceStreamConnectMaxLimit,					/*!< 豸					*/

	//Ϊ豸Ϣƥ䣬Ϣ붨£(Ĵ涨)
	eErrorMODULE_ID = 16000,
	eErrorUNSUPPORTED_MAJORTYPE,						/*!< ֵ֧						*/
	eErrorUNSUPPORTED_MINORTYPE,						/*!< ֵ֧Ĵ						*/
	eErrorSTRUCT_UNVALID,								/*!< ṹЧ								*/
	eErrorSTRUCT_READONLY,								/*!< ṹֻ							*/
	eErrorBUF_SMALL,									/*!< ̫С								*/
	eErrorSTRUCT_UNSUPPORTED,							/*!< ϵͳָ֧ýṹûȡ			*/
	eErrorNO_RIGHT,										/*!< ûȨ								*/
	eErrorPARAM_OVERFLOW,								/*!< 								*/
	eErrorCALLSDK_FAIL,									/*!< SDKʧ							*/
	//		WiFi Դ
	eErrorInvalidWifiCfgParam,							//	߲Ч
	eErrorNetcardNotEnable,								//	δ
	eErrorModeError,										//	ǰAPģʽ,STAģʽֲ֧
	eErrorTestBusy,											//	, Ժ...
	eErrorNoDeviceAvailable								//	ûпõ豸

}eVideoNetClientError;

/*!
*  \enum	eClientSDKAttributeType
*  \brief	ͻSDK
*/
typedef enum eClientSDKAttributeType
{
	eClientSDKAttributeTypeBegin			=	0,		/*!< ʼֵ									*/
	eAttributeConnectTimeOut,							/*!< ӳʱʱ							*/
	eAttributeCommandTimeOut,							/*!< Ƴʱʱ						*/
	eAttributeMediaTimeOut,								/*!< ýƳʱʱ						*/
	eAttributeProbeTimeOut,
	eAttributeSendFileBufferSize,						/*!< ϴļBufferĴС				*/
	eAttributeDisonnectTimeOut,							/*!< Ͽӳʱʱ						*/
	eClientSDKAttributeTypeEnd,							/*!< ֵ									*/
}eClientSDKAttributeType;

/*!
*  \enum	eMediaFunctionType
*  \brief	ý幦
*/
typedef enum eMediaFunctionType
{
	eMediaFunctionTypeBegin			=	0,				/*!< ʼֵ									*/
	eMediaFunctionRealStream,							/*!< ʵʱ									*/
	eMediaFunctionVoiceStream,							/*!< 									*/
	eMediaFunctionHistoryStream,						/*!< ʷ									*/
	eMediaFunctionTransparent,							/*!< ͸ͨ								*/
	eMediaFunctionFileUpload,							/*!< ļϴ								*/
	eMediaFunctionFileDownload,							/*!< ļ								*/
	eMediaFunctionTypeEnd,								/*!< ֵ									*/
}eMediaFunctionType;

/*!
*  \enum	eStreamTransferMode
*  \ingroup DS_StreamTransferMode
*  \brief	䷽ʽ
*/
typedef enum eStreamTransferMode
{
	eStreamTransferModeBegin		=	0,				/*!< ʼֵ									*/
	eGeneralTCP,										/*!< ͨTCP								*/
	eGeneralRTP,										/*!< ͨRTP								*/
	eStreamTransferModeEnd,								/*!< ֵ									*/
}eStreamTransferMode;

/*!
*  \enum	eRTPStreamTransferMode
*  \ingroup DS_RTPStreamTransferMode
*  \brief	RTP䷽ʽ
*/
typedef enum eRTPStreamTransferMode
{
	eRTPStreamTransferModeBegin		=	0,				/*!< ʼֵ									*/
	eRTPGeneralTCP,										/*!< ͨTCP								*/
	eRTPGeneralUDP,										/*!< ͨUDP								*/
	eRTPStreamTransferModeEnd,								/*!< ֵ									*/
}eRTPStreamTransferMode;

/*!
*  \enum	eStreamMediaType
*  \ingroup DS_StreamMediaType
*  \brief	ý
*/
typedef enum eStreamMediaType
{
	eStreamMediaTypeBegin			=	0,				/*!< ʼֵ									*/
	eMainVideoAndSound,									/*!< Ƶ							*/
	eMainVideo,											/*!< Ƶ								*/
	eMainSound,											/*!< Ƶ								*/
	eAssistVideo,										/*!< Ƶ								*/
	eAssistHDVideo,										/*!< Ƶ							*/
	eStreamMediaTypeEnd,								/*!< ֵ									*/
}eStreamMediaType;

/*!
*  \enum	eHistoryStreamType
*  \ingroup DS_HistoryStreamType
*  \brief	ʷ
*/
typedef enum eHistoryStreamType
{
	eHistoryStreamTypeBegin = 0,						/*!< ʼֵ                                 */
	eAllStreamMedia,									/*!< ý                             */
	eGeneralRecord,										/*!< ͨ¼                               */
	eManualRecord,										/*!< ֶ¼                               */
	eMotionRecord,										/*!< ƶ¼                               */
	eAlarmRecord,										/*!< ¼                               */
	eAIRecord,											/*!< ¼                               */
	ePIRRecord,											/*!< PIR¼                               */
	eHistoryStreamTypeEnd,								/*!< ֵ                                 */
}eHistoryStreamType;

/*!
*  \enum	eFileType
*  \brief	ļ
*/
typedef enum eFileQueryType
{
	eFileTypeBegin			=	0,						/*!< ʼֵ									*/
	eUpgrade,											/*!< 									*/
	eImage,												/*!< ͼƬļ								*/
	ePtzProtocolFile,									/*!< ̨Э								*/
	eFileTypeEnd,										/*!< ֵ									*/
}eFileQueryType;

/*!
*  \enum	eHistoryStreamOperation
*  \brief	ʷ,ʷֶ֧ͨͬʱͬʱ
*/
typedef enum eHistoryStreamOperation
{
	eHistoryStreamOperationBegin	=	0,				/*!< ʼֵ									*/
	eHistoryStreamAddChannel,							/*!< ʷͨ							*/
	eHistoryStreamDelChannel,							/*!< ɾʷͨ							*/
	eHistoryStreamOperationEnd,							/*!< ֵ									*/
}eHistoryStreamOperation;

/*!
*  \enum	eHistoryStreamControl
*  \brief	ʷ
*/
typedef enum eHistoryStreamControl
{
	eHistoryStreamControlBegin		=	0,				/*!< ʼֵ									*/
	eHistoryPlay,										/*!< 									*/
	eHistoryStop,										/*!< ֹͣ									*/
	eHistoryStreamControlEnd,							/*!< ֵ									*/
}eHistoryStreamControl;

/*!
*  \enum	eDecodeMode
*  \brief	뷽ʽ
*/
typedef enum eDecodeMode
{
	eDecodeModeBegin				=	0,				/*!< ʼֵ									*/
	eSoftDecode,										/*!< 								*/
	eHardDecode,										/*!< Ӳ뿨							*/
	eMatrixDecode,										/*!< 뿨							*/
	eDecodeModeEnd,										/*!< ֵ									*/
}eDecodeMode;

/*!
*  \enum	eDecodeShowMode
*  \brief	뷽ʽ
*/
typedef enum eDecodeShowMode
{
	eDecodeShowModeBegin			=	0,				/*!< ʼֵ									*/
	eNormalMode,										/*!< ͨģʽ								*/
	eOverlayMode,										/*!< ģʽ,һ̨ͻͬһʱֻһ*/
	eDecodeShowModeEnd,									/*!< ֵ									*/
}eDecodeShowMode;

/*!
*  \enum	eDecodeEffectType
*  \brief	Ч
*/
typedef enum eDecodeEffectType
{
	eDecodeEffectTypeBegin			=	0,				/*!< ʼֵ									*/
	eBrightValue,										/*!< 									*/
	eContrastValue,										/*!< Աȶ									*/
	eSaturationValue,									/*!< Ͷ									*/
	eHueValue,											/*!< ɫ									*/
	eQualityValue,										/*!< 									*/
	eDecodeEffectTypeEnd,								/*!< ֵ									*/
}eDecodeEffectType;

/*!
*  \enum	eSoftDecodeEffectValue
*  \brief	Чֵ
*/
typedef enum eSoftDecodeEffectValue
{
	eSoftDecodeEffectValueBegin		=	0,				/*!< ʼֵ									*/
	eSoftDecodeMinEffectValue		=	1,				/*!< СЧֵ								*/
	eSoftDecodeNormalEffectValue	=	8,				/*!< Чֵ								*/
	eSoftDecodeMaxEffectValue		=	17,				/*!< Чֵ								*/
	eSoftDecodeLowQualityValue,							/*!< 									*/
	eSoftDecodeHighQualityValue,						/*!< 									*/
	eSoftDecodeEffectValueEnd,							/*!< ֵ									*/
}eSoftDecodeEffectValue;

/*!
*  \enum	eMatrixDecodeEffectValue
*  \brief	Чֵ
*/
typedef enum eMatrixDecodeEffectValue
{
	eMatrixDecodeEffectValueBegin	=	0,				/*!< ʼֵ									*/
	eMatrixDecodeMinEffectValue		=	1,				/*!< СЧֵ								*/
	eMatrixDecodeNormalEffectValue	=	8,				/*!< Чֵ								*/
	eMatrixDecodeMaxEffectValue		=	15,				/*!< Чֵ								*/
	eMatrixDecodeLowQualityValue,						/*!< 									*/
	eMatrixDecodeHighQualityValue,						/*!< 									*/
	eMatrixDecodeEffectValueEnd,						/*!< ֵ									*/
}eMatrixDecodeEffectValue;



/*!
*  \enum	eTaskControl
*  \brief	
*/
typedef enum eTaskControl
{
	eTaskControlBegin				=	0,				/*!< ʼֵ									*/
	eTaskStart,											/*!< 								*/
	eTaskStop,											/*!< ֹͣ								*/
	eTaskSetSpeed,										/*!< ʷʱÿٶ				*/
	eTaskControlEnd,									/*!< ֵ									*/
}eTaskControl;

/*!
*  \enum	eOperationType
*  \brief	
*/
typedef enum eOperationType
{
	eOperationTypeBegin			=	0,					/*!< ʼֵ									*/
	eOperationGet,										/*!< ȡ								*/
	eOperationSet,										/*!< ò								*/
	eOperationTypeEnd,									/*!< ֵ									*/
}eOperationType;

/*!
*  \enum	eVoiceStreamDisposeMode
*  \brief	ʽ
*/
typedef enum eVoiceStreamDisposeMode
{
	eVoiceStreamDisposeModeBegin=	0,					/*!< ʼֵ									*/
	eVoiceStreamDecodePlay,								/*!< 벥								*/
	eVoiceStreamTransport,								/*!< 									*/
	eVoiceStreamDisposeModeEnd,							/*!< ֵ									*/
}eVoiceStreamDisposeMode;

/*!
*  \enum	eVoiceStreamSource
*  \brief	Դ
*/
typedef enum eVoiceStreamSource
{
	eVoiceStreamSourceBegin		=	0,					/*!< ʼֵ									*/
	eVoiceStreamCapture,								/*!< 									*/
	eVoiceStreamReceive,								/*!< 									*/
	eVoiceStreamSourceEnd,								/*!< ֵ									*/
}eVoiceStreamSource;

/*!
*  \enum	eStreamImageFormat
*  \brief	ýͼƬʽ
*/
typedef enum eStreamImageFormat
{
	eStreamImageFormatBegin		=	0,					/*!< ʼֵ									*/
	eStreamImageBitmap,									/*!< λͼ									*/
	eStreamImageFormatEnd,								/*!< ֵ									*/
}eStreamImageFormat;


/*!-
*  \enum	eFileLockOperationCode
*  \brief	ļ
*/
typedef enum eFileLockOperationCode
{
	eUnlockFile	=	0,									/*!< 									*/
	eLockFile,											/*!< 									*/
}eFileLockOperationCode;


/*!
*  \enum	eImageFormat
*  \brief	ץͼļʽ
*/
typedef enum eImageFormat
{
	eImageFormatBegin = 0,								/*!< ʼֵ									*/
	eBmpFormat,											/*!< λͼʽ								*/
	eJpgFormat,											/*!< jpgʽ								*/
	eJpgFormatV2,										/*!< jpgV2ʽ ,ʹʽץͼ		*/
	eJPGFormatUI,										/*!< DVR/NVR/IPDбؽ豸		*/
	eImageFormatEnd,									/*!< ֵ									*/
}eImageFormat;

/*!
*  \enum	eQueryStatus
*  \brief	ѯ״̬
*/
typedef enum eQueryStatus
{
	eQueryOK = 0,										/*!< ѯɹ								*/
	eQueryFailed,										/*!< ѯʧ								*/
	eQueryBusy,											/*!< ѯæ									*/
	eQueryFinished,										/*!< ѯ								*/
}eQueryStatus;

/*!
*  \enum	eRemoteDeviceControl
*  \brief	Զ豸
*/
typedef enum eRemoteDeviceControl
{
	eRemoteDeviceControlBegin = 0,						/*!< ʼֵ									*/
	eDeviceReboot,										/*!< 									*/
	eDeviceHalt,										/*!< ػ									*/
	eDeviceStandby,										/*!< 									*/
	eDeviceSetDefault,									/*!< ָϵͳĬ							*/
	eDeviceSendTestEmail,								/*!< Ͳʼ							*/
    eDeviceSetDefense,                                  /*!<                                    */
    eDeviceUnsetDefense,                                /*!<                                    */
	eDeviceDefaultISPCfg,								/*!< ISPĬ                            */
	eDeviceAdminDefaultPassword,						/*!< ָadminĬ                    */
	eDeviceDetectBadPoint,								/*!< ⻵								*/
	eDeviceStartDetect,									/*!< ʼ̽								*/
	eDeviceStopDetect,									/*!< ֹͣ̽								*/

	eRemotePreviewCruiseStart = 20,						/*!< Ԥת                     */
	eRemotePreviewCruiseStop,							/*!< ֹͣԤת                     */

	eDeviceResetImage,									/*!< ͼ,                    */
	eDeviceEnterAPMode,									/*!< APģʽ			                    */
	eDeviceStartVoice,									/*!< Խ								*/
	eDeviceStopVoice,									/*!< ֹͣԽ								*/
	eDeviceRestoreFactory,								/*!< ָ							*/
	eDeviceSendTestFTP,									/*!< ͲFTP							*/
	eDeviceGammaDefault,								/*!< Gamma߻ָĬ 						*/

	eDeviceOpenDoor = 100,					/*!< 	*/

	eRemoteDeviceControlEnd,						/*!< ֵ									*/
}eRemoteDeviceControl;

/*!
*  \enum	eDiskGroupType
*  \brief	 
*/
typedef enum eDiskGroupType
{
	eDiskGroupTypeBegin			= 0,					/*!< ʼֵ									*/
	eDiskGroupNormal,									/*!< ͨ								*/
	eDiskGroupAlarm,									/*!< 								*/
	eDiskGroupRedundance,				    			/*!< 								*/
	eDiskGroupBackup,			       	    			/*!< 								*/
	eDiskGroupTypeEnd,									/*!< ֵ									*/
}eDiskGroupType;

/*!
*  \enum	eDiskGroupOperation
*  \brief	Ӳ
*/
typedef enum eDiskGroupOperation
{
	eDiskGroupOperationBegin = 0,						/*!< ʼֵ									*/
	eUnMountDisk,										/*!< жӲ								*/
	eCreateNewPartition,								/*!< ·								*/
	eDeletePartition,									/*!< ɾ								*/
	eFormatPartition,									/*!< ʽ								*/
	eDiskGroupKeepTime,									/*!< 鱣ʱ						*/
	eDiskGroupBindChannel,								/*!< ͨ							*/
	eDiskGroupAddPartition,								/*!< ӷ							*/
	eDiskGroupDelPartition,								/*!< ӷɾ							*/
	eInitializeDisk,									/*!< ʼӲ								*/
	eDiskGroupOperationEnd,								/*!< ֵ									*/
}eDiskGroupOperation;

/*!
*  \enum	eTransferFileType
*  \brief	ļ
*/
typedef enum eTransferFileType
{
	eTransferFileTypeBegin		=	0,					/*!< ʼֵ									*/
	eFileSystemUpdate,									/*!< ļ								*/
	ePtzProtocol,										/*!< ̨Эļ							*/
	eDeviceConfig,										/*!< 豸ļ							*/
	ePicture,											/*!< ͼƬļ								*/
	eRecordSetFile,										/*!< ʷ¼ѯļ						*/	
	eDeviceDetectListFile,								/*!< 豸̽бļ						*/
	eTransferFileTypeEnd,								/*!< ֵ									*/
}eTransferFileType;

typedef enum eDataPacketType
{
	eDataTypeBegin = 0,
	eDataRequest,
	eDataPacket,
	eDataReply,
	eDataFinished,
	eDataCanceled,
	eDataError,
	eWriteError,
	eFlashFull,
	eFileCheckError,
	eFileAliveKeep,
	eDataTypeEnd,
}eDataPacketType;

/*!
*  \enum	eTaskStatus
*  \brief	״̬
*/
typedef enum eTaskStatus
{
	eTaskStatusBegin				=	0,				/*!< ʼֵ									*/
	eTaskStatusNone,									/*!< ״̬								*/
	eTaskStatusInitialize,								/*!< ʼ								*/
	eTaskStatusDestroy,									/*!< 								*/
	eTaskStatusStart,									/*!< 								*/
	eTaskStatusStop,									/*!< ֹͣ								*/
	eTaskStatusRun,										/*!< 								*/
	eTaskStatusRecover,									/*!< ָ								*/
	eTaskStatusEnd,										/*!< ֵ									*/
}eTaskStatus;

/*!
*  \enum	eVoiceMode
*  \ingroup DS_VoiceMode
*  \brief	ģʽ
*/
typedef enum eVoiceMode
{
	eVoiceModeBegin			=	0,						/*!< ʼֵ									*/
	eVoiceG726,											/*!< G726ģʽ							*/
	eVoiceG711U,										/*!< G711Uģʽ                        */
	eVoiceMPEG4AAC,										/*!< MPEG4 AACģʽ                    */
	eVoiceAutoDiscern,									/*!< Զʶģʽ						*/
	eVoiceADPCMima,										/*!< ADPCMimaģʽ						*/
	eVoiceG711A,										/*!< G711Aģʽ                        */
	eVoiceModeEnd,										/*!< ֵ									*/
}eVoiceMode;

/*!
*  \enum	eVideoCodecMode
*  \ingroup DS_VideoCodecMode
*  \brief	Ƶģʽ
*/
typedef enum eVideoCodecMode
{
	eVideoCodecModeBegin			=	0,				/*!< ʼֵ									*/
	eVideoCodecH264,									/*!< ׼H264ģʽ						*/
	eVideoCodecHYMpeg4,									/*!< HYMpeg4ģʽ                      */
	eVideoCodecHYH264,									/*!< HYH264ģʽ						*/
	eVideoCodecAutoDiscern,								/*!< Զʶģʽ						*/
	eVideoCodecModeEnd,									/*!< ֵ									*/
}eVideoCodecMode;

/*!
*  \enum	eFileTransferControl
*  \brief	ļ
*/
typedef enum eFileTransferControl
{
	eFileTransferControlBegin		=	0,				/*!< ʼֵ									*/
	eFileTransferStart,									/*!< ļת							*/
	eFileTransferStop,									/*!< ֹͣļ							*/
	eFileTransferControlend,							/*!< ʼֵ									*/
}eFileTransferControl;

/*!
*  \enum	ePTZControlCodeType
*  \brief	PTZ̨
*/
typedef enum ePTZControlCmdCode
{
    ePTZControlCodeAllOff               = 0	,			//	ر(Ͽ)п	(Param1: Ч, Param2: Ч, Param3: Ч, Param4: Ч)		
    ePTZControlCodeCameraPower          = 1	,			//	ͨԴ		(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeLightPower           = 2	,			//	ͨƹԴ			(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeWiper                = 3	,			//	ͨˢ			(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeFans                 = 4	,			//	ͨȿ			(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeHeater               = 5	,			//	ͨ		(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeAuxEquiment          = 6	,			//	ͨ豸		(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)

    ePTZControlCodeStopContinue         = 10,			//	ֹͣ(ͷ,̨)	(Param1: Ч, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeZoomIn               = 11,			//	(ʱ)		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeZoomOut              = 12,			//	С(ʱС)		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeFocusNear            = 13,			//	ǰ				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeFocusFar             = 14,			//					(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeApertureUp           = 15,			//	Ȧ				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeApertureDown         = 16,			//	ȦС				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeAutoZoom             = 17,			//	Զ(Զ)	(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeAutoFocus            = 18,			//	Զ			(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeAutoAperture         = 19,			//	ԶȦ			(Param1: 1-ʼ/0-ֹͣ, Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeUp                   = 21,			//	̨				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeDown                 = 22,			//	̨¸				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeLeft                 = 23,			//	̨ת				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeRight                = 24,			//	̨ת				(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeUpLeft               = 25,			//	̨ת		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeUpRight              = 26,			//	̨ת		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeDownLeft             = 27,			//	̨¸ת		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeDownRight            = 28,			//	̨¸ת		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)
    ePTZControlCodeAutoLeftRight        = 29,			//	̨Զɨ		(Param1: 1-ʼ/0-ֹͣ, Param2: ٶ [0-10,0ʾĬٶ,1-10ʾٶȼ], Param3: Ч, Param4: Ч)

	ePTZControlCodePresetSet            = 40,			//	Ԥõ			(Param1: Ԥõ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodePresetClear          = 41,			//	Ԥõ			(Param1: Ԥõ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodePresetCall           = 42,			//	תԤõ			(Param1: Ԥõ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)

    ePTZControlCodeCuriserSetStart      = 51,			//	Ѳ			(Param1: Ѳ·ߺ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeCuriserSetStop       = 52,			//	رѲ			(Param1: Ѳ·ߺ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeCuriserAddPreset     = 53,			//	ԤõѲ	(Param1: Ѳ·ߺ[>=0], Param2: Ԥõ[>=0], Param3: ͣʱ[,>=0], Param4: Ѳٶ[1-10])
    ePTZControlCodeCuriserRunStart      = 54,			//	ʼѲ				(Param1: Ѳ·ߺ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeCuriserRunStop       = 55,			//	ֹͣѲ				(Param1: Ѳ·ߺ[>=0], Param2: Ч, Param3: Ч, Param4: Ч)

    ePTZControlCodeTraceSetStart        = 61,			//	켣			(Param1: 켣[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeTraceSetStop         = 62,			//	رչ켣			(Param1: 켣[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeTraceRunStart        = 63,			//	ʼ켣				(Param1: 켣[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeTraceRunStop         = 64,			//	ֹͣ켣				(Param1: 켣[>=0], Param2: Ч, Param3: Ч, Param4: Ч)
    ePTZControlCodeSystemReset          = 99,			//	ϵͳλ				(Param1: Ч, Param2: Ч, Param3: Ч, Param4: Ч)

}ePTZControlCmdCode;

/*!
*  \enum	eHistoryLogMajorType
*  \brief	־ѯ
*/
typedef enum eHistoryLogMajorType
{
	eHistoryLogMajorTypeBegin	=	0,					/*!< ʼֵ									*/
	eHistoryLogSysOperation,							/*!< ϵͳ־							*/
	eHistoryLogSysSetting,								/*!< ϵͳ־							*/
	eHistoryLogRecord,									/*!< ¼־								*/
	eHistoryLogUserManage,								/*!< û־							*/
	eHistoryLogAlarm,									/*!< 豸־							*/
	eHistoryLogException,								/*!< 豸쳣־							*/
	eHistoryLogStorage,									/*!< 洢־							*/
	eHistoryLogNetWork,									/*!< ¼								*/
	eHistoryLogMajorAll,								/*!< 								*/
	eHistoryLogAIGate,									/*!< Ž¼־					*/
	eHistoryLogMajorTypeEnd,							/*!< ֵ									*/
}eHistoryLogMajorType;

/*!
*  \enum	eHistoryLogMinorType
*  \brief	־ѯ
*/
typedef enum eHistoryLogMinorType
{
	eHistoryLogSysOpAll				= 0,				/*!< ϵͳ						*/
	eHistoryLogSysOpUpdate,								/*!< ϵͳ								*/
	eHistoryLogSysOpPTZControl,							/*!< ̨								*/
	eHistoryLogSysOpIllShutdown,						/*!< Ƿػ								*/
	eHistoryLogSysOpPowerOff,							/*!< ػ								*/
	eHistoryLogSysOpPowerOn,							/*!< 									*/
	eHistoryLogSysOpRemoteReset,						/*!< Զ								*/
	eHistoryLogSysOpClearAlarm,							/*!< 									*/
	eHistoryLogLocalPlayback,							/*!< ػط								*/
	eHistoryLogLocalBackup,								/*!< ر								*/
	eHistoryLogRemotePlaybackAndBackup,					/*!< Զ̱ݺͻط							*/

	eHistoryLogSysSetAll			= 100,				/*!< ϵͳ						*/
	eHistoryLogSysSetTimeSetting,						/*!< ¼ʱ							*/
	eHistoryLogSysSetCommonSetting,						/*!< ͨ								*/
	eHistoryLogSysSetCodecSetting,						/*!< 								*/
	eHistoryLogSysSetNetSetting,						/*!< 								*/
	eHistoryLogSysSetServerSetting,						/*!< 								*/
	eHistoryLogSysSetMotionSetting,						/*!< ƶ							*/
	eHistoryLogSysSetPTZSetting,						/*!< ̨							*/
	eHistoryLogSysSetDefaultSetting,					/*!< ָĬ							*/
	eHistoryLogSysSetDisplayDeviceSetting,				/*!< ʾ豸						*/
	eHistoryLogSysSetDisplayModeSetting,				/*!< ʾģʽ							*/
	eHistoryLogSysSetPictureSetting,					/*!< ͼɫ							*/
	eHistoryLogSysSetMaintainSetting,					/*!< Զά							*/
	eHistoryLogSysSetAlarmOutSetting,					/*!< 							*/
	eHistoryLogSysSetAlarmInSetting,					/*!< 							*/
	eHistoryLogSysSetCustomizeFunction,					/*!< ܶ							*/
	eHistoryLogSysSetImportPTZProtocol,					/*!< ̨Э							*/
	eHistoryLogSysSetExportPTZProtocol,					/*!< ̨Э							*/
	eHistoryLogSysSetImportSettings,					/*!< 							*/
	eHistoryLogSysSetExportSettings,					/*!< 							*/
	eHistoryLogSysSetExceptionSetting,					/*!< 쳣							*/
	eHistoryLogSysSetIpConflick=122,						/*!< IPͻ									*/

	eHistoryLogRecordAll			= 200,				/*!< ¼						*/
	eHistoryLogRecordStartManual,						/*!< ֶ¼							*/
	eHistoryLogRecordStartAuto,							/*!< Զ¼							*/
	eHistoryLogRecordStop,								/*!< ֹͣ								*/

	eHistoryLogUserAll				= 300,				/*!< û						*/
	eHistoryLogUserAdd,									/*!< û								*/
	eHistoryLogUserDelete,								/*!< ɾû								*/
	eHistoryLogUserEdit,								/*!< ޸û							*/
	eHistoryLogUserLogin,								/*!< û¼								*/
	eHistoryLogUserLogout,								/*!< ûǳ								*/

	eHistoryLogAlarmAll				= 400,				/*< 							*/
	eHistoryLogAlarmMotionStart,						/*!< ƶ⿪ʼ							*/
	eHistoryLogAlarmMotionStop,							/*!< ƶ							*/
	eHistoryLogAlarmInputAlarm,							/*!< 뱨ʼ							*/

	eHistoryLogExceptionAll			= 500,				/*!< 쳣							*/
	eHistoryLogExceptionIpConflict,						/*!< IPͻ									*/
	eHistoryLogExceptionHardDiskFull,					/*!< Ӳ									*/
	eHistoryLogExceptionHardDiskError,					/*!< Ӳ̳								*/
	eHistoryLogExceptionIllegalAccess,					/*!< Ƿ								*/
	eHistoryLogExceptionSignalLost,						/*!< źŶʧ								*/
	eHistoryLogExceptionSignalRecover,					/*!< źŻָ								*/
	eHistoryLogExceptionNetDisconnect,					/*!< ߶									*/

	eHistoryLogStorageAll			= 600,				/*!< 洢						*/
	eHistoryLogStorageFormatPartition,					/*!< ʽ								*/
	eHistoryLogStorageAddPartition,						/*!< ӷ								*/
	eHistoryLogStorageRemovePartition,					/*!< ɾ								*/
	eHistoryLogStorageUnmountDisk,						/*!< жӲ								*/
	eHistoryLogStorageDiskGroupOperation,				/*!< ̷							*/

	eHistoryLogNetworkAll			= 700,				/*!< ¼						*/
	eHistoryLogNetworkConnectSuccess,					/*!< ӳɹ							*/
	eHistoryLogNetworkConnectFailed,					/*!< ʧ							*/
	eHistoryLogNetworkDisconnect,						/*!< Ͽʱ䡡							*/
	eHistoryLogNetworkRecover,							/*!< ָ								*/
	eHistoryLogNetworkActiveDisconnect,					/*!< Ͽ							*/

	eHistoryLogAIGateAll			= 800,				/*!< Ž¼					*/
	eHistoryLogAIGateFaceRecognitionOpen,				/*!< ȶԿţEventGateFaceRecognition*/
	eHistoryLogAIGateKeyboardOpen,						/*!< 뿪ţEventGateKeyboard			*/
	eHistoryLogAIGateCardOpen,							/*!< ˢţEventGateCard				*/
	eHistoryLogAIGateButtonOpen,						/*!< ţޣ							*/
	eHistoryLogAIGateRemoteOpen,						/*!< Զ̿ţEventGateRemote  */
}eHistoryLogMinorType;

/*!
*  \enum	eFrameType
*  \ingroup DS_FrameType
*  \brief	֡
*/
typedef enum eFrameType
{
	eFrameError								= 0x0000,
	eFrameIFrames							= 0x0001,	//I֡
	eFramePFrames							= 0x0002,
	eFrameBPFrames 							= 0x0020,
	eFrameBBPFrames 						= 0x0004,
	eFrameAudioFrames 						= 0x0008,
	eFrameQCIFIFrames						= 0x0010,	//QCIFI֡
	eFramePktSQCIFIFrames 					= 0x0011,	//I֡
	eFrameQCIFPFrames 						= 0x0040,
	eFramePktSQCIFPFrames 					= 0x0041,	//P֡
	eFrameAIFrames							= 0x0086,	//AI֡
	eFrameBIFrames							= 0x0090,
	eFrameBBIFrames							= 0x00C0,
	eFrameSysHeader							= 0x0080,	//ϵͳͷ
	eFramePktSysHeaderAux					= 0x0081,	//ϵͳͷ
	eFramePktSysHeaderHDAux					= 0x0082,	//ϵͳͷ
	eFrameSFrames 							= 0x0200,
	eFrameDspStatus 						= 0x0100,
	eFrameAimDetection						= 0x0400,
	eFrameOrigImage							= 0x0800,
	eFrameMotionDetection 					= 0x1000,
}eFrameType;

/*!
*  \enum	ePanelKeyBoardCodeType
*  \brief	ֵ
*/
typedef enum ePanelKeyBoardCodeType
{
	ePanelKeyBoardTypeBegin						= 0x0,		/*!< ʼֵ									*/
	ePanelKeyBoardCode_0						= 0x1,		/*!< Ӧ:0								*/
	ePanelKeyBoardCode_1						= 0x2,		/*!< Ӧ:1								*/
	ePanelKeyBoardCode_2 						= 0x3,		/*!< Ӧ:2								*/
	ePanelKeyBoardCode_3 						= 0x4,		/*!< Ӧ:3								*/
	ePanelKeyBoardCode_4 						= 0x5,		/*!< Ӧ:4								*/
	ePanelKeyBoardCode_5 						= 0x6,		/*!< Ӧ:5								*/
	ePanelKeyBoardCode_6 						= 0x7,		/*!< Ӧ:6								*/
	ePanelKeyBoardCode_7 						= 0x8,		/*!< Ӧ:7								*/
	ePanelKeyBoardCode_8 						= 0x9,		/*!< Ӧ:8								*/
	ePanelKeyBoardCode_9 						= 0xA,		/*!< Ӧ:9								*/
	ePanelKeyBoardCode_10 						= 0xB,		/*!< Ӧ:10								*/
	ePanelKeyBoardCode_11 						= 0xC,		/*!< Ӧ:11								*/
	ePanelKeyBoardCode_12 						= 0xD,		/*!< Ӧ:12								*/
	ePanelKeyBoardCode_13 						= 0xE,		/*!< Ӧ:13								*/
	ePanelKeyBoardCode_14 						= 0xF,		/*!< Ӧ:14								*/
	ePanelKeyBoardCode_15 						= 0x10,		/*!< Ӧ:15								*/
	ePanelKeyBoardCode_16 						= 0x11,		/*!< Ӧ:16								*/
	ePanelKeyBoardCode_PTZ						= 0x40,		/*!< Ӧ:̨							*/
	ePanelKeyBoardCode_Copy						= 0x41,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Multi					= 0x42,		/*!< Ӧ:໭							*/
	ePanelKeyBoardCode_Switch					= 0x43,		/*!< Ӧ:л							*/
	ePanelKeyBoardCode_Function					= 0x44,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Play						= 0x45,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Backward 				= 0x46,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Record					= 0x47,		/*!< Ӧ:¼							*/
	ePanelKeyBoardCode_ESC						= 0x48,		/*!< Ӧ:˳							*/
	ePanelKeyBoardCode_Left						= 0x49,		/*!< Ӧ:								*/
	ePanelKeyBoardCode_Right					= 0x4A,		/*!< Ӧ:								*/
	ePanelKeyBoardCode_Up						= 0x4B,		/*!< Ӧ:								*/
	ePanelKeyBoardCode_Down						= 0x4C,		/*!< Ӧ:								*/
	ePanelKeyBoardCode_Enter					= 0x4D,		/*!< Ӧ:ȷ							*/
	ePanelKeyBoardCode_Shutdown 				= 0x4E,		/*!< Ӧ:ػ							*/
	ePanelKeyBoardCode_TV_VGA					= 0x4F,		/*!< Ӧ:TV/VGA							*/
	ePanelKeyBoardCode_Edit						= 0x50,		/*!< Ӧ:༭							*/
	ePanelKeyBoardCode_Language					= 0x51,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Mute						= 0x52,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Pause					= 0x53,		/*!< Ӧ:ͣ							*/
	ePanelKeyBoardCode_Stop						= 0x54,		/*!< Ӧ:ֹͣ							*/
	ePanelKeyBoardCode_AlarmClear				= 0x55,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_Defence					= 0x56,		/*!< Ӧ:						*/
	ePanelKeyBoardCode_Capture					= 0x57,		/*!< Ӧ:ץͼ							*/
	ePanelKeyBoardCode_LightAdd					= 0x58,		/*!< Ӧ:						*/
	ePanelKeyBoardCode_LightSub					= 0x59,		/*!< Ӧ:ȼ						*/
	ePanelKeyBoardCode_ContrastAdd				= 0x5A,		/*!< Ӧ:Աȶ						*/
	ePanelKeyBoardCode_ContrastSub				= 0x5B,		/*!< Ӧ:Աȶȼ						*/
	ePanelKeyBoardCode_SpeedAdd					= 0x5C,		/*!< Ӧ:ٶ						*/
	ePanelKeyBoardCode_SpeedSub					= 0x5D,		/*!< Ӧ:ٶȼ						*/
	ePanelKeyBoardCode_Set						= 0x5E,		/*!< Ӧ:							*/
	ePanelKeyBoardCode_F1						= 0x5F,		/*!< Ӧ:F1								*/
	ePanelKeyBoardTypeEnd,									/*!< ֵ									*/
}ePanelKeyBoardCodeType;

/*!
*  \enum	ePanelControlType
*  \brief	
*/
typedef enum ePanelControlType
{
	ePanelControlBegin							= 0,		/*!< ʼֵ									*/
	ePanelControlKeyDown,									/*!< 									*/
	ePanelControlKeyUp,										/*!< 									*/
	ePanelControlClick,										/*!< (²)						*/
	ePanelControlEnd,										/*!< ֵ									*/
}ePanelControlType;

/*!
*  \enum	eDecoderChannelStatus
*  \ingroup DS_DecoderChannelStatus
*  \brief	ͨ״̬
*/
typedef enum eDecoderChannelStatus
{
	eDecoderChannelStatusBegin					= 0,		/*!< ʼֵ									*/
	eDecoderChannelStatusOpen,								/*!< 									*/
	eDecoderChannelStatusClose,								/*!< ر									*/
	eDecoderChannelStatusContinue,							/*!< 									*/
	eDecoderChannelStatusEnd,								/*!< ֵ									*/
}eDecoderChannelStatus;

/*!
*  \enum	eStreamSourceType
*  \ingroup DS_StreamSourceType
*  \brief	ýԴ
*/
typedef enum eStreamSourceType
{
	eStreamSourceTypeBegin						= 0,		/*!< ʼֵ									*/
	eStreamSourceTypeReal,									/*!< ʵʱ									*/
	eStreamSourceTypeHistory,								/*!< ʷ									*/
	eStreamSourceTypeEnd,									/*!< ֵ									*/
}eStreamSourceType;

/*!
*  \enum	eStreamPlayControlStatus
*  \ingroup DS_StreamPlayControlStatus
*  \brief	ý岥ſ״̬
*/
typedef enum eStreamPlayControlStatus
{
	eStreamPlayControlBegin						= 0,		/*!< ʼֵ									*/
	eStreamPlayControlPlay,									/*!< 									*/
	eStreamPlayControlSuspend,								/*!< ͣ									*/
	eStreamPlayControlResume,								/*!< ָ									*/
	eStreamPlayControlStop,									/*!< ֹͣ									*/
	eStreamPlayControlFast,									/*!< ٲ								*/
	eStreamPlayControlSlow,									/*!< ٲ								*/
	eStreamPlayControlNormal,								/*!< ٶ								*/
	eStreamPlayControlOneByOne,								/*!< ֡								*/
	eStreamPlayControlOpenAudio,							/*!< 								*/
	eStreamPlayControlCloseAudio,							/*!< ر								*/
	eStreamPlayControlSetPos,								/*!< λ								*/
	eStreamPlayControlClearBuffer,							/*!< ջ								*/
	eStreamPlayControlEnd,									/*!< ֵ									*/
}eStreamPlayControlStatus;

/*!
*  \enum	eDisplayControlStatus
*  \ingroup DS_DisplayControlStatus
*  \brief	ʾ״̬
*/
typedef enum eDisplayControlStatus
{
	eDisplayControlStatusBegin					= 0,		/*!< ʼֵ									*/
	eDisplayControlStatusEnlarge,							/*!< Ŵʾ								*/
	eDisplayControlStatusRenew,								/*!< ԭ									*/
	eDisplayControlStatusEnd,								/*!< ֵ									*/
}eDisplayControlStatus;

/*!
*  \enum	eScreenControlStatus
*  \ingroup DS_ScreenControlStatus
*  \brief	Ļ״̬
*/
typedef enum eScreenControlStatus
{
	eScreenControlStatusBegin					= 0,			/*!< ʼֵ									*/
	eScreenControlStatusLoopStart,							/*!< ʼת									*/
	eScreenControlStatusLoopStop,							/*!< ֹͣת									*/
	eScreenControlStatusSplitSingle,						/*!< 									*/
	eScreenControlStatusSplitThree,						/*!< 									*/
	eScreenControlStatusSplitFour,							/*!< Ļ									*/
	eScreenControlStatusSplitSix,							/*!< 									*/
	eScreenControlStatusSplitNine,							/*!< Ż									*/
	eScreenControlStatusSplitTen,							/*!< ʮ									*/
	eScreenControlStatusSplitTwelve,						/*!< ʮ									*/
	eScreenControlStatusSplitThirteen,						/*!< ʮ									*/
	eScreenControlStatusSplitFifteen,						/*!< ʮ廭									*/
	eScreenControlStatusSplitSixteen,						/*!< ʮ									*/
	eScreenControlStatusEnd,								/*!< ֵ									*/
}eScreenControlStatus;

/*!
*  \enum	eResolutionMode
*  \ingroup DS_ResolutionMode
*  \brief	ֱģʽ
*/
typedef enum eResolutionMode
{
	eResolutionModeBegin					=	0,			/*!< ʼֵ									*/
	eResolutionModeAutoDiscern,							/*!< Զʶֱ								*/
	eResolutionModeQCIF,									/*!< QCIF (176*144)							*/
	eResolutionModeCIF,										/*!< CIF (352*288 / 320*240 / 352*240)			*/
	eResolutionModeHalfD1,									/*!< HalfD1 (704*288 / 640*240 / 704*240)		*/
	eResolutionModeD1,										/*!< D1	(704*576 / 640*480 / 704*480)			*/
	eResolutionModeDCIF,									/*!< DCIF (528*384 / 480*240)					*/
	eResolutionModeMD,										/*!< MD	(512*288 / 416*240)					*/
	eResolutionModeVGA,										/*!< VGA (640*480)							*/
	eResolutionModeHD720,									/*!< HD720 (1280*720)						*/
	eResolutionModeQuadVGA,									/*!< QuadVGA (1280*960)						*/
	eResolutionModeUXGA,									/*!< UXGA (1600*1200)						*/
	eResolutionModeHD1080,									/*!< HD1080 (1920*1080)						*/
	eResolutionModeEnd,										/*!< ֵ									*/
}eResolutionMode;

/*!
*  \enum	eVGAResolutionMode
*  \ingroup DS_VGAResolutionMode
*  \brief	VGAֱ
*/
typedef enum eVGAResolutionMode
{
	VGA_SVGA_800x600_60HZ 					= 0,
	VGA_SVGA_800x600_75HZ,
	VGA_XGA_1024x768_60HZ,
	VGA_XGA_1024x768_70HZ,
	VGA_SXGA_1280x1024_60HZ,
	VGA_1280x720P_60HZ,
	VGA_1920x1080i_60HZ,
	VGA_1920x1080p_60HZ
}eVGAResolutionMode;

typedef enum eResolutionIndex
{
	eResolutionIndex_CIF,		//352*288
	eResolutionIndex_D1,		//704*576

	eResolutionIndex_SD,
	eResolutionIndex_QuadVGA,	//1280*960
	eResolutionIndex_SXGA,		//1280*1024
	eResolutionIndex_UXGA,		//1600*1200

	eResolutionIndex_720P,		//1280*720
	eResolutionIndex_1080P,		//1920*1080

	eResolutionIndex_VGA,		//640*480

	eResolutionIndex_QXGA,		//2048x1536
	eResolutionIndex_640x360,	//640*360
	eResolutionIndex_QVGA,		//320*240
	eResolutionIndex_UWXGA,		//2592*1520
	eResolutionIndex_USXGA,		//2592*1944
	eResolutionIndex_480X256,	//480*256
	eResolutionIndex_320X176,	//320*176
	eResolutionIndex_960H=20,	//960*576
	eResolutionIndex_1024x1536, //1024*1536
	eResolutionIndex_QCIF,		//176*144
	eResolutionIndex_WQXGA,		//2304*1728
	eResolutionIndex_QSXGA,		//2592*1920
	eResolutionIndex_1080N=30,  //960*1080
	eResolutionIndex_4M_N,      // 1280*1520
	eResolutionIndex_5M_N,      // 1280*1944
}eResolutionIndex;

/*!
*  \enum	eLogoPictureType
*  \ingroup DS_LogoPictureType
*  \brief	LogoͼƬ
*/
typedef enum eLogoPictureType
{
	eLogoPictureTypeBegin					= 0,		/*!< ʼֵ									*/
	eLogoPictureTypeDecoderChannel,						/*!< ͨLOGO							*/
	eLogoPictureTypeEnd,								/*!< ֵ									*/
}eLogoPictureType;

/*!
*  \enum	eDeviceChannelControl
*  \ingroup DS_DeviceChannelControl
*  \brief	豸ͨ
*/
typedef enum eDeviceChannelControl
{
	eDeviceChannelControlBegin		 = 0,				/*!< ʼֵ									*/
	eDeviceChannelControlShowLogo,						/*!< ʾLOGO								*/
	eDeviceChannelControlHideLogo,						/*!< LOGO								*/
	eDeviceChannelControlEnd,							/*!< ֵ									*/
}eDeviceChannelControl;

/*!
*  \enum	eDeviceProtocolType
*  \ingroup DS_DeviceProtocolType
*  \brief	豸Э
*/
typedef enum eDeviceProtocolType
{
	eDeviceProtocolTypeBegin		 = 0,				/*!< ʼֵ									*/
	eDeviceProtocolTypeAdapter,							/*!< Ӧ汾								*/
	eDeviceProtocolTypeClassics,						/*!< 汾								*/
	eDeviceProtocolTypeNewborn,							/*!< °汾									*/
	eDeviceProtocolTypeEnd,								/*!< ֵ									*/
}eDeviceProtocolType;

/*!
*  \enum	eNetworkSDKVersion
*  \ingroup DS_NetworkSDKVersion
*  \brief	
*/
typedef enum eNetworkSDKVersion
{
	eNetworkSDKVersionUnkown		 = 0,					/*!< δ֪汾								*/
	eNetworkSDKVersion1,								/*!< Ӧhieclient.dll						*/
	eNetworkSDKVersion2,								/*!< ӦHieClientUnit.dll					*/
}eNetworkSDKVersion;




enum
{
	DEV_STATUS_BASE = 0,				//δ

	DEV_STATUS_CONNECTING,				//
	DEV_STATUS_CONNECT_SUC,				//ӳɹ
	DEV_STATUS_LOGIN_FAIL,				//ʧ:û
	DEV_STATUS_CONNECT_LIMIT,			//ʧ:
	DEV_STATUS_COMMUNICATE_ERR,			//ʧ:ͨѶ쳣
	DEV_STATUS_CONNECT_FAIL_OTHER,		//ʧ:	
	DEV_STATUS_DISCONNECTED,			//ѶϿ
	DEV_STATUS_GETCONFIG_FAIL,			//ȡʧ
	DEV_STATUS_NETWORK_DISCONNECT,		//Ͽ
	DEV_STATUS_IP_SAME,		//ipͻ

	DEV_STATUS_END,							
};


//////////////////////////////////////////////////////////////////////////
//ṹ
//////////////////////////////////////////////////////////////////////////

/*!
*  \struct	tagTimeInfo
*  \ingroup DS_TimeInfo
*  \brief	ʱϢ
*/
typedef struct tagTimeInfo
{
	WORD	wYear;										/*!< 										*/
	WORD	wMonth;										/*!< 										*/
	WORD	wDay;										/*!< 										*/
	WORD	wHour;										/*!< ʱ										*/
	WORD	wMinute;									/*!< 										*/
	WORD	wSecond;									/*!< 										*/
}TimeInfo, *LPTimeInfo;

/*!
*  \struct	tagAbsoluteTime
*  \ingroup DS_AbsoluteTime
*  \brief	ʱϢ
*/
typedef struct tagAbsoluteTime
{
	WORD	wYear;										/*!< 										*/
	WORD	wMonth;										/*!< 										*/
	WORD	wWeek;										/*!< 										*/
	WORD	wDay;										/*!< 										*/
	WORD	wHour;										/*!< ʱ										*/
	WORD	wMinute;									/*!< 										*/
	WORD	wSecond;									/*!< 										*/
	WORD	wMillisecond;								/*!< 									*/
}AbsoluteTime, *LPAbsoluteTime;

/*!
*  \struct	tagBuffer
*  \ingroup DS_Buffer
*  \brief	Ϣ
*/
typedef struct tagBuffer
{
	BYTE	*pBuffer;									/*!< ýݻ							*/
	DWORD	dwBufLen;									/*!< ýݳ							*/
}Buffer, *LPBuffer;

/*!
*  \struct	tagUserLoginPara
*  \ingroup DS_UserLoginPara
*  \brief	û¼
*/
typedef struct tagUserLoginPara
{
	char	sServerIP[MAX_ADDRESS_LEN];					/*!< IPַ							*/
	DWORD	dwCommandPort;								/*!< ¼ӵ˿						*/
	char	sUName[USERNAME_LEN];						/*!< ¼ûû						*/
	char	sUPass[USERPASS_LEN];						/*!< ¼ûû						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}UserLoginPara, *LPUserLoginPara;

/*!
*  \struct	tagConfigInformation
*  \brief	ԶϢ
*/
typedef struct tagConfigInformation
{
	DWORD	dwMainCommand;								/*!< Ϣ						*/
	DWORD	dwAssistCommand;							/*!< Ϣ						*/
	char	sConfig[MAX_CFG_LEN];						/*!< Ϣ							*/
	DWORD	dwConfigLen;								/*!< Ϣ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}ConfigInformation, *LPConfigInformation;

/*!
*  \struct	tagConfigInformationV2
*  \brief	ԶϢ(V2)
*/
typedef struct tagConfigInformationV2
{
	DWORD	dwMainCommand;								/*!< Ϣ						*/
	DWORD	dwAssistCommand;							/*!< Ϣ						*/
	DWORD	dwConfigLen;								/*!< Ϣ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
	char	sConfig[MAX_CFG_LEN_V2];					/*!< Ϣ							*/
}ConfigInformationV2, *LPConfigInformationV2;

/*!
*  \struct	tagConfigInformationV3
*  \brief	ԶϢ(V3), ڻȡ32֮ͨͨ
*/
typedef struct tagConfigInformationV3
{
	DWORD	dwMainCommand;								/*!< Ϣ						*/
	DWORD	dwAssistCommand;							/*!< Ϣ						*/
	DWORD	dwConfigLen;								/*!< Ϣ							*/
	DWORD   dwBeginChannel;								/*!< ʼͨ*/
	DWORD	dwReserve[DEF_RESERVE_NUM-1];					/*!< 									*/
	char	sConfig[MAX_CFG_LEN_V2];					/*!< Ϣ							*/
}ConfigInformationV3, *LPConfigInformationV3;


/*!
*  \struct	tagStreamMediaFrame
*  \brief	ý֡Ϣ
*/
typedef struct tagStreamMediaFrame
{
	DWORD	dwChannel;									/*!< ͨ									*/
	Buffer	cFrameBuffer;								/*!< ֡								*/
	AbsoluteTime	cFrameTime;							/*!< ֡ʱ									*/
	DWORD	dwFrameType;								/*!< ֡(eFrameType)				*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}StreamMediaFrame, *LPStreamMediaFrame;

/*!
*  \struct	tagStreamVoiceFrame
*  \brief	֡Ϣ
*/
typedef struct tagStreamVoiceFrame
{
	Buffer	cFrameBuffer;								/*!< ֡								*/
	eVoiceStreamSource	eVoiceSource;					/*!< ֡Դ									*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}StreamVoiceFrame, *LPStreamVoiceFrame;

/*!
*  \struct	tagRealStreamPara
*  \ingroup DS_RealStreamPara
*  \brief	ʵʱӲ
*/
typedef struct tagRealStreamPara
{
	DWORD	dwChannel;									/*!< ͨ							*/
	eStreamTransferMode	eTransferMode;					/*!< ģʽ								*/
	eStreamMediaType	eMediaType;						/*!< ý								*/
	WORD    wMediaPort;									/*!< ָֹý˿						*/	
	WORD    wRTPPort;									/*!< ָֹRTP˿						*/	
	DWORD	dwReserve[DEF_RESERVE_NUM-1];					/*!< 									*/
}RealStreamPara, *LPRealStreamPara;


/*!
*  \struct	tagRemoteDesktopStreamPara
*  \ingroup DS_RemoteDesktopStreamPara
*  \brief	ԶӲ
*/
typedef struct tagRemoteDesktopStreamPara
{
	DWORD	dwChannel;									/*!< ͨ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}RemoteDesktopStreamPara, *LPRemoteDesktopStreamPara;


/*!
*  \struct	tagRemoteDesktopStreamOpereatePara
*  \ingroup DS_RemoteDesktopStreamOpereatePara
*  \brief	Զ
*/
typedef struct tagRemoteDesktopStreamOpereatePara
{
	DWORD	m_dwOperateType;												/*!< 0,ʾ1ʾм2ʾҼ   */
	DWORD	m_dwAction;														/*!< 0,up,1,down,2,move,3.wheelup,4,wheeldown */
	DWORD	m_dwPosX;
	DWORD	m_dwPosY;
	DWORD	m_dwWheel;
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}RemoteDesktopStreamOpereatePara, *LPRemoteDesktopStreamOpereatePara;



/*!
*  \struct	tagChannelOSDInformation
*  \ingroup DS_ChannelOSDInformation
*  \brief	ͨOSDϢ
*/
typedef struct tagChannelOSDInformation
{
	DWORD	dwEnable;									/*!< : 0Ϊ, 1Ϊ				*/
	char	cOSDText[MAX_OSD_TEXT_STRING_LENGTH];		/*!< OSDϢ								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}ChannelOSDInformation, *LPChannelOSDInformation;

/*!
*  \struct	tagStreamTransferPara
*  \ingroup DS_VoiceInteract_CodecPara
*  \brief	תӲ
*/
typedef struct tagStreamTransferPara
{
	eStreamTransferMode	eTransferMode;					/*!< ģʽ								*/
	eStreamSourceType eStreamSourceValue;				/*!< ýԴ							*/
	eVideoCodecMode	eVideoCodecValue;					/*!< Ƶģʽ							*/
	eVoiceMode	eVoiceCodecValue;						/*!< Ƶģʽ							*/
	eResolutionMode	eResolutionValue;					/*!< ͼֱģʽ							*/
	ChannelOSDInformation	cOSDInfo;					/*!< OSDϢṹ							*/
	WORD dwMediaPort;
	WORD dwRTPPort;
	DWORD	dwReserve[DEF_RESERVE_NUM-1];					/*!< 									*/
}StreamTransferPara, *LPStreamTransferPara;

/*!
*  \struct	tagMediaServerInformation
*  \ingroup DS_MediaServerInformation
*  \brief	ýϢ
*/
typedef struct tagMediaServerInformation
{
	DWORD	dwEnable;									/*!< : 0Ϊ, 1Ϊ				*/
	char	sServerIP[MAX_ADDRESS_LEN];					/*!< IPַ							*/
	DWORD	dwServerPort;								/*!< ¼ӵķ˿					*/
	char	sUName[USERNAME_LEN];						/*!< ¼ûû						*/
	char	sUPass[USERPASS_LEN];						/*!< ¼ûû						*/
	eRTPStreamTransferMode	eRTPStreamTransferValue;	/*!< RTPģʽ							*/
	char	sChannel[MAX_RTSP_SOURCE_STRING_LENGTH];	/*!< Ƶͨ								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}MediaServerInformation, *LPMediaServerInformation;

/*!
*  \struct	tagHistoryStreamPara
*  \ingroup DS_HistoryStreamPara
*  \brief	ʷӲ
*/
typedef struct tagHistoryStreamPara
{
	DWORD	dwDiskGroup;								/*!< 									*/
	DWORD	dwChannel;									/*!< ýͨ							*/
	DWORD		dwEnableEndTime;						/*!< ʱǷЧ						*/
	TimeInfo	cBeginTime;								/*!< ʷʼʱ							*/
	TimeInfo	cEndTime;								/*!< ʷʱ							*/
	eHistoryStreamType	eStreamType;					/*!< ʷ								*/
	eStreamTransferMode	eTransferMode;					/*!< ģʽ								*/
	char	cStreamMediaType;							/*!< ý 0ʾ1ʾ	*/
	char	cReserve[1]	;								/*!< 									*/
	WORD    wMediaPort;									/*!< ֶָý˿						*/
	WORD    wRTPPort;									/*!< ֶָRTP˿						*/
	char	cReserve2[2]	;							/*!< 									*/
	DWORD	dwReserve[DEF_RESERVE_NUM - 2];				/*!< 									*/
}HistoryStreamPara, *LPHistoryStreamPara;

/*!
*  \struct	tagHYPrivateServerInformation
*  \ingroup DS_HYPrivateServerInformation
*  \brief	HY˽ЭϢ
*/
typedef struct tagHYPrivateServerInformation
{
	DWORD	dwEnable;									/*!< : 0Ϊ, 1Ϊ				*/
	eDeviceProtocolType	eDeviceProtocolValue;			/*!< 豸Э汾						*/
	eStreamSourceType	eStreamSourceValue;				/*!< ýԴ							*/
	UserLoginPara	cUserLoginPara;						/*!< ¼Ϣ							*/
	RealStreamPara	cRealStreamPara;					/*!< ʵʱϢ							*/
	HistoryStreamPara cHistoryStreamPara;				/*!< ʷϢ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}HYPrivateServerInformation, *LPHYPrivateServerInformation;

/*!
*  \struct	tagLocalHistoryInformation
*  \ingroup DS_LocalHistoryInformation
*  \brief	ʷϢ
*/
typedef struct tagLocalHistoryInformation
{
	DWORD		dwEnable;								/*!< : 0Ϊ, 1Ϊ				*/
	DWORD		dwEnableEndTime;						/*!< ʱǷЧ						*/
	TimeInfo	cBeginTime;								/*!< ʷʼʱ							*/
	TimeInfo	cEndTime;								/*!< ʷʱ							*/
	eHistoryStreamType	eStreamType;					/*!< ʷ								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}LocalHistoryInformation, *LPLocalHistoryInformation;

/*!
*  \struct	tagDecoderDynamicInformation
*  \brief	̬Ϣ
*/
typedef struct tagDecoderDynamicInformation
{
	MediaServerInformation	cMediaServerInfo;			/*!< ýϢ						*/
	HYPrivateServerInformation	cZWPrivateServerInfo;	/*!< HY˽ЭϢ					*/
	LocalHistoryInformation	cLocalHistoryInformation;	/*!< ʷϢ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderDynamicInformation, *LPDecoderDynamicInformation;

/*!
*  \struct	tagStreamTransferFrame
*  \ingroup DS_StreamTransferFrame
*  \brief	ת֡
*/
typedef struct tagStreamTransferFrame
{
	eFrameType	eFrameTypeInfo;							/*!< ֡Ϣ								*/
	DWORD	dwTimeStamp;								/*!< ֡ʱ								*/
	AbsoluteTime cAbsoluteTime;							/*!< ֡ʱ							*/
	DWORD	dwFrameNumber;								/*!< ֡									*/
	Buffer	cFrameBuffer;								/*!< ֡								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}StreamTransferFrame, *LPStreamTransferFrame;

/*!
*  \struct	tagFontPara
*  \brief	Ϣ,ϵͳ
*/
typedef struct tagFontPara
{
	DWORD lfHeight;										/*!< ߼λַ߶						*/
	DWORD lfWidth; 										/*!< ߼λַ						*/
	DWORD lfEscapement; 									/*!< ÿıʱҳ׶˵ĽǶ		*/
	DWORD lfOrientation; 								/*!< ַҳ׶˵ĽǶ			*/
	DWORD lfWeight; 										/*!< ,ָĴϸ̶			*/
	BYTE lfItalic; 										/*!< Ƿʹб							*/
	BYTE lfUnderline; 									/*!< Ƿʹ»							*/
	BYTE lfStrikeOut; 									/*!< Ƿʹɾ							*/
	BYTE lfCharSet; 									/*!< ַ									*/
	BYTE lfOutPrecision; 								/*!< 								*/
	BYTE lfClipPrecision; 								/*!< 								*/
	BYTE lfQuality; 									/*!< 								*/
	BYTE lfPitchAndFamily; 								/*!< ַ						*/
	char lfFaceName[MAX_FONT_NAME_LEN];					/*!< 								*/
}FontPara, *LPFontPara; 

typedef struct tagFileTransferDataPacket
{
	eDataPacketType m_dwPacketType;						/*!< 0:ݴ俪ʼ 1:ݰ 2:Ӧ 3:	*/
	DWORD m_dwPacketSequence;
	DWORD m_dwPacketLen;
}FileTransferDataPacket, *LPFileTransferDataPacket;

/*!
*  \struct	tagHistoryStreamParaEx
*  \brief	ʷӲչ
*/
typedef struct tagHistoryStreamMultiTypePara
{
	DWORD	dwDiskGroup;								/*!< 									*/
	DWORD	dwChannel;									/*!< ýͨ							*/
	DWORD		dwEnableEndTime;						/*!< ʱǷЧ						*/
	TimeInfo	cBeginTime;								/*!< ʷʼʱ							*/
	TimeInfo	cEndTime;								/*!< ʷʱ							*/
	DWORD		dwStreamType;							/*!< ʷ(ֶ֧͵)			*/
	eStreamTransferMode	eTransferMode;					/*!< ģʽ								*/
	char	cStreamMediaType;							/*!< ý 0ʾ1ʾ	*/
	char	cReserve[1]	;								/*!< 									*/
	WORD    wMediaPort;									/*!< ֶָý˿						*/
	WORD    wRTPPort;									/*!< ֶָRTP˿						*/
	char	cReserve2[2]	;							/*!< 									*/
	DWORD	dwReserve[DEF_RESERVE_NUM - 2];				/*!< 									*/
}HistoryStreamMultiTypePara, *LPHistoryStreamMultiTypePara;

/*!
*  \struct	tagVoiceStreamPara
*  \brief	Ӳ
*/
typedef struct tagVoiceStreamPara
{
	DWORD	dwChannel;									/*!< ýͨ							*/
	eVoiceMode eMode;									/*!< ģʽ							*/
	eStreamTransferMode	eTransferMode;					/*!< ģʽ								*/
	WORD wMediaPort;
	WORD wRTPPort;
	char nSpeakToDevice;			/*!< CIUƵݵ豸								*/
	char reserved[3];
	DWORD	dwReserve[DEF_RESERVE_NUM-2];					/*!< 									*/
}VoiceStreamPara, *LPVoiceStreamPara;

/*!
*  \struct	tagStreamDecodePara
*  \brief	ýģʽ
*/
typedef struct tagStreamDecodePara
{
	eDecodeMode	eDecMode;								/*!< ģʽ								*/
	eDecodeShowMode	eDecShowMode;						/*!< ʾģʽ							*/
	DWORD	dwDecChannel;								/*!< ͨ,Ϊɲд			*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}StreamDecodePara, *LPStreamDecodePara;

/*!
*  \struct	tagStreamCaptureImagePara
*  \brief	ý岶ͼƬ
*/
typedef struct tagStreamCaptureImagePara
{
	char	sImageFile[MAX_FILENAME];					/*!< ͼƬ·								*/
	DWORD	dwTimeWait;									/*!< ͼƬʱʱ,0xFFFFFFFFΪõȴ	*/
	eStreamImageFormat	eImageFormat;					/*!< ͼƬʽ						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}StreamCaptureImagePara, *LPStreamCaptureImagePara;

/*!
*  \struct	tagHistoryStreamQueryFactor
*  \brief	ʷѯ
*/
typedef struct tagHistoryStreamQueryFactor
{
	DWORD				dwChannel;						/*!< ͨ									*/
	DWORD				dwDiskGroup;					/*!< 									*/
	eHistoryStreamType	eStreamType;					/*!< ʷ								*/
	char				cBeginTime[15];					/*!< ʼʱ								*/
	char				cEndTime[15];					/*!< ʱ								*/
}HistoryStreamQueryFactor, *LPHistoryStreamQueryFactor;

/*!
*  \struct	tagHistoryStreamMultiTypeQueryFactor
*  \ingroup DS_HistoryStreamMultiTypeQueryFactor
*  \brief	ʷѯ
*/
#ifdef _WIN32
#pragma pack(1)
#endif
typedef struct tagHistoryStreamMultiTypeQueryFactor
{
	DWORD				dwChannel;						/*!< ͨ									*/
	DWORD				dwDiskGroup;					/*!< 									*/
	DWORD				dwStreamType;					/*!< ʷ								*/
	char				cBeginTime[15];					/*!< ʼʱ								*/
	char				cEndTime[15];					/*!< ʱ								*/
}
#ifdef _WIN32
#pragma pack()
#else
__attribute__((aligned(1), packed))
#endif
HistoryStreamMultiTypeQueryFactor, *LPHistoryStreamMultiTypeQueryFactor;


/*!
*  \struct	tagFileQueryFactor
*  \brief	ļѯ
*/
typedef struct tagFileQueryFactor
{
	DWORD				dwChannel;						/*!< ͨ									*/
	DWORD				dwFileType;						/*!< ļ								*/
	char				cBeginTime[DATE_TIME_LEN];		/*!< ʼʱ								*/
	char				cEndTime[DATE_TIME_LEN];		/*!< ʱ								*/
}FileQueryFactor, *LPFileQueryFactor;

/*!
*  \struct	tagHistoryStreamQueryResult
*  \brief	ʷѯ
*/
typedef struct tagHistoryStreamQueryResult
{
	DWORD				dwChannel;						/*!< ͨ									*/
	eHistoryStreamType	eStreamType;					/*!< ʷ								*/
	char				cBeginTime[DATE_TIME_LEN];		/*!< ʼʱ								*/
	char				cEndTime[DATE_TIME_LEN];		/*!< ʱ								*/
	DWORD				dwStreamSize;					/*!< ݳ								*/
}HistoryStreamQueryResult, *LPHistoryStreamQueryResult;

/*!
*  \struct	tagHistoryStreamMultiTypeQueryResult
*  \ingroup DS_HistoryStreamMultiTypeQueryResult
*  \brief	ʷѯ
*/
typedef struct tagHistoryStreamMultiTypeQueryResult
{
	DWORD				dwChannel;						/*!< ͨ									*/
	DWORD				dwStreamType;					/*!< ʷ								*/
	char				cBeginTime[DATE_TIME_LEN];		/*!< ʼʱ								*/
	char				cEndTime[DATE_TIME_LEN];		/*!< ʱ								*/
	DWORD				dwStreamSize;					/*!< ݳ								*/
}
#ifdef _WIN32
#else
__attribute__((aligned(1), packed))
#endif
HistoryStreamMultiTypeQueryResult, *LPHistoryStreamMultiTypeQueryResult;

/*!
*  \struct	tagHistoryStreamQueryResult
*  \brief	ʷѯ
*/
typedef struct tagFileQueryResult
{
    DWORD				dwChannel;						/*!< ͨ									*/
    DWORD				dwLock;							/*!< Ƿ								*/
    DWORD				dwDataSize;						/*!< ݴС								*/
    DWORD				dwFileType;						/*!< ͼƬ								*/
    char				cCreateTime[DATE_TIME_LEN];		/*!< ͼƬʱ								*/
    char				cFileName[MAX_FILENAME];		/*!< ͼƬ豸·                         */
}FileQueryResult, *LPFileQueryResult;

/*!
*  \struct	tagMediaLinkIDQueryResult
*  \brief	ѯýID
*/
typedef struct tagMediaLinkIDQueryResult
{
	DWORD	dwNumber;									/*!< Ч								*/
	DWORD	dwLinkID[MAX_LINK_ID_QUERY_NUM];			/*!< ID									*/
}MediaLinkIDQueryResult, *LPMediaLinkIDQueryResult;

/*!
*  \struct	tagLogQueryFactor
*  \brief	־ѯ
*/
typedef struct tagLogQueryFactor
{
	DWORD					m_dwQueryMode;				/*!< ѯʽ								*/
	eHistoryLogMajorType	m_eMajorType;				/*!< 									*/
	eHistoryLogMinorType	m_eMinorType;				/*!< 									*/
	DWORD					m_dwChannel;				/*!< ͨ									*/
	char					m_sStartTime[DATE_TIME_LEN];/*!< ʼʱ								*/
	char					m_sStopTime[DATE_TIME_LEN];	/*!< ʱ								*/
}LogQueryFactor, *LPLogQueryFactor;

/*!
*  \struct	tagLogQueryResult
*  \brief	ʷ־ѯ
*/
typedef struct tagLogQueryResult
{
	eHistoryLogMajorType	m_eMajorType;				/*!< 									*/
	eHistoryLogMinorType	m_eMinorType;				/*!< 									*/
	DWORD					m_dwDetailInfo;				/*!< ϸϢ								*/
	char					m_sUserName[USERNAME_LEN];	/*!< û								*/
	char					m_sUserIP[IP_ADDRESS_LEN];	/*!< ûIPַ								*/
	char					m_sLogTime[DATE_TIME_LEN];	/*!< ʱ								*/
}LogQueryResult, *LPLogQueryResult;

/*!
*  \struct	tagTransparentChannelPara
*  \brief	͸ͨ
*/
typedef struct tagTransparentChannelPara
{
	DWORD	dwMajorType;								/*!< Ϣ								*/
	DWORD	dwMinorType;								/*!< Ϣ								*/
}TransparentChannelPara, *LPTransparentChannelPara;

/*!
*  \struct	tagFileUploadPara
*  \brief	ļϴ
*/
typedef struct tagFileUploadPara
{
	eTransferFileType	eFileType;						/*!< ϴļ							*/
	char	strRemoteFilePath[MAX_FILE_PATH_LEN];		/*!< ϴļ·							*/
	char	strLocalFilePath[MAX_FILE_PATH_LEN];		/*!< ϴļ·							*/
}FileUploadPara, *LPFileUploadPara;

/*!
*  \struct	tagFileUploadState
*  \brief	ļϴ״̬
*/
typedef struct tagFileUploadState
{
	DWORD	dwUploadSize;								/*!< ϴݳ							*/
	DWORD	dwStatus;									/*!< ϴ״̬0Ϊڴͣ1Ϊȡ		*/
														/*!<2ΪFlash 3Ϊ汾Իļ4ʾдʧܣ5ʾɹɣ6ʾʧܣ7ʾȡļ	*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}FileUploadState, *LPFileUploadState;

/*!
*  \struct	tagFileDownloadPara
*  \brief	ļز
*/
typedef struct tagFileDownloadPara
{
	eTransferFileType	eFileType;						/*!< ļ							*/
	char	strRemoteFilePath[MAX_FILE_PATH_LEN];		/*!< Դļ·							*/
	char	strLocalFilePath[MAX_FILE_PATH_LEN];		/*!< Ŀļ·						*/
}FileDownloadPara, *LPFileDownloadPara;


/*!
*  \struct	tagImageFileInfo
*  \brief	 ץͼļϢ
*/
typedef struct tagImageFileInfo
{
	DWORD				m_dwFileSize;					/*!< ļС								*/
	char				m_sFileName[MAX_FILENAME];		/*!< ļ									*/
	char				m_sCreateTime[DATE_TIME_LEN];	/*!< ļʱ							*/
}ImageFileInfo, *LPImageFileInfo;


/*!
*  \struct	tagRecordSetFileInfo
*  \brief	 ʷ¼ѯļϢ
*/
typedef struct tagRecordSetFileInfo
{
	DWORD				m_dwFileSize;					/*!< ļС								*/
	char				m_sFileName[MAX_FILENAME];		/*!< ļ									*/
	char				m_sCreateTime[DATE_TIME_LEN];	/*!< ļʱ							*/	
}RecordSetFileInfo, *LPRecordSetFileInfo;

/*!
*  \struct	tagServerInformation
*  \brief	Ϣ
*/
typedef struct tagServerInformation
{
	char	cAddress[MAX_ADDRESS_LEN];					/*!< ַ									*/
	DWORD	dwCommandPort;								/*!< ˿								*/
	DWORD	dwTCPPort;									/*!< TCP˿								*/
	DWORD	dwRTPPort;									/*!< RTP˿								*/
}ServerInformation, *LPServerInformation;

/*!
*  \struct	tagDeviceRegisterInfo
*  \brief	豸עϢ
*/
typedef struct tagDeviceRegisterInfo
{
	DWORD		dwDeviceID;								/*!< Ʒк								*/
	char		cDeviceIP[IP_ADDRESS_LEN];				/*!< 豸IPַ								*/
	char		cDeviceMAC[MAC_ADDRESS_LEN];			/*!< 豸MACַ							*/
	DWORD		dwDeviceCmdPort;						/*!< 豸˿							*/
	DWORD		dwHTTPPort;								/*!< HTTP˿								*/
	DWORD		dwDeviceType;							/*!< 豸								*/
	char		cDeviceVersion[VERSION_INFO_LEN];		/*!< 豸汾							*/
	DWORD		dwDeviceMaxConnect;						/*!< Ƶ						*/
}DeviceRegisterInfo, *LPDeviceRegisterInfo;

/*!
*  \struct	tagDeviceRegisterInfoV1
*  \brief	豸עϢ
*/
typedef struct tagDeviceRegisterInfoV1
{
	DWORD	m_bytDevType;								/*!< 豸(Read)							*/
	DWORD	m_bytBoardID;								/*!< 豸ͺ(Read)							*/

	WORD	m_bytDevDetectPort;							/*!< 豸Զּ˿					*/
	WORD	m_wCmdPort;									/*!< 豸˿							*/
	WORD	m_wMediaPort;								/*!< 豸ý˿							*/
	WORD	m_wHttpPort;								/*!< 豸HTTP˿							*/
	WORD	m_wRTSPPort;								/*!< 豸RTSP˿							*/
	BYTE	m_bytPadding1[2];							/*!< ֶ								*/

	BYTE	m_bytDevChan;								/*!< 豸ͨ(Read)						*/
	BYTE	m_bytDevRegInterval;						/*!< 豸עʱ						*/
	BYTE	m_bytDevMac[MAC_BINARY_ADDRESS_LEN];		/*!< 豸MACַ(Read)						*/

	char	m_bytDevIP[IP_ADDRESS_LEN];					/*!< 豸ǰIPַ							*/
	char	m_bytDevMask[IP_ADDRESS_LEN];				/*!< 豸IPַ							*/
	char	m_bytDevGateway[IP_ADDRESS_LEN];			/*!< 豸صַ							*/
	char	m_bytDeviceVersion[DVR_MAX_DEVICE_VERSION_LEN]; /*!< 豸汾Ϣ(ֻռЧ)*/
	char	m_bytP2PUUID[DVR_MAX_P2P_UUID_LEN];			/*!< P2P UUID(ֻռЧ)	*/

	char 	m_szTypeName[32];							/*!< 豸(ReadOnly)					*/
	char 	m_szSerialNum[32];							/*!< к(ReadOnly)						*/
	char 	m_szHardwareVersion[32];					/*!< Ӳ汾(ReadOnly) 					*/
	char 	m_szSoftwareVersion[32];					/*!< 汾(ReadOnly) 					*/
	char 	m_szAlgorithmVersion[32];					/*!< 㷨汾(ReadOnly) 					*/
	char 	m_szDspVersion[32];							/*!< 汾(ReadOnly) 					*/

	BYTE	m_byVideoInChannels;						/*!< Ƶ·(ReadOnly)  				*/
	BYTE	m_byAudioInChannels;						/*!< Ƶ·(ReadOnly)  				*/
	BYTE	m_byAlarmInChannels;						/*!< ·(ReadOnly)  				*/
	BYTE	m_byAlarmOutChannels;						/*!< ·(ReadOnly)  				*/

	BYTE	m_byVGAChannels;							/*!< VGAӿڸ(ReadOnly)  				*/
	BYTE	m_bySpotOutChannles;						/*!< SPOT·(ReadOnly)  				*/
	BYTE	m_byVoiceInChannels;						/*!< Խ·(ReadOnly)  			*/
	BYTE	m_byP2PType;								/*!< P2Pͣ0֧֣1tutk,2,ulk		*/

	BYTE	m_bytNetworkType;							/*!< , μeWhichNetcardUsed		*/
	BYTE	m_bytDHCP;									/*!< DHCP(ReadOnly)
														0, ʾֶЧ(豸0)
														1̬
														2̬ȡ						*/
	BYTE	m_bytAutoGenIP;								/*!< IPӦ(ReadOnly)
														0, ʾֶЧ(豸0)
														1
														2								*/
	BYTE	m_cAuthState;								/*!< Ȩ״̬0ʾδȨ1ʾȨ	*/

	char	m_bytPushNum[8];							/*!< ͺ									*/
	char	m_cDeviceName[64];							/*!< 豸 UTF8							*/
	DWORD	m_nCurrentTime;								/*!< ǰʱ    							*/
	long	m_nTimeZone;								/*!< ǰʱԷΪλ    			*/
	DWORD	m_dwMaxVideoConnect;						/*!< Ƶ						*/
	char	m_Reserve[256];								/*!< ֶ								*/
}DeviceRegisterInfoV1, *LPDeviceRegisterInfoV1;

/*!
*  \struct	tagDeviceConfigFromHttp
*  \brief	HTTP豸
*/
typedef struct tagDeviceConfigFromHttp
{
	WORD	wLocalCmdPort;								/*!< ˿							*/
	WORD	wLocalMediaPort;							/*!< ý˿							*/
	int		iReserve[DEF_HTTP_CFG_RESERVE_NUM];			/*!< 									*/
}DeviceConfigFromHttp, *LPDeviceConfigFromHttp;

/*!
*  \struct	tagProtocolNode
*  \brief	IPCЭϸ
*/
typedef struct tagProtocolNode
{
	int     bValid;			
	int     nProtocolType;								/*!< Э,οeIPProtocolType							*/
	char    cProtocolName[32];							/*!< Э							*/
	char    cResevered[256];
}NETWORK_PROTOCOL_NODE;

/*!
*  \struct	tagDeviceProtCapFromHttp
*  \brief	IPCЭ, һûиʱʾ֧Э
*/
typedef struct tagDeviceProtCapFromHttp
{
	int     bValid;
	int     nProtocolCount;								/*!< ֵ֧Э							*/
	NETWORK_PROTOCOL_NODE cProtocolList[32];			/*!< Эб							*/
	char    strP2PURL[64];								/*!< P2PЭӦAPPַ				*/
	char    bValidNotAllowAVIBackup;					/*!< ֹAVIʽıݵֶǷЧ	*/
	char    bNotAllowAVIBackup;							/*!< ǷֹAVIʽı					*/
	char    cReserved[190];								/*!< 							*/
}SUPPORT_NETWORK_PROTOCOL_CAP;

/*!
*  \struct	tagDeviceProbeParameter
*  \brief	̽ò
*/
typedef struct tagDeviceProbeParameter
{
	WORD	m_wBeginPort;								/*!< ̽ʼ˿							*/
	WORD	m_wEndPort;									/*!< ̽˿							*/
	DWORD	m_dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DeviceProbeParameter, *LPDeviceProbeParameter;

/*!
*  \struct	tagDeviceProbeConfig
*  \brief	̽ò
*/
#ifdef SYSTEM_WIN32
#pragma pack(push)//״̬
#pragma pack(1)  //Ϊ16ֽڶ
#endif
typedef struct tagDeviceProbeConfig
{ 
	DWORD	m_bytDevType;								/*!< (Read)						*/
	BYTE	m_bytDevChan;								/*!< 豸ͨ(Read)						*/
	BYTE	m_bytDevAutoReg;							/*!< ǷԶע						*/
	BYTE	m_bytDevRegInterval;						/*!< 豸עʱ						*/
	BYTE	m_bytDevMac[MAC_BINARY_ADDRESS_LEN];		/*!< 豸MACַ(Read)						*/
	BYTE	m_bytDevIP[IP_ADDRESS_LEN];					/*!< 豸ǰIPַ							*/
	BYTE	m_bytDevMask[IP_ADDRESS_LEN];				/*!< 豸IPַ							*/
	BYTE	m_bytDevGateway[IP_ADDRESS_LEN];			/*!< 豸صַ							*/
	BYTE	m_bytDevManHost[IP_ADDRESS_LEN];			/*!< 豸ַ						*/
	WORD	m_bytDevDetectPort;							/*!< 豸Զּ˿					*/
	WORD	m_wManHostPort;								/*!< 豸˿						*/
	WORD	m_wCmdPort;									/*!< 豸˿							*/
	WORD	m_wMediaPort;								/*!< 豸ý˿							*/
	DWORD	m_dwReserveFirst;							/*!< 								*/
	DWORD	m_dwReserveSecond;							/*!< 								*/
	DWORD	m_dwValidMask;								/*!< Ч(λ0Ч1Ч)			*/
}DeviceProbeConfig, *LPDeviceProbeConfig;
#ifdef SYSTEM_WIN32
#pragma pack(pop)//ָ״̬
#endif

/*!
*  @struct	tagVIDEONETCLIENT_TIME
*  @brief	ϵͳʱ
 */
typedef struct tagHY_DVR_TIME
{
	int nYear;																/*!<  */
	int nMonth;																/*!<  */
	int nDay;																/*!<  */
	int nHour;																/*!< ʱ */
	int nMinute;															/*!<  */
	int nSecond;															/*!<  */

} HY_DVR_TIME, *LPHY_DVR_TIME;

/*!
*  \struct	tagDeviceProbeConfigV2
*  \brief	̽òV2
*/
typedef struct tagDeviceProbeConfigV2
{ 
	DWORD	m_bytDevType;								/*!< (Read)						*/
	BYTE	m_bytDevChan;								/*!< 豸ͨ(Read)						*/
	BYTE	m_bytDevAutoReg;							/*!< ǷԶע						*/
	BYTE	m_bytDevRegInterval;						/*!< 豸עʱ						*/
	BYTE	m_bytPadding1[1];							/*!< ֽڣ֤4ֽڶ				*/
	BYTE	m_bytDevMac[MAC_BINARY_ADDRESS_LEN];		/*!< 豸MACַ(Read)						*/
	BYTE	m_bytPadding2[2];							/*!< ֽڣ֤4ֽڶ				*/
	BYTE	m_bytDevIP[IP_ADDRESS_LEN];					/*!< 豸ǰIPַ							*/
	BYTE	m_bytDevMask[IP_ADDRESS_LEN];				/*!< 豸IPַ							*/
	BYTE	m_bytDevGateway[IP_ADDRESS_LEN];			/*!< 豸صַ							*/
	BYTE	m_bytDevManHost[IP_ADDRESS_LEN];			/*!< 豸ַ						*/
	WORD	m_bytDevDetectPort;							/*!< 豸Զּ˿					*/
	WORD	m_wManHostPort;								/*!< 豸˿						*/
	WORD	m_wCmdPort;									/*!< 豸˿							*/
	WORD	m_wMediaPort;								/*!< 豸ý˿							*/
	DWORD	m_dwReserveFirst;							/*!< 								*/
	DWORD	m_dwReserveSecond;							/*!< 								*/
	char	m_bytDeviceVersion[DVR_MAX_DEVICE_VERSION_LEN]; /*!< 豸汾Ϣ(ֻռЧ)*/
	char	m_bytP2PUUID[DVR_MAX_P2P_UUID_LEN];			/*!< P2P UUID(ֻռЧ)*/
	
	char 	m_szTypeName[32];							/*!< 豸(ReadOnly)*/
	char 	m_szSerialNum[32];							/*!< к(ReadOnly)  */
	char 	m_szHardwareVersion[32];					/*!< Ӳ汾(ReadOnly) */
	char 	m_szSoftwareVersion[32];					/*!< 汾(ReadOnly) */
	char 	m_szDspVersion[32];							/*!< 汾(ReadOnly) */

	unsigned char m_byVideoInChannels;					/*!< Ƶ·(ReadOnly)  */
	unsigned char m_byAudioInChannels;					/*!< Ƶ·(ReadOnly)  */
	unsigned char m_byAlarmInChannels;					/*!< ·(ReadOnly)  */
	unsigned char m_byAlarmOutChannels;					/*!< ·(ReadOnly)  */

	unsigned char m_byVGAChannels;						/*!< VGAӿڸ(ReadOnly)  */
	unsigned char m_bySpotOutChannles;					/*!< SPOT·(ReadOnly)  */
	unsigned char m_byVoiceInChannels;					/*!< Խ·(ReadOnly)  */
	unsigned char m_byP2PType;							/*!< P2Pͣ0֧֣1tutk,2,ulk*/

	unsigned char m_bytNetworkType;						/*!< , (ReadOnly) μeWhichNetcardUsed*/
	unsigned char m_bytDHCP;							/*!< DHCP(ReadOnly)  
																 0, ʾֶЧ(豸0)
																 1̬
																 2̬ȡ					*/
	unsigned char m_bytAutoGenIP;						/*!< IPӦ(ReadOnly)  
																 0, ʾֶЧ(豸0)
																 1
																 2							*/
	unsigned char m_bytPadding4[1];						/*!< (ReadOnly)					*/

	char	m_bytPushNum[8];							/*!< ͺ							*/
	char    m_cAuthState;								/*!< Ȩ״̬0ʾδȨ1ʾȨ*/
	char	m_cDeviceName[64];							/*!< 豸 UTF8					*/		
	unsigned char m_bytPadding5[3];						/*!< (ReadOnly)					*/
	HY_DVR_TIME m_struCurrentTime;						/*!< ǰʱ    					*/
	int     m_nTimeZone;								/*!< ǰʱԷΪλ    	*/
	char	m_bytCustomType[16];						/*!< ƿͻϢڿͻʶ豸	*/
	char	m_bytSessionID[8];							/*!< 豸ỰID豸̬ɣʱЧ	*/
	DWORD m_dwBootCount;						/*!< 						*/
	char	m_bytReserved[720];							/*!< 						*/
	DWORD	m_dwValidMask;								/*!< Ч(λ0Ч1Ч)			*/
	DWORD	m_dwValidMask2;								/*!< Ч(λ0Ч1Ч)			*/
}DeviceProbeConfigV2, *LPDeviceProbeConfigV2;

	/*!
*  @struct	tagNotifyOnlineConfig
*  @brief	̽ò
*/
typedef struct tagNotifyOnlineConfig
{ 
	DWORD	m_bytDevType;								/*!< (Read)						*/
	BYTE	m_bytDevChan;								/*!< 豸ͨ(Read)						*/
	BYTE	m_bytDevAutoReg;							/*!< ǷԶע						*/
	BYTE	m_bytDevRegInterval;						/*!< 豸עʱ						*/
	BYTE	m_bytPadding1[1];							
	BYTE	m_bytDevMac[MAC_BINARY_ADDRESS_LEN];		/*!< 豸MACַ(Read)						*/
	BYTE	m_bytPadding2[2];
	BYTE	m_bytDevIP[IP_ADDRESS_LEN];					/*!< 豸ǰIPַ							*/
	BYTE	m_bytDevMask[IP_ADDRESS_LEN];				/*!< 豸IPַ							*/
	BYTE	m_bytDevGateway[IP_ADDRESS_LEN];			/*!< 豸صַ							*/
	BYTE	m_bytDevManHost[IP_ADDRESS_LEN];			/*!< 豸ַ						*/
	WORD	m_bytDevDetectPort;							/*!< 豸Զּ˿					*/
	WORD	m_wManHostPort;								/*!< 豸˿						*/
	WORD	m_wCmdPort;									/*!< 豸˿							*/
	WORD	m_wMediaPort;								/*!< 豸ý˿							*/
	DWORD	m_dwReserveFirst;							/*!< 								*/
	DWORD	m_dwReserveSecond;							/*!< 								*/
	char	m_bytDeviceVersion[DVR_MAX_DEVICE_VERSION_LEN]; /*!< 豸汾Ϣ							*/
	char	m_bytP2PUUID[DVR_MAX_P2P_UUID_LEN];				/*!< P2P UUID								*/
	char	m_bytReserved[1024];								/*!< 								*/		
	DWORD	m_dwValidMask;								/*!< Ч(λ0Ч1Ч)			*/
	DWORD	m_dwValidMask2;
}NotifyOnlineConfig, *LPNotifyOnlineConfig;

//̽
#define DVR_MAX_DEVICE_NAME_LENGTH		(32)

typedef struct tagVIDEONETCLIENT_FRONT_PROBE_DEVICE_INFO
{
	char strDeviceName[DVR_MAX_DEVICE_NAME_LENGTH];  //洢豸֣Ҫ豸̣
	char strDevIp[IP_ADDRESS_LEN];			//豸IP
	char strDevSubmask[IP_ADDRESS_LEN];		//豸
	char strDevGateway[IP_ADDRESS_LEN];		//豸
	char strDevMac[MAC_ADDRESS_LEN];		//豸macַ
	char cReserve1[2];							//ֶΣֽ֤ڶ
	DWORD dwDevType;							//豸ͣҪNVRṩֶӦַ
	DWORD dwDevProtocolType;					//豸ЭͣҪNVRṩֶӦַ
	DWORD dwDevChannelCount;					//豸ͨ
	DWORD dwDevPort;							//豸ʵĶ˿ںţ˽еָ˿ںţͬЭ˿ںòһ
	char cDevUUid[64] ;							//豸Ψһʶ
	char strDevUID[64];							//ȡ豸UID
	char cReserve[192];	
}VIDEONETCLIENT_FRONT_PROBE_DEVICE_INFO;

/*!
*  @struct	tagDeviceProbeUserLoginPara
*  @brief	̽û֤
*/
typedef struct tagDeviceProbeUserLoginPara
{
	char	sUName[USERNAME_LEN];						/*!< ¼ûû						*/
	char	sUPass[USERPASS_LEN];						/*!< ¼ûû						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DeviceProbeUserLoginPara, *LPDeviceProbeUserLoginPara;

/*!
*  @struct	tagDeviceProbeConfigInformation
*  @brief	̽Ϣ
*/
typedef struct tagDeviceProbeConfigInformation
{
	BYTE	bytMainCommand;								/*!< Ϣ						*/
	BYTE	bytAssistCommand;							/*!< Ϣ						*/
	char	sConfig[MAX_PARTNER_PROBE_CFG_LEN];			/*!< Ϣ							*/
	WORD	dwConfigLen;								/*!< Ϣ							*/
	DWORD	dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DeviceProbeConfigInformation, *LPDeviceProbeConfigInformation;

/*!
*  \struct	tagFunctionInfo
*  \brief	Ϣ
*/
typedef struct tagFunctionInfo
{
	DWORD dwMajor;										/*!< 汾								*/
	DWORD dwMinor;										/*!< ΰ汾								*/
	DWORD dwRevision;									/*!< ޶汾								*/
	DWORD dwSVN;										/*!< SVN									*/
}FunctionInfo, *LPFunctionInfo;

/*!
*  \struct	tagPanelStatusInfo
*  \brief	״̬Ϣ
*/
typedef struct tagPanelStatusInfo
{
	DWORD dwStatus;										/*!< ״̬,0Ϊδ,1Ϊ			*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}PanelStatusInfo, *LPPanelStatusInfo;

/*!
*  \struct	tagPanelControlParameter
*  \brief	Ʋ
*/
typedef struct tagPanelControlParameter
{
	DWORD dwControl;									/*!< ,μePanelControlTypeֵ		*/
	DWORD dwKeyBoardCode;								/*!< ֵ,μePanelKeyBoardCodeTypeֵ	*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}PanelControlParameter, *LPPanelControlParameter;

/*!
*  \struct	tagDecoderLoopStatus
*  \ingroup DS_DecoderLoopStatus
*  \brief	ͨѯ״̬
*/
typedef struct tagDecoderLoopStatus
{
	DWORD	dwChannelNumber;							/*!< ͨ									*/
	eDecoderChannelStatus	eDecChStatus[MAX_DEC_CHANNEL_NUMBER];/*!< ͨ״̬						*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderLoopStatus, *LPDecoderLoopStatus;

/*!
*  \struct	tagDecoderDeviceConfig
*  \ingroup DS_DecoderDeviceConfig
*  \brief	豸
*/
typedef struct tagDecoderDeviceConfig
{
	DWORD	dwDecoderChannelNumber;					/*!< ͨ,ݽģʽ,ֻ	*/
	eResolutionMode	eDecodeMode;						/*!< ģʽ								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderDeviceConfig, *LPDecoderDeviceConfig;

/*!
*  \struct	tagChannelChromaConfig
*  \ingroup DS_ChannelChromaConfig
*  \brief	ͨѧ
*/
typedef struct tagChannelChromaConfig
{
	DWORD dwBrightness;								/*!< ,0-255 							*/
	DWORD dwContrast;								/*!< Աȶ,0-255							*/
	DWORD dwSaturation;								/*!< Ͷ,0-255 							*/
	DWORD dwHue;									/*!< ɫ,0-255 							*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}ChannelChromaConfig, *LPChannelChromaConfig;

/*!
*  \struct	tagDecoderChannelConfig
*  \ingroup DS_DecoderChannelConfig
*  \brief	ͨ
*/
typedef struct tagDecoderChannelConfig
{
	DWORD	dwDecChanScaleStatus;					/*!< ͨʾſƣ1-ʾ0-ʵʾ 	*/
	ChannelChromaConfig	cChannelChromaConfig;			/*!< ѧ								*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderChannelConfig, *LPDecoderChannelConfig;

/*!
*  \struct	tagDecoderVideoStandardConfig
*  \ingroup DS_DecoderVideoStandardConfig
*  \brief	ͨƵʽ
*/
typedef struct tagDecoderVideoStandardConfig
{
	DWORD	dwVideoStandard;						/*!< Ƶʽ: 0-PAL1-NTSC  				*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderVideoStandardConfig, *LPDecoderVideoStandardConfig;

/*!
*  \struct	tagDecoderChannelSourceConfig
*  \ingroup DS_DecoderChannelSourceConfig
*  \brief	ͨƵԴ
*/
typedef struct tagDecoderChannelSourceConfig
{
	MediaServerInformation	cMediaServerInfo;			/*!< ýϢ							*/
	HYPrivateServerInformation	cHYPrivateServerInfo;	/*!< HY˽ЭϢ						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderChannelSourceConfig, *LPDecoderChannelSourceConfig;

/*!
*  \struct	tagDecoderChannelLoopConfig
*  \ingroup DS_DecoderChannelLoopConfig
*  \brief	ͨת
*/
typedef struct tagDecoderChannelLoopConfig
{
	DWORD	dwEnable;								/*!< Ƿ  								*/
	DWORD	dwPoolTime;							/*!< Ѳʱ  								*/
	DecoderChannelSourceConfig cSource[MAX_DECODER_CHANNEL_SOURCE];/*!< ͨƵԴ						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderChannelLoopConfig, *LPDecoderChannelLoopConfig;

/*!
*  \struct	tagDecoderChannelInformation
*  \ingroup DS_DecoderChannelInformation
*  \brief	ͨϢ
*/
typedef struct tagDecoderChannelInformation
{
	DWORD	dwDecoderState;						/*!< ͨ״̬0-̬ 1ѭ			*/
	DWORD	dwGetStreamMode;						/*!< ȡģʽ0-δ룬1-2-			*/
	MediaServerInformation	cMediaServerInfo;			/*!< ýϢ							*/
	HYPrivateServerInformation	cHYPrivateServerInfo;	/*!< HY˽ЭϢ						*/
	LocalHistoryInformation	cLocalHistoryInformation;		/*!< ʷϢ							*/
	StreamTransferPara 	cStreamTransferPara;				/*!< תϢ						*/
	DWORD	dwReserve[DEF_RESERVE_NUM];				/*!< 									*/
}DecoderChannelInformation, *LPDecoderChannelInformation;

/*!
*  \struct	tagDecoderChannelStatusInfo
*  \ingroup DS_DecoderChannelStatusInfo
*  \brief	ͨ״̬Ϣ
*/
typedef struct tagDecoderChannelStatusInfo
{
	eDecoderChannelStatus	eDecChStatus;				/*!< ͨ״̬								*/
	eStreamSourceType	eStreamSourceTypeValue;			/*!< ýԴ							*/
	DWORD	dwStreamBitrate;							/*!< ý(kbps)						*/
	DWORD	dwVideoWidth;								/*!< Ƶͼ							*/
	DWORD	dwVideoHeight;								/*!< Ƶͼ߶							*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderChannelStatusInfo, *LPDecoderChannelStatusInfo;

/*!
*  \struct	tagDecoderChannelStatus
*  \ingroup DS_DecoderChannelStatus
*  \brief	ͨ״̬
*/
typedef struct tagDecoderChannelStatus
{
	DWORD	dwChannelNumber;							/*!< ͨ									*/
	DecoderChannelStatusInfo	cDecChStatus[MAX_DEC_CHANNEL_NUMBER];/*!< ͨ״̬Ϣ		*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderChannelStatus, *LPDecoderChannelStatus;

/*!
*  \struct	tagDecoderChannelStatusControl
*  \brief	ͨ
*/
typedef struct tagDecoderChannelControl
{
	eDecoderChannelStatus	eDecChStatus[MAX_DEC_CHANNEL_NUMBER];/*!< ͨ״̬				*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderChannelStatusControl, *LPDecoderChannelStatusControl;

/*!
*  \struct	tagDecoderSetPlayStatusParameter
*  \ingroup DS_DecoderSetPlayStatusParameter
*  \brief	ýͨ״̬
*/
typedef struct tagDecoderSetPlayStatusParameter
{
	eStreamPlayControlStatus	ePlayControlStatus;		/*!< ״̬							*/
	/*	
	ePlayControlStatus Ϊٶȵʱ: eStreamPlayControlFast, eStreamPlayControlSlow.
	Ԫ0ʾٶ, 2ʾ 2, 4ʾ 4, 8ʾ 8, 16ʾ 16
	*/
	DWORD dwParameter[MAX_PLAY_CONTROL_PARAMETER];		/*!< ״̬Ʋ						*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderSetPlayStatusParameter, *LPDecoderSetPlayStatusParameter;

/*!
*  \struct	tagDecoderPlayStatusParameter
*  \ingroup DS_DecoderPlayStatusParameter
*  \brief	ͨ״̬
*/
typedef struct tagDecoderPlayStatusParameter
{
	eStreamSourceType	eStreamSourceTypeValue;			/*!< ýԴ							*/
	DWORD		dwEnableEndTime;						/*!< ʱǷЧ						*/
	TimeInfo	cBeginTime;								/*!< ʷʼʱ							*/
	TimeInfo	cEndTime;								/*!< ʷʱ							*/
	TimeInfo	cCurrentTime;							/*!< ǰŵʷʱ					*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderPlayStatusParameter, *LPDecoderPlayStatusParameter;

/*!
*  \struct	tagDecoderGetPlayStatusParameter
*  \ingroup DS_DecoderGetPlayStatusParameter
*  \brief	ȡͨ״̬
*/
typedef struct tagDecoderGetPlayStatusParameter
{
	DWORD	dwChannelNumber;							/*!< ͨ									*/
	DecoderPlayStatusParameter	cDecChPlayStatus[MAX_DEC_CHANNEL_NUMBER];/*!< ͨ״̬Ϣ*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderGetPlayStatusParameter, *LPDecoderGetPlayStatusParameter;

/*!
*  \struct	tagDecoderDisplayStatus
*  \ingroup DS_DecoderDisplayStatus
*  \brief	ýͨʾ״̬
*/
typedef struct tagDecoderDisplayStatus
{
	DWORD	dwWindow;								/*!< ڱ								*/
	eDisplayControlStatus	eDisplayControlStatusValue;	/*!< ʾ״̬Ϣ							*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderDisplayStatus, *LPDecoderDisplayStatus;

/*!
*  \struct	tagUploadLogoParameter
*  \ingroup DS_UploadLogoParameter
*  \brief	ϴLogo
*/
typedef struct tagUploadLogoParameter
{
	eLogoPictureType	eLogoPictureValue;				/*!< LogoͼƬ							*/
	DWORD dwParameter[MAX_LOGO_PICTURE_PARAMETER];		/*!< LogoͼƬ							*/
	Buffer				cBuffer;						/*!< LogoͼƬ							*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}UploadLogoParameter, *LPUploadLogoParameter;

/*!
*  \struct	tagDecoderDisplayConfig
*  \ingroup DS_DecoderDisplayConfig
*  \brief	ʾ
*/
typedef struct tagDecoderDisplayConfig
{
	eVGAResolutionMode	eVGAResolution;				/*!<	ֱ								*/
	eScreenControlStatus	eScreenControlStatusValue;		/*!< ʾ״̬Ϣ							*/
	DWORD	dwDecoderChannel[MAX_DISPLAY_SCREEN_NUMBER];	/*!< 󶨵Ľͨ							*/
	DWORD	dwEnlargeWindow;						/*!< ڷŴ, 0xFFFFFFFFʾŴ,ʾڱ	*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}DecoderDisplayConfig, *LPDecoderDisplayConfig;

/*!
*  \struct	tagTransmitHistoryStreamQueryFactor
*  \ingroup DS_TransmitHistoryStreamQueryFactor
*  \brief	תʷѯ
*/
typedef struct tagTransmitHistoryStreamQueryFactor
{
	UserLoginPara	cUserLoginPara;					/*!< ¼Ϣ							*/
	eDeviceProtocolType	eDeviceProtocolValue;			/*!< 豸Э汾							*/
	HistoryStreamMultiTypeQueryFactor cFactor;			/*!< ʷѯ							*/
	DWORD dwReserve[DEF_RESERVE_NUM];					/*!< 									*/
}TransmitHistoryStreamQueryFactor, *LPTransmitHistoryStreamQueryFactor;

/*!
*  @struct	tagEventGateKeyboard
*  @brief	Ž
*/
typedef struct tagEventGateKeyboard
{
	char	m_szID[USERPASS_LEN];						/*!< ʱصID								*/
	char	m_Reserve[MAX_CFG_LEN_512BYTE - 32];		/*!< ֶ							*/
}EventGateKeyboard, *LPEventGateKeyboard;

/*!
*  @struct	tagEventGateCard
*  @brief	Žˢ
*/
typedef struct tagEventGateCard
{
	char	m_szID[MAX_CARD_ID_LENGTH];				/*!< ӿƬʱصID								*/
	char	m_Reserve[MAX_CFG_LEN_512BYTE - 32];		/*!< ֶ							*/
}EventGateCard, *LPEventGateCard;

/*!
*  @struct	tagEventGateRemote
*  @brief	ŽԶ̲
*/
typedef struct tagEventGateRemote
{
	char	m_ControlID[MAX_GATE_REMOTE_ID_LENGTH];		/*!< Զ̿							*/
	char	m_Reserve[MAX_CFG_LEN_512BYTE - 32];		/*!< ֶ							*/
}EventGateRemote, *LPEventGateRemote;

/*!
*  @struct	tagObjectRect
*  @brief	Ŀλ
*/
typedef struct tagObjectRect
{
	WORD				wLeft;							/*!< 									*/
	WORD				wRight;							/*!< 									*/
	WORD				wTop;							/*!< 									*/
	WORD				wBottom;						/*!< 									*/
}ObjectRect, *LPObjectRect;

/*!
*  @struct	tagImageInfo
*  @brief	ͼƬϢ
*/
typedef struct tagImageInfo
{
	WORD				wWidth;							/*!< ͼƬ								*/
	WORD				wHeight;						/*!< ͼƬ߶								*/
	DWORD				dwLength;						/*!< ļС								*/
	char				cReserve[8];					/*!< 								*/
}ImageInfo, *LPImageInfo;

/*!
*  @struct	tagFaceFeatureInfo
*  @brief	ʶϢ
*/
typedef struct tagFaceFeatureInfo
{
	unsigned char		cAge;							/*!< 䣺0-δ֪ʾ				*/
	unsigned char		cSex;							/*!< Ա0-δ֪1-ԣ2-Ů			*/
	unsigned char		cHat;							/*!< ñӣ0-δ֪1-ñӣ2-ñ		*/
	unsigned char		cHair;							/*!< ͷȣ0-δ֪1-̷2-ͨ3-*/
	unsigned char		cHairColor;						/*!< ͷɫ0-δ֪1-ɫ2-ɫ3-ɫ4-*/
	unsigned char		cEye;							/*!< ۾0-δ֪1-2-ۣ3-ڵ	*/
	unsigned char		cGlasses;						/*!< ۾0-δ֪1-۾2-۾		*/
	unsigned char		cBeard;							/*!< 룺0-δ֪1-к룬2-޺		*/
	unsigned char		cMask;							/*!< ֣0-δ֪1-п֣2-޿		*/
	unsigned char		cSkin;							/*!< ɫ0-δ֪1-ɫ2-ɫ3-ɫ4-ɫ*/
	unsigned char		cSmile;							/*!< 飺0-δ֪1-ͨ2-΢Ц			*/
	unsigned char		cHuman;							/*!< 壺0-δ֪1-壬2-			*/
	unsigned char		cQuality;						/*!< ȣֵΧ0-100				*/
	float				cYaw;							/*!< Ƕ								*/
	float				cRoll;							/*!< Ƕ								*/
	float				cPitch;							/*!< бǶ								*/
	char				cReserve[64];					/*!< 								*/
}FaceFeatureInfo, *LPFaceFeatureInfo;

/*!
*  @struct	tagFaceCaptureInfo
*  @brief	ץϢ
*/
#ifdef WIN32
#pragma pack(1)
#endif
typedef struct tagFaceCaptureInfo
{
	FaceFeatureInfo		cFaceFeature;					/*!< ʶϢ⵽ĿϢ	*/
	ImageInfo			cFaceImage;						/*!< ץͼƬϢʵʱץͼƬϢ			*/
	ObjectRect			cFaceRect;						/*!< λãͼλϢ		*/
	unsigned long long 	llFaceTraceId;					/*!< ʶץĸID		*/
	int							nFaceTraceIDDie;				/*!< trackidһ¼trackid뱾εtrackidͬΪͬһtrackidһͼ								*/
	char				cReserve[92-4];					/*!< 	-4: nFaceTraceIDDie								*/
#ifdef WIN32
}FaceCaptureInfo, *LPFaceCaptureInfo;
#pragma pack()
#else
}__attribute__((packed)) FaceCaptureInfo, *LPFaceCaptureInfo;
#endif

/*!
*  @struct	tagFaceMatchInfo
*  @brief	ƥϢ
*/
typedef struct tagFaceMatchInfo
{
	float				fMatch;							/*!< ƥȣֵΧ0~100.0			*/
	DWORD				dwSerial;						/*!< ƥţһʶе	*/
	char				cLibID[MAX_FACE_LIB_ID_LENGTH];	/*!< ID			*/
	char				cFaceID[MAX_FACE_ID_LENGTH];	/*!< ID									*/
	unsigned char		cFaceLibName[MAX_FACE_LIB_NAME_LENGTH];/*!< ƣUnicode			*/
	unsigned char		cFaceName[MAX_FACE_NAME_LENGTH];/*!< ƣUnicode					*/
	ImageInfo			cImageInfo;						/*!< ͼƬϢ							*/
	char				szUniqueID[32];					/*!< UID							*/
	//char				cReserve[32];					/*!< 								*/
}FaceMatchInfo, *LPFaceMatchInfo;

/*!
*  @struct	tagEventFaceRecognition
*  @brief	ʶ¼
*/
/*¼ػͼ
ʽֲ[EventFaceRecognition][Image0]
EventFaceRecognitionʾʶ¼ṹ
Image0ʾʵʱץͼƬͼƬϢcFaceImage
һʶƥ¼ʾ
1. ʶ¼ϢϢΪץģץԴͼƬ
2. ʶ¼ϢϢΪȶԣƥĿͼƬ
3. ʣȶ¼Ϣ
*/
#ifdef _WIN32
#pragma pack(1)
#endif
typedef struct tagEventFaceRecognition
{
	DWORD				dwID;							/*!< ¼IDͬһ¼ڶƬηʱʹͬIDʶ*/
	DWORD				dwType;							/*!< ͣ0-ץģʵʱץĵĿ
														1-ȶԣеƥĿ	*/
	DWORD				dwTimeSec;						/*!< ʱλ룩					*/
	DWORD				dwTimeUSec;						/*!< ʱλ΢룩				*/
	DWORD				dwFaceNumber;					/*!< ǰʵʱͼм⵽*/
	DWORD				dwImageCodec;					/*!< ͼƬʽ0-JPEG						*/
	DWORD				dwMatchNumber;					/*!< ƥ0-δƥ䵽Ŀ꣬ΪƥĿ*/
	union {
		FaceCaptureInfo		cCaptureInfo;				/*!< ץͼƬϢץͼƬϢ		*/
		FaceMatchInfo		cMatchInfo;					/*!< ƥͼƬϢĿͼƬϢ		*/
	}cFace;												/*!< 飺dwTypeΪ0ʱʹcCaptureInfoΪ1ʱʹcMatchInfo*/
	DWORD				dwRuleID;						/*!< ID¼Դץ¼ʱ0xFFFFFFFF*/
	float						fFaceTemperature;		/*!< ¶						*/
	char						cTemperatureUnit;		/*!< ¶(0϶	1϶)						*/
	char						cIsNormalFaceTemperature;		/*!< ¶Ƿ(0֧    1¶	2¶쳣)						*/
	char				cReserve[64 - 10];				/*!< 								*/
}
#ifdef _WIN32
EventFaceRecognition, *LPEventFaceRecognition;
#pragma pack()
#endif
#ifdef _LINUX
__attribute__((packed)) EventFaceRecognition, *LPEventFaceRecognition;
#endif

//ϵͳ״̬
typedef struct tagDevicePerformanceStatus
{
	double m_CPUPercent;								//!<CPU
	double m_MemoryPercent;								//!<ڴ
	double m_StoragePercent;							//!<洢
	DWORD m_Uptime;										//!<ʱ
	DWORD m_OpenDoorCount;								//!<Ŵ
	int cReserve[256];
}DevicePerformanceStatus, *PDevicePerformanceStatus;

//////////////////////////////////////////////////////////////////////////
//ص
//////////////////////////////////////////////////////////////////////////

/*!
*  \brief
*	û¼ص
* @param hUser
*	û,ͨû¼ȡľ
* @param eEvent
*	¼
* @param dwParam1 -- dwParam3
*	б
			USEREVENT_REALSTREAM_STARTLINK
			USEREVENT_REALSTREAM_STOPLINK
			1ID..Ϊ0
			AlarmEventͣ
			1  ͣ
				2  ͨ
				3  ״̬(Ƶʧʱ,0ʾź,1ʾź)
			    


			USEREVENT_DISKGROUP_MANAGE:
			wp1 = eDiskGroupOperation
			wp2 = (0-ɹʧ)
			wp3 = Ӳ̲ʱʹõ֤룬ɿͻӲ̹õ


			USEREVENT_HISTORYSTREAM_NOTICE:
			wp1 = 1//ʾͣ1-ΪȡʷݴС
			wp2 = (0-ɹʧ)
			wp3 = datasize//ݴС KB    


			USEREVENT_HEARTBEAT_LOST
			δ⵽Ͽ
			Ϊ0
			USEREVENT_NET_RECOVER
			ɹ
			Ϊ0


			eHeartBeatEvent
			δõõ

			USEREVENT_USER_DISCONNECT
			δõõ

* @param dwUserData
*	û,¼ʱû
* @return
*	0
* @note
*	ڴ˻ص¼̵߳,
*	Ϊ˱֤ȷ,뾡ܼڻصеʽ,Աֹ.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_UserEvent)(IN HUSER hUser, IN DWORD dwEventType, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, IN VNC_USERDATA dwUserData);


/*!
*  \brief
*	û¼ص
* @param hUser
*	û,ͨû¼ȡľ
* @param dwEventType
*	¼
*    	USEREVENT_REALSTREAM_STARTLINK
		USEREVENT_REALSTREAM_STOPLINK
		1ID..Ϊ0
		AlarmEventͣ
		1  ͣ
		2  ͨ
		3  ״̬(Ƶʧʱ,0ʾź,1ʾź)



		USEREVENT_DISKGROUP_MANAGE:
		wp1 = eDiskGroupOperation
		wp2 = (0-ɹʧ)
		wp3 = Ӳ̲ʱʹõ֤룬ɿͻӲ̹õ


		USEREVENT_HISTORYSTREAM_NOTICE:
		wp1 = 1//ʾͣ1-ΪȡʷݴС
		wp2 = (0-ɹʧ)
		wp3 = datasize//ݴС KB    


		USEREVENT_HEARTBEAT_LOST
		δ⵽Ͽ
		Ϊ0
		USEREVENT_NET_RECOVER
		ɹ
		Ϊ0


		eHeartBeatEvent
		δõõ

		USEREVENT_USER_DISCONNECT
		δõõ
* @param dwSubEventType
*   ¼
* @param cBuffer
*   ¼
* @param dwUserData
*	û,¼ʱû
* @return
*	0
* @note
*	ڴ˻ص¼̵߳,
*	Ϊ˱֤ȷ,뾡ܼڻصеʽ,Աֹ.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_UserEventEx)(IN HUSER hUser, IN DWORD dwEventType, IN DWORD dwSubEventType, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, IN const LPBuffer cBuffer, IN VNC_USERDATA dwUserData);


/*!
*  \brief
*	ýݻص
* @param hStream
*	ý,ͨȡ,ʾýݵԴ
* @param cFrame
*	ý,֡,֡ʱ,֡Ϣ
*	ļʱյΪeFrameSysHeaderʱҪ֮֡֡дļ
*	뾡֤eFrameSysHeader͵֡ļͷ,Ա㲥
* @param dwUserData
*	û,ýݻصʱû
* @return
*	0
* @note
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_StreamMedia)(IN HSTREAM hStream, IN const StreamMediaFrame *cFrame, IN VNC_USERDATA dwUserData);

/*!
*  \brief
*	ԭʼýݻص
* @param hStream
*	ý,ͨȡ,ʾýݵԴ
* @param cFrame
*	ԭʼý,֡,֡ʱ,֡Ϣ
* @param dwUserData
*	û,ýݻصʱû
* @return
*	0
* @note
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_StreamMediaRaw)(IN HSTREAM hStream, IN const StreamMediaFrame *cFrame, IN VNC_USERDATA dwUserData);

/*!
*  \brief
*	ݻص
* @param hStream
*	,ͨȡ,ʾýݵԴ
* @param eSource
*	Դ,߽յ
* @param cFrame
*	,,֡ԴϢ
* @param dwUserData
*	û,ݻصʱû
* @return
*	0
* @note
*	ڴ˻صݽ벶̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_StreamVoice)(IN HSTREAM hStream, IN eVoiceStreamSource eSource, IN const StreamVoiceFrame *cFrame, IN VNC_USERDATA dwUserData);

/*!
*  \brief
*	͸ͨݻص
* @param hTransparent
*	͸ͨ,ͨ͸ͨȡ,ʾݵԴ
* @param cBuffer
*	͸ͨ,ݻ볤
* @param dwUserData
*	û,͸ͨݻصʱû
* @return
*	0
* @note
*	ڴ˻ص͸ͨݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_TransparentChannel)(IN HTRANSPARENT hTransparent, IN const LPBuffer pBuffer, IN DWORD dwUserData);

/*!
*  \brief
*	ļϴݻص
* @param hFileTransfer
*	ļϴ,ͨļϴȡ
* @param cState
*	ļϴ״̬,Ѵݳ
* @param dwUserData
*	û,ݻصʱû
* @return
*	0
* @note
*	ڴ˻صļϴݷ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_FileUpload)(IN HFILE_TRANSFER hFileTransfer, IN const FileUploadState cState, IN DWORD dwUserData);

/*!
*  \brief
*	ļݻص
* @param hFileTransfer
*	ļؾ,ͨļػȡ
* @param cBuffer
*	ļ,ݻ볤
* @param dwUserData
*	û,ݻصʱû
* @return
*	0
* @note
*	ڴ˻صļݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ.
* @note
*	ӿ: ʽ
*   cBufferΪ0xFFFFFFFF,ָΪNULLʱʾسӦϿ
*/
typedef int(CALLBACK *CB_FileDownload)(IN HFILE_TRANSFER hFileTransfer, IN const Buffer cBuffer, IN DWORD dwUserData);


/*!
*  \brief
*	豸עص
* @param pDeviceRegister
*	豸עϢ
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeviceRegister)(IN LPDeviceRegisterInfo pDeviceRegister);

/*!
*  \brief
* @param hUser
*	û,ͨû¼ȡľ
*	豸עص
* @param pDeviceRegister
*	豸עϢ
* @param user
*	û
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeviceRegisterV1)(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister, IN void *user);

/*!
*  \brief
* @param hUser
*	û,ͨû¼ȡľ
*	豸ص
* @param pSystemStatus
*	豸ϵͳ״̬
* @param user
*	û
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeviceHeartbeat)(IN HUSER hUser, IN PDevicePerformanceStatus pSystemStatus, IN void *user);

/*!
*  \brief
* @param hUser
*	û,ͨû¼ȡľ
*	豸߻ص
* @param pDeviceRegister
*	豸עϢ
* @param user
*	û
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeviceHeartbeatLost)(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister, IN void *user);

/*!
*  \brief
*	û¼ص
* @param hUser
*	û,ͨû¼ȡľ
* @param dwEventType
*	¼
*    	USEREVENT_REALSTREAM_STARTLINK
		USEREVENT_REALSTREAM_STOPLINK
		1ID..Ϊ0
		AlarmEventͣ
		1  ͣ
		2  ͨ
		3  ״̬(Ƶʧʱ,0ʾź,1ʾź)



		USEREVENT_DISKGROUP_MANAGE:
		wp1 = eDiskGroupOperation
		wp2 = (0-ɹʧ)
		wp3 = Ӳ̲ʱʹõ֤룬ɿͻӲ̹õ


		USEREVENT_HISTORYSTREAM_NOTICE:
		wp1 = 1//ʾͣ1-ΪȡʷݴС
		wp2 = (0-ɹʧ)
		wp3 = datasize//ݴС KB    


		USEREVENT_HEARTBEAT_LOST
		δ⵽Ͽ
		Ϊ0
		USEREVENT_NET_RECOVER
		ɹ
		Ϊ0


		eHeartBeatEvent
		δõõ

		USEREVENT_USER_DISCONNECT
		δõõ
* @param dwSubEventType
*   ¼
* @param cBuffer
*   ¼
* @param dwUserData
*	û,¼ʱû
* @return
*	0
* @note
*	ڴ˻ص¼̵߳,
*	Ϊ˱֤ȷ,뾡ܼڻصеʽ,Աֹ.
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeviceEventEx)(IN HUSER hUser, IN DWORD dwEventType, IN DWORD dwSubEventType, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, IN const LPBuffer cBuffer, IN void *user);


/*!
*  \brief
*	ǿɾѵ¼ûص
* @param hUser
*	û,ͨû¼ȡľ
* @param dwUserData
*	û
* @note
*	ӿ: ʽ
*/
typedef int(CALLBACK *CB_DeleteUserForce)(IN HUSER hUser, IN DWORD dwUserData);

/*!
*  \brief
*	豸̽ص
* @param cConfig
*	豸Ϣ
* @note
*	ӿ: ʽ
*/
typedef void (CALLBACK *CB_DeviceProbe)(IN LPDeviceProbeConfig cConfig);

/*!
*  \brief
*	豸̽ص
* @param cConfigV2
*	豸Ϣ
* @note
*	ӿ: ʽ
*/
typedef void (CALLBACK *CB_DeviceProbeV2)(IN LPDeviceProbeConfigV2 cConfigV2);

/*!
*  \brief
*	豸̽صNVR˻ȡNVRȡ豸б
* @param cConfig
*	豸Ϣ
* @note
*	ӿ: ʽ
*/
typedef void (CALLBACK *CB_DeviceProbeFromNVR)(IN HUSER hUser,IN VIDEONETCLIENT_FRONT_PROBE_DEVICE_INFO * cConfig,IN DWORD dwUserData);

/*!
*  \brief
*	豸̽ص,֧豸豸(V2)̽
* @param dwVersion
*   ǵǰ̽⵽豸Ϣ汾. 0, ʾLPDeviceProbeConfig, 1, ʾLPDeviceProbeConfigV2,10,ʾ֪ͨṹΪLPDeviceProbeConfigV2
* @param void*
*	豸Ϣ, ӦóӦødwVersionʹӦĽṹ.
* @param dwUserdata
*   û
* @note
*	ӿ: ʽ
*/
typedef void (CALLBACK *CB_DeviceProbeV3)(IN DWORD dwVersion, IN void* cConfigV2, IN DWORD dwUserdata);


/*!
*  \brief
*	豸߻ص
* @param cConfig
*	豸Ϣ
* @note
*	ӿ: ʽ
*/
typedef void (CALLBACK *CB_DeviceNotifyOnline)(IN LPNotifyOnlineConfig cConfig);

#endif
