// ControlDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/ControlDlg.h"

#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;

// CControlDlg Ի

IMPLEMENT_DYNAMIC(CControlDlg, CDialog)

CControlDlg::CControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CControlDlg::IDD, pParent)
{

}

CControlDlg::~CControlDlg()
{
}

void CControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBCHANNEL2, m_CBControl);
}


BEGIN_MESSAGE_MAP(CControlDlg, CDialog)
	ON_BN_CLICKED(IDOK2, &CControlDlg::OnBnClickedOk2)
END_MESSAGE_MAP()


// CControlDlg Ϣ

BOOL CControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	CString	cChannel;
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cControl[] = {"Force IFrame", "Capture Image", "Clear Alarm", "Manual Record", "Automation Record", "Close Record", "Alarm Out Open", "Alarm Out Close", "Reboot", "Shutdown", "Disk Group", "Get Record State", "Get Alarm Out State", "Get Alarm In State","Set Defense","Unset Defense"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cControl); count++)
	{
		m_CBControl.AddString(cControl[count]);
	}
	if (0 < m_CBControl.GetCount())
	{
		m_CBControl.SetCurSel(0);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CControlDlg::OnBnClickedOk2()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	int control = m_CBControl.GetCurSel();
	int channel = m_CBChannel.GetCurSel();
	switch (control)
	{
	case 0:
		g_pMainDialog->ForceIFrame(channel);
		break;
	case 1:
		g_pMainDialog->CaptureImage(channel, eBmpFormat);
		break;
	case 2:
		g_pMainDialog->ClearAlarm(channel, 0);
		break;
	case 3:
		g_pMainDialog->RecordControl(channel, 0);
		break;
	case 4:
		g_pMainDialog->RecordControl(channel, 1);
		break;
	case 5:
		g_pMainDialog->RecordControl(channel, 2);
		break;
	case 6:
		g_pMainDialog->AlarmOut(channel, 0);
		break;
	case 7:
		g_pMainDialog->AlarmOut(channel, 1);
		break;
	case 8:
		g_pMainDialog->Reboot();
		break;
	case 9:
		g_pMainDialog->Shutdown();
		break;
	case 10:
		g_pMainDialog->DiskGroupManage();
		break;
	case 11:
		g_pMainDialog->GetRecordState(channel);
		break;
	case 12:
		g_pMainDialog->GetAlarmOutState();
		break;
    case 13:
        g_pMainDialog->GetAlarmInState();
        break;
    case 14:
        g_pMainDialog->SetDefense();
        break;
    case 15:
        g_pMainDialog->UnsetDefense();
        break;
	default:
		break;
	}
}
