// HistoryQueryDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/HistoryQueryDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CHistoryQueryDlg Ի

IMPLEMENT_DYNAMIC(CHistoryQueryDlg, CDialog)

CHistoryQueryDlg::CHistoryQueryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHistoryQueryDlg::IDD, pParent)
	, m_EDRecvFile(_T("C:\\"))
{

}

CHistoryQueryDlg::~CHistoryQueryDlg()
{
}

void CHistoryQueryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBQUERYTYPE, m_CBQueryType);
	DDX_Control(pDX, IDC_CBMAINTYPE, m_CBMainType);
	DDX_Control(pDX, IDC_CBASSISTTYPE, m_CBAssistType);
	DDX_Control(pDX, IDC_STARTDATE, m_DTStartDate);
	DDX_Control(pDX, IDC_STOPDATE, m_DTStopDate);
	DDX_Text(pDX, IDC_EDRECVFILE, m_EDRecvFile);
	DDX_Control(pDX, IDC_CBGROUP, m_CBGroup);
}


BEGIN_MESSAGE_MAP(CHistoryQueryDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CHistoryQueryDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BTRECVBROWSE, &CHistoryQueryDlg::OnBnClickedBtrecvbrowse)
END_MESSAGE_MAP()


// CHistoryQueryDlg Ϣ

BOOL CHistoryQueryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	CString	cChannel;
	cChannel.Format("All");
	m_CBChannel.AddString(cChannel);
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cQueryType[] = {"All", "Plan", "Manual", "Motion", "Alarm", "Motion & Alarm"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cQueryType); count++)
	{
		m_CBQueryType.AddString(cQueryType[count]);
	}
	if (0 < m_CBQueryType.GetCount())
	{
		m_CBQueryType.SetCurSel(0);
	}

	CString cMainType[] = {"All"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cMainType); count++)
	{
		m_CBMainType.AddString(cMainType[count]);
	}
	if (0 < m_CBMainType.GetCount())
	{
		m_CBMainType.SetCurSel(0);
	}

	CString cAssistType[] = {"All"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cAssistType); count++)
	{
		m_CBAssistType.AddString(cAssistType[count]);
	}
	if (0 < m_CBAssistType.GetCount())
	{
		m_CBAssistType.SetCurSel(0);
	}

	CString cGroup[] = {"Normal And Alram", "Redundancy", "Backup"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cGroup); count++)
	{
		m_CBGroup.AddString(cGroup[count]);
	}
	if (0 < m_CBGroup.GetCount())
	{
		m_CBGroup.SetCurSel(0);
	}

	// ʱؼ
	m_DTStartDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	m_DTStopDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CHistoryQueryDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	m_info.m_Channel = m_CBChannel.GetCurSel();
	m_info.m_QueryType = m_CBQueryType.GetCurSel();
	m_info.m_MainType = m_CBMainType.GetCurSel();
	m_info.m_AssistType = m_CBAssistType.GetCurSel();
	m_info.m_DiskGroup = m_CBGroup.GetCurSel();
	CUtility cUtility;
	cUtility.TimeFormControl(m_info.m_StartTime, m_DTStartDate);
	cUtility.TimeFormControl(m_info.m_StopTime, m_DTStopDate);
	m_info.m_Record = m_EDRecvFile;
	OnOK();
}

void CHistoryQueryDlg::OnBnClickedBtrecvbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectDirectory(m_EDRecvFile, GetSafeHwnd()))
	{
		UpdateData(FALSE);
	}
}
