// HistoryQueryResultDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/HistoryQueryResultDlg.h"

#include "../inc/Utility.h"
using namespace common;

// CHistoryQueryResultDlg Ի

IMPLEMENT_DYNAMIC(CHistoryQueryResultDlg, CDialog)

CHistoryQueryResultDlg::CHistoryQueryResultDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHistoryQueryResultDlg::IDD, pParent)
{

}

CHistoryQueryResultDlg::~CHistoryQueryResultDlg()
{
}

void CHistoryQueryResultDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_RESULT, m_LSResult);
}


BEGIN_MESSAGE_MAP(CHistoryQueryResultDlg, CDialog)
END_MESSAGE_MAP()


// CHistoryQueryResultDlg Ϣ

BOOL CHistoryQueryResultDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ListView_SetExtendedListViewStyle(m_LSResult.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSResult.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSResult.InsertColumn(0, "index", LVCFMT_LEFT, 70);//ʼб
	m_LSResult.InsertColumn(1, "channel", LVCFMT_LEFT, 60);
	m_LSResult.InsertColumn(2, "type", LVCFMT_LEFT, 70);
	m_LSResult.InsertColumn(3, "start", LVCFMT_LEFT, 130);
	m_LSResult.InsertColumn(4, "stop", LVCFMT_LEFT, 130);
	m_LSResult.InsertColumn(5, "size", LVCFMT_LEFT, 85);

	CUtility	cUtility;
	CString str;
	for (ListQueryResult::iterator iter = m_lsQueryResult.begin(); iter != m_lsQueryResult.end(); iter++)
	{
		int count = m_LSResult.InsertItem(0xFFFF, "");
		str.Format("%d", count + 1);
		m_LSResult.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", iter->dwChannel);
		m_LSResult.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", iter->eStreamType);
		m_LSResult.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", iter->cBeginTime);
		m_LSResult.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", iter->cEndTime);
		m_LSResult.SetItem(count, 4, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", iter->dwStreamSize);
		m_LSResult.SetItem(count, 5, 1 , str, NULL, 0, 0, 0);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}
