// TalkStreamDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/TalkStreamDlg.h"

#include "../inc/Utility.h"
using namespace common;


// CTalkStreamDlg Ի

IMPLEMENT_DYNAMIC(CTalkStreamDlg, CDialog)

CTalkStreamDlg::CTalkStreamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTalkStreamDlg::IDD, pParent)
	, m_EDSendFile(_T("C:\\TalkSendFile.wav"))
	, m_EDRecvFile(_T("C:\\"))
{

}

CTalkStreamDlg::~CTalkStreamDlg()
{
}

void CTalkStreamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBPROTOCOL, m_CBProtocol);
	DDX_Text(pDX, IDC_EDSENDFILE, m_EDSendFile);
	DDX_Text(pDX, IDC_EDRECVFILE, m_EDRecvFile);
}


BEGIN_MESSAGE_MAP(CTalkStreamDlg, CDialog)
	ON_BN_CLICKED(IDC_BTSENDBROWSE, &CTalkStreamDlg::OnBnClickedBtsendbrowse)
	ON_BN_CLICKED(IDC_BTRECVBROWSE, &CTalkStreamDlg::OnBnClickedBtrecvbrowse)
	ON_BN_CLICKED(IDOK, &CTalkStreamDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CTalkStreamDlg Ϣ

BOOL CTalkStreamDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ

	CString cProtocol[] = {"TCP", "RTP"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cProtocol); count++)
	{
		m_CBProtocol.AddString(cProtocol[count]);
	}
	if (0 < m_CBProtocol.GetCount())
	{
		m_CBProtocol.SetCurSel(0);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CTalkStreamDlg::OnBnClickedBtsendbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectFile(m_EDSendFile))
	{
		UpdateData(FALSE);
	}
}

void CTalkStreamDlg::OnBnClickedBtrecvbrowse()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	CUtility	cUtility;
	if (0 == cUtility.SelectDirectory(m_EDRecvFile, GetSafeHwnd()))
	{
		UpdateData(FALSE);
	}
}

void CTalkStreamDlg::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	m_info.m_Protocol = m_CBProtocol.GetCurSel();
	m_info.m_cSendFile = m_EDSendFile;
	m_info.m_cRecvFile = m_EDRecvFile;

	OnOK();
}
