
// DeviceRegisterCenterDlg.h : ͷļ
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"

#include <iostream>
#include <list>
#include <map>

// CDeviceRegisterCenterDlg Ի
class CDeviceRegisterCenterDlg : public CDialog
{
public:
	int DeviceRegisterV1(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister);
	int DeviceHeartbeat(IN HUSER hUser, IN PDevicePerformanceStatus pSystemStatus);
	int DeviceHeartbeatLost(IN HUSER hUser, IN LPDeviceRegisterInfoV1 pDeviceRegister);
	int DeviceEventEx(IN HUSER hUser, IN DWORD dwEventType, IN DWORD dwSubEventType, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, IN const LPBuffer cBuffer, IN void *user);
// 
public:
	CDeviceRegisterCenterDlg(CWnd* pParent = NULL);	// ׼캯

	void Log(const char *message);
// Ի
	enum { IDD = IDD_DEVICEREGISTERCENTER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧


// ʵ
protected:
	HICON	m_hIcon;
	long	m_lUpdateListCount;
	long	m_lUpdateListBack;
	HANDLE	m_hGuardDevice;
	HANDLE	m_hGuardMessage;
	std::map<int, DeviceRegisterInfoV1> m_lsDevice;
	std::list<std::string>				m_lsMessage;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnMenuServiceStart();
	afx_msg void OnMenuServiceStop();
	afx_msg void OnMenuServiceExit();
	CListCtrl m_LSDevices;
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	CListBox m_LSMessage;
	afx_msg void OnConfigCaptcity();
	afx_msg void OnConfigSystemtime();
	afx_msg void OnAddFace();
	afx_msg void OnControlRemoteopen();
	afx_msg void OnFaceAddface();
};
