/*!
* @file
*  VideoNetClient.h
* @brief
*  ͻSDKͷļ, SDKнӿ, Ҫӿ˵
*  ͻSDK;
* @author
*  zw
* @date
*  2014623
* @version
*  5.2.0
*/

#ifndef __VIDEONET_CLIENT_H__

#define __VIDEONET_CLIENT_H__

#ifdef VNCLIENT_EXPORTS

#define VNCLIENT_API	extern "C" __declspec(dllexport)
#define CALLSTACK		__stdcall

#elif defined(__cplusplus)

#if defined(_WIN32) || defined(__WIN64)

#define VNCLIENT_API	extern "C" __declspec(dllimport)
#ifndef CALLSTACK
#define CALLSTACK		__stdcall
#endif

#else

#define VNCLIENT_API	extern "C"
#ifndef CALLSTACK
#define CALLSTACK
#endif

#endif

#else

#define VNCLIENT_API
#define CALLSTACK

#endif

//ͨϢļ
#include "./VideoNetClient_Common.h"

//SDKϢͷļ
#include "./VideoNetClient_Configure.h"
/*!
* @brief
*	
* @return
*	0ʾɹ, ʾ
* @note
*	,Ҫʱֹͣӿ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_Start();

/*!
* @brief
*	ֹͣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_Stop();

/*!
* @brief
*	û¼,豸вҪȵ¼
*	
* @param hUser
*	û,¼ӿþֵ
* @param cUserLoginPara
*	û¼Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_UserLogin(OUT HUSER *hUser, IN const LPUserLoginPara cUserLoginPara);

/*!
* @brief
*	ûע
* @param hUser
*	û,ͨû¼ȡľ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_UserLogout(IN HUSER hUser);

/*!
* @brief
*	ķ¼
* @param hUser
*	û,ͨû¼ȡľ
* @param dwEventTypes
*	Զ¼,ͨһοԶĶ¼ͬصû
* @param cbEvent
*	ص
* @param dwUserData
*	¼صʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SubscribeEvent(IN HUSER hUser, IN DWORD dwEventTypes, IN CB_UserEvent cbEvent, IN VNC_USERDATA dwUserData);

/*!
* @brief
*	˶¼
* @param hUser
*	û,ͨû¼ȡľ
* @param dwEventTypes
*	Զ¼,ͨһο˶¼
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_UnSubscribeEvent(IN HUSER hUser, IN DWORD dwEventTypes);

/*!
* @brief
*	ķ¼
* @param hUser
*	û,ͨû¼ȡľ
* @param dwEventTypes
*	Զ¼,ͨһοԶĶ¼ͬصû
* @param cbEvent
*	ص
* @param dwUserData
*	¼صʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SubscribeEventEx(IN HUSER hUser, IN DWORD dwEventTypes, IN CB_UserEventEx cbEventEx, IN VNC_USERDATA dwUserData);

/*!
* @brief
*	Ϣ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetConfig(IN HUSER hUser, IN const LPConfigInformation cConfig);

/*!
* @brief
*	Ϣ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetConfigV2(IN HUSER hUser, IN const LPConfigInformationV2 cConfig);

/*!
* @brief
*	Ϣ, ó32ͨ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetConfigV3(IN HUSER hUser, IN const LPConfigInformationV3 cConfig);

/*!
* @brief
*	ȡϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetConfig(IN HUSER hUser, IN LPConfigInformation cConfig);

/*!
* @brief
*	ȡϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetConfigV2(IN HUSER hUser, IN LPConfigInformationV2 cConfig);


VNCLIENT_API int CALLSTACK VideoNetClient_GetConfigV3(IN HUSER hUser, IN LPConfigInformationV3 cConfig);

/*!
* @brief
*	Ϣ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @param dwTimeOut
*	ʱʱ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetConfigV4(IN HUSER hUser, IN const LPConfigInformationV3 cConfig, IN DWORD dwTimeOut);

/*!
* @brief
*	Ϣ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	Ϣ
* @param dwTimeOut
*	ʱʱ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetConfigV4(IN HUSER hUser, IN LPConfigInformationV3 cConfig, IN DWORD dwTimeOut);


VNCLIENT_API int CALLSTACK VideoNetClient_TransparentData(IN HUSER hUser, IN_OUT char * pBuffer,IN_OUT int & nBufferLen);

VNCLIENT_API int CALLSTACK VideoNetClient_TransparentDataV2(IN HUSER hUser, char* pHttpRequest, int dwRequestLen, char** ppResponse, int* pResponseLen);

VNCLIENT_API int CALLSTACK VideoNetClient_ReleaseTransparentDataV2Buffer(char * pBuffer);


/*!
* @brief
*	ȡͻSDK(ڿƿͻSDKӿΪ)
* @param eType
*	ͻSDK
* @param dwAttribute
*	ͻSDKֵ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetAttribute(IN eClientSDKAttributeType eType, OUT DWORD *dwAttribute);

/*!
* @brief
*	ÿͻSDK(ڿƿͻSDKӿΪ)
* @param eType
*	ͻSDK
* @param dwAttribute
*	ͻSDKֵ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetAttribute(IN eClientSDKAttributeType eType, IN DWORD dwAttribute);

/*!
* @brief
*	Զ豸
* @param hUser
*	û,ͨû¼ȡľ
* @param eOperationCode
*	롡
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceControl(IN HUSER hUser, IN eRemoteDeviceControl eOperationCode);

/*!
* @brief
*	Զ豸
* @param hUser
*	û,ͨû¼ȡľ
* @param eOperationCode
*	롡
* @param dwTimeOut
*	ʱʱ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceControlV1(IN HUSER hUser, IN eRemoteDeviceControl eOperationCode, IN DWORD dwTimeOut);


/*!
* @brief
*	Զ豸ǿI֡
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_ForceIFrame(IN HUSER hUser,IN DWORD dwChannel);

/*!
* @brief
*	Զ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param dwAlarmType
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_AlarmClear(IN HUSER hUser,IN DWORD dwChannel, IN DWORD dwAlarmType);

/*!
* @brief
*	Զץͼ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param eFormat
*	ͼƬʽ
* @param pImageFileInfo
*	ͼƬϢ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_ImageCapture(IN HUSER hUser, IN DWORD dwChannel, IN eImageFormat eFormat, OUT LPImageFileInfo pImageFileInfo);

/*!
* @brief
*	Զļ
* @param hUser
*	û,ͨû¼ȡľ
* @param szFileName
*	ļ
* @param eOperationCode
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileLock(IN HUSER hUser, IN char *szFileName, IN eFileLockOperationCode eOperationCode);

/*!
* @brief
*	Զ¼
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param dwRecordType
*	¼
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RecordControl(IN HUSER hUser, IN DWORD dwChannel, IN DWORD dwRecordType);

/*!
* @brief
*	Զ̱
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param dwSwitch
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_AlarmoutControl(IN HUSER hUser, IN DWORD dwChannel, IN DWORD dwSwitch);

/*!
* @brief
*	ȡԶ̱״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChanNum
*	Чͨ
* @param dwStateBits
*	λ0-31ֱʾ031ͨı״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_AlarminStateGet(IN HUSER hUser, OUT DWORD* dwChanNum, OUT DWORD* dwStateBits);

/*!
* @brief
*	ȡԶ̱״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChanNum
*	Чͨ
* @param dwStateBits
*	λ0-31ֱʾ031ͨı״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_AlarmoutStateGet(IN HUSER hUser, OUT DWORD* dwChanNum, OUT DWORD* dwStateBits);

/*!
* @brief
*	ʵʱ
* @param hStream
*	ý,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamPara
*	ʵʱϢ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RealStreamConnect(OUT HSTREAM *hStream, IN HUSER hUser, IN const LPRealStreamPara cStreamPara);

/*!
* @brief
*	Ͽʵʱ
* @param hStream
*	ý,ͨʵʱȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RealStreamDisconnect(IN HSTREAM hStream);

/*!
* @brief
*	ʷֵ֧ͨһ¼ͺ¼ͣ
* @param hHistory
*	ʷͨ,ӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamPara
*	ʷͨϢ
* @param dwUserData
*	ʷûݣݻʷ¼֪ͨдݸû
*	ûԸݸûжһʷʷػǻطŵ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamCreate(OUT HSTREAM *hHistory, IN HUSER hUser, IN const LPHistoryStreamPara cStreamPara, IN DWORD dwUserData);

/*!
* @brief
*	ʷֶ֧ͨ¼͵ϣ
* @param hHistory
*	ʷͨ,ӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamPara
*	ʷͨϢ
* @param dwUserData
*	ʷûݣݻʷ¼֪ͨдݸû
*	ûԸݸûжһʷʷػǻطŵ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamMultiTypeCreate(OUT HSTREAM *hHistory, IN HUSER hUser, IN const LPHistoryStreamMultiTypePara cStreamPara, IN DWORD dwUserData);

/*!
* @brief
*	ʷͨ
* @param hHistory
*	ʷͨ,ͨʷͨȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamDestroy(IN HSTREAM hHistory);

/*!
* @brief
*	ʷͨʱλ
* @param hHistory
*	ʷͨ,ͨʷͨȡ
* @param eOperation
*	ʷͨ
* @param cTime
*	ʷͨʱϢ,ȡʱ˲Ϊ,ʱ˲Ϊ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamPosition(IN HSTREAM hHistory, IN eOperationType eOperation, IN_OUT TimeInfo *cTime);

/*!
* @brief
*	Ŀʷͨ׼ʷͨͬ
* @param hHistory
*	׼ʷͨ,ӵԸʷͨʱΪ׼
* @param hDestHistory
*	Ŀʷͨʷͨڻ׼ʷͨͬ
* @return
*	0ʾɹ, ʾ
* @note
*	ʷֶ֧ͨͬʱͬʱ
* @note
*	ӿ: ʽ
* @note
*	ʷͬ󣬻hHistoryΪ׼ٶλһΣλʱhHistoryʼʱ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamSync(IN HSTREAM hHistory, IN HSTREAM hDestHistory);

/*!
* @brief
*	Ŀʷͨӻ׼ʷƳ
* @param hHistory
*   ׼ʷͨ
* @param hDestHistory
*	Ŀʷͨ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamUnSync(IN HSTREAM hHistory, IN HSTREAM hDestHistory);

/*!
* @brief
*	ʷٶ
* @param hHistory
*   ʷͨ
* @param dwSpeed
*	ʷٶȣ2x 4x 8x 16x
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamSetSpeed(IN HSTREAM hHistory, IN DWORD dwSpeed);

/*!
* @brief
*	ʷصӿ
* @param hStream
*	ý,ͨȡ
* @param cbStreamMedia
*	ýصӿ
* @param dwUserData
*	ýصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿýݻص,
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamCB(IN HSTREAM hStream, IN CB_StreamMedia cbStreamMedia, IN DWORD dwUserData);

/*!
* @brief
*	
* @param hStream
*	,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamPara
*	Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_VoiceStreamConnect(OUT HSTREAM *hStream, IN HUSER hUser, IN const LPVoiceStreamPara cStreamPara);

/*!
* @brief
*	Ͽ
* @param hStream
*	,ͨȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_VoiceStreamDisconnect(IN HSTREAM hStream);

/*!
* @brief
*	ݽӿ
* @param hStream
*	,ͨȡ
* @param cFrame
*	֡,ɴصȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_VoiceStreamSend(IN HSTREAM hStream, IN const LPBuffer cFrame);

/*!
* @brief
*	صӿ
* @param hStream
*	,ͨȡ
* @param cbStreamVoice
*	صӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	صʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ڴ˻صݽ벶̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_VoiceStreamCB(IN HSTREAM hStream, IN CB_StreamVoice cbStreamVoice, IN VNC_USERDATA dwUserData);

/*!
* @brief
*	ýصӿ
* @param hStream
*	ý,ͨȡ
* @param cbStreamMedia
*	ýصӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	ýصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿýݻص,
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamMediaCB(IN HSTREAM hStream, IN CB_StreamMedia cbStreamMedia, IN VNC_USERDATA dwUserData);

/*!
* @brief
*	ԭʼýصӿ
* @param hStream
*	ý,ͨȡ
* @param cbStreamMedia
*	ýصӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	ýصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿýݻص,
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamMediaRawCB(IN HSTREAM hStream, IN CB_StreamMediaRaw cbStreamMedia, IN VNC_USERDATA dwUserData);

/*!
* @brief
*	ýƽӿ,ýֹͣ
* @param hStream
*	ý,ͨȡ
* @param eMediaControl
*	ý
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamMediaControl(IN HSTREAM hStream, IN eTaskControl eMediaControl);

/*!
* @brief
*	ýID
* @param hStream
*	ý,ͨȡ
* @param dwLinkID
*	ýID
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*	õýIDᱣ浽,ڷ֮ǰһֱ,ͻԲѯ豸ϵID
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetStreamMediaLinkID(IN HSTREAM hStream, IN DWORD dwLinkID);

/*!
* @brief
*	ѯýID
* @param hStream
*	ý,ͨȡ
* @param eType
*	ý
* @param cQueryResult
*	ѯID
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*	ѯڷϵýID
*/
VNCLIENT_API int CALLSTACK VideoNetClient_QueryStreamMediaLinkID(IN HUSER hUser, IN eMediaFunctionType eType, IN LPMediaLinkIDQueryResult cQueryResult);

/*!
* @brief
*	ʷѯӲֵ֧һ¼ͺ¼ͣ
* @param hStreamQuery
*	ʷѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamQueryFactor
*	ʷѯ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamQueryConnect(OUT HSTREAM_QUERY *hStreamQuery, IN HUSER hUser, IN LPHistoryStreamQueryFactor cStreamQueryFactor);

/*!
* @brief
*	ʷѯӲֶ֧¼͵ϣ
* @param hStreamQuery
*	ʷѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamQueryFactor
*	ʷѯ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamMultiTypeQueryConnect(OUT HSTREAM_QUERY *hStreamQuery, IN HUSER hUser, IN LPHistoryStreamMultiTypeQueryFactor cStreamQueryFactor);


/*!
* @brief
*	ʷѯӲֶ֧¼͵ϣ(չļʽѯ)
* @param hStreamQuery
*	ʷѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamQueryFactor
*	ʷѯ
* @param result_list
*	ʷѯ¼һԸһռ䣬ɣУ6400Ԫؿռӣ
* @param list_cnt
*	ʷѯ¼ΪʾռСΪʱʾļ¼
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamMultiTypeQueryConnectEx(OUT HSTREAM_QUERY *hStreamQuery, IN HUSER hUser, IN LPHistoryStreamMultiTypeQueryFactor pStreamQueryFactor, IN_OUT LPHistoryStreamMultiTypeQueryResult result_list, IN_OUT int* list_cnt);


/*!
* @brief
*	ʷѯϿ
* @param hStreamQuery
*	ʷѯ,ͨʷѯȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamQueryDisconnect(IN HSTREAM_QUERY hStreamQuery);

/*!
* @brief
*	ʷѯһֵ֧һ¼ͺ¼ͣ
* @param hStreamQuery
*	ʷѯ,ͨʷѯȡ
* @param pStreamQueryResult
*	ʷѯһ¼
* @return
*	0ʾɹ, 2Ϊѯæ,3ΪѯѾ,ֵΪ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamQueryNext(IN HSTREAM_QUERY hStreamQuery, OUT LPHistoryStreamQueryResult pStreamQueryResult);

/*!
* @brief
*	ʷѯһֶ֧¼͵ϣ
* @param hStreamQuery
*	ʷѯ,ͨʷѯȡ
* @param pStreamQueryResult
*	ʷѯһ¼
* @return
*	0ʾɹ, 2Ϊѯæ,3ΪѯѾ,ֵΪ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryStreamMultiTypeQueryNext(IN HSTREAM_QUERY hStreamQuery, OUT LPHistoryStreamMultiTypeQueryResult pStreamQueryResult);

/*!
* @brief
*	ļѯӲ
* @param hFileQuery
*	ļѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param pFileQueryFactor
*	ļѯ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileQueryConnect(OUT HFILE_QUERY *hFileQuery, IN HUSER hUser, IN LPFileQueryFactor pFileQueryFactor);

/*!
* @brief
*	ļѯϿ
* @param hFileQuery
*	ļѯ,ͨļѯȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileQueryDisconnect(IN HFILE_QUERY hFileQuery);

/*!
* @brief
*	ļѯһ
* @param hFileQuery
*	ļѯ ,ͨļѯȡ
* @param pFileQueryResult
*	ļѯһ¼
* @return
*	0ʾɹ, 2Ϊѯæ,3ΪѯѾ,ֵΪ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileQueryNext(IN HFILE_QUERY hFileQuery, OUT LPFileQueryResult pFileQueryResult);

/*!
* @brief
*	ʷ־ѯӲ
* @param hLogQuery
*	ʷ־ѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cLogQueryFactor
*	ʷ־ѯ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryLogQueryConnect(OUT HLOG_QUERY *hLogQuery, IN HUSER hUser, IN LPLogQueryFactor pLogQueryFactor);

/*!
* @brief
*	ʷ־ѯϿ
* @param hLogQuery
*	ʷ־ѯ,ͨʷ־ѯȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryLogQueryDisconnect(IN HLOG_QUERY hLogQuery);

/*!
* @brief
*	ʷ־ѯһ
* @param hLogQuery
*	ʷ־ѯ,ͨʷ־ѯȡ
* @param pLogQueryResult
*	ʷ־ѯһ¼
* @return
*	0ʾɹ, 2Ϊѯæ,3ΪѯѾ,ֵΪ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_HistoryLogQueryNext(IN HLOG_QUERY hLogQuery, OUT LPLogQueryResult pLogQueryResult);

/*!
* @brief
*	͸ͨӲ
* @param hTransparent
*	͸ͨ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param pTransparentPara
*	͸ͨӲ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransparentChannelConnect(OUT HTRANSPARENT *hTransparent, IN HUSER hUser, IN LPTransparentChannelPara pTransparentPara);

/*!
* @brief
*	͸ͨϿ
* @param hTransparent
*	͸ͨ,ͨ͸ͨȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransparentChannelDisconnect(IN HTRANSPARENT hTransparent);

/*!
* @brief
*	͸ͨݷ
* @param hTransparent
*	͸ͨ,ͨ͸ͨȡ
* @param cBuffer
*	͸ͨݻ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransparentChannelWrite(IN HTRANSPARENT hTransparent, IN const LPBuffer pBuffer);

/*!
* @brief
*	͸ͨݻصӿ
* @param hTransparent
*	͸ͨ,ͨ͸ͨȡ
* @param cbTransparent
*	͸ͨݻصӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	͸ͨݻصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ڴ˻ص͸ͨݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransparentChannelCB(IN HTRANSPARENT hTransparent, IN CB_TransparentChannel cbTransparent, IN DWORD dwUserData);

/*!
* @brief
*	ļϴӲ
* @param hFileTransfer
*	ļϴ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param pFileUploadPara
*	ļϴ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileUploadConnect(OUT HFILE_TRANSFER *hFileTransfer, IN HUSER hUser, IN LPFileUploadPara pFileUploadPara);

/*!
* @brief
*	ļϴ
* @param hFileTransfer
*	ļϴ,Ӻӿþֵ
* @param eControlCode
*	ֹͣļ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileUploadControl(IN HFILE_TRANSFER hFileTransfer, IN eFileTransferControl eControlCode);

/*!
* @brief
*	ļϴϿ
* @param hFileTransfer
*	ļϴ,ͨļϴȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileUploadDisconnect(IN HFILE_TRANSFER hFileTransfer);

/*!
* @brief
*	ļϴصӿ
* @param hFileTransfer
*	ļϴ,ͨļϴȡ
* @param cbFileUpload
*	ļϴ״̬ص
* @param dwUserData
*	ļϴصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileUploadCB(IN HFILE_TRANSFER hFileTransfer, IN CB_FileUpload cbFileUpload, IN DWORD dwUserData);

/*!
* @brief
*	ļӲ
* @param hFileTransfer
*	ļؾ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param pFileDownloadPara
*	ļز
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileDownloadConnect(OUT HFILE_TRANSFER *hFileTransfer, IN HUSER hUser, IN LPFileDownloadPara pFileDownloadPara);


/*!
* @brief
*	ļؿ
* @param hFileTransfer
*	ļؾ,Ӻӿþֵ
* @param eControlCode
*	ֹͣļ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileDownloadControl(IN HFILE_TRANSFER hFileTransfer, IN eFileTransferControl eControlCode);


/*!
* @brief
*	ļضϿ
* @param hFileTransfer
*	ļؾ,ͨļػȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileDownloadDisconnect(IN HFILE_TRANSFER hFileTransfer);

/*!
* @brief
*	ļػصӿ
* @param hFileTransfer
*	ļؾ,ͨļػȡ
* @param cbFileDownload
*	ļݻص
* @param dwUserData
*	ļػصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_FileDownloadCB(IN HFILE_TRANSFER hFileTransfer, IN CB_FileDownload cbFileDownload, IN DWORD dwUserData);

/*!
 * \brief
 *	򣬼豸ע
 * \param sListenIP
 *  PC IP ַΪNULLSDK ԶȡPC IP ַ
 *   PC жIP ַָһIP ַм
 * \param dwListenPort
 *   ؼ˿ںţû;
 * \return
*	0ʾɹ, ʾ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceRegisterListenStart(IN char *sListenIP, IN DWORD dwListenPort);

/*!
 * \brief
 *	ֹͣ
 * \return
 *   TRUEʾɹ FALSEʾʧ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceRegisterListenStop();

/*!
* \brief
*    豸עص
* \param cbDeviceRegister
*    صָ
* \param user
*    û
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceRegisterCBV1(IN CB_DeviceRegisterV1 cbDeviceRegister, IN void *user);

/*!
* \brief
*    豸ص
* \param cbDeviceHeartbeat
*    صָ
* \param cbDeviceHeartbeatLost
*    ʧصָ
* \param user
*    û
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceHeartbeatCB(IN CB_DeviceHeartbeat cbDeviceHeartbeat, IN CB_DeviceHeartbeatLost cbDeviceHeartbeatLost, IN void *user);

/*!
* \brief
*    豸¼ص
* \param cbDeviceEvent
*    صָ
* \param user
*    û
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceEventCB(IN CB_DeviceEventEx cbDeviceEvent, IN void *user);

/*!
 * \brief
 *  豸עỰ͸ݽӿ
 * \param hUser
 *  豸עỰ
 * \param pHttpRequest
 *  ͸
 * \param dwRequestLen
 *  ͸ݳ
 * \param ppResponse
 *  ͸ӦݣûɽӿڲṩʹVideoNetClient_ReleaseDataӿͷŻ
 * \param pResponseLen
 *  ͸Ӧݳ
 * \return
 *	0ʾɹ, ʾ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceRegisterTransparentData(IN HUSER hUser, char* pHttpRequest, int dwRequestLen, char** ppResponse, int* pResponseLen);

/*!
 * \brief
 *  ͷڲṩĻ
 * \param pBuffer
 *  ڲṩĻ
 * \return
 *	0ʾɹ, ʾ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_ReleaseData(char * pBuffer);


/*!
* \brief
*    豸עص
* \param cbDeviceRegister
*    صָ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceRegisterCB(IN CB_DeviceRegister cbDeviceRegister);

/*!
 * \brief
 *  Զ̿PTZ
 * \param hUser
 *  û¼
 * \param dwChannel
 *   ͨ(0ʼ)
 * \param eCommandCode
 *   PTZ
 * \param dwParam1
 *   PTZ1
 * \param dwParam2
 *   PTZ2
 * \param dwParam3
 *   PTZ3
 * \param dwParam4
 *   PTZ4
 * \return
 *	0ʾɹ, ʾ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_PTZControl(IN HUSER hUser, IN DWORD dwChannel, IN ePTZControlCmdCode eCommandCode, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3, DWORD dwParam4);

/*!
 * \brief
 *  жĳǷָ
 * \param hUser
 *  û¼
 * \param dwChannel
 *   ͨ(0ʼѯͼƬļʱòʾͨţѯ¼ļʱòʾ)
 * \param dwMajorType
 *   ͣ0-¼ļ   1-ͼƬļ
 * \param dwMinorType
 *   ͣʱûʹã
 * \param szYearMonth
 *   ʱ䴮磺201001
 * \return
 *	0ʾɹ, ʾ
 */
VNCLIENT_API int CALLSTACK VideoNetClient_DataExistCheck(IN HUSER hUser, IN DWORD dwChannel, IN DWORD dwMajorType, IN DWORD dwMinorType, IN char *szYearMonth, OUT DWORD *dwResult);

/*!
* @brief
*	Զ
* @param hUser
*	û,ͨû¼ȡľ
* @param eOperationCode
*	
* @param dwParam1-3
*	б
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DiskGroupManage(IN HUSER hUser, IN eDiskGroupOperation eOperationCode, IN DWORD dwParam1, IN DWORD dwParam2, IN DWORD dwParam3);

/*!
* @brief
*	ȡݴСֶ֧¼͵ϣ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannelBits
*	031λֱʾ031ͨѡ״̬1ʾѡ
* @param eDskGroupType
*	̷
* @param eStreamType
*	¼
* @param szStartTime
*	ʼʱ
* @param szEndTime
*	ʱ
* @param dwDataSize
*	ݴС
* @param dwUserData
*	û
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetMultiTypeDataSize(IN HUSER hUser, IN DWORD dwChannelBits,IN eDiskGroupType eDskGroupType, IN DWORD dwStreamType, IN const char *szStartTime, IN const char *szEndTime, IN DWORD dwUserData, OUT DWORD *dwDataSize);

/*!
* @brief
*	ȡݴСֵ֧һ¼ͺ¼ͣ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannelBits
*	031λֱʾ031ͨѡ״̬1ʾѡ
* @param eDskGroupType
*	̷
* @param eStreamType
*	¼
* @param szStartTime
*	ʼʱ
* @param szEndTime
*	ʱ
* @param dwDataSize
*	ݴС
* @param dwUserData
*	û
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetDataSize(IN HUSER hUser, IN DWORD dwChannelBits,IN eDiskGroupType eDskGroupType, IN eHistoryStreamType dwStreamType, IN const char *szStartTime, IN const char *szEndTime, IN DWORD dwUserData, OUT DWORD *dwDataSize);

/*!
* @brief
*	ǿɾѵ¼ûصӿ
* @param hUser
*	û,ͨû¼ȡľ
* @param cbStreamMedia
*	ýصӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	ʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿǿɾѵ¼ûص,
*	ɴ˽ӿ֪ͨûѱ豸ǿɾ,
*	ڴ˻صҪظ豸,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeleteUserForceCB(IN CB_DeleteUserForce cbDeleteUserForce, IN DWORD dwUserData);

/*!
* \brief
*	ַת
* \param pString
*	Դַ
* \param cFont
*   Ϣ
* \param buffer
*   ݻ
* \param dwBuflen
*   ݻ,ת󽫱дΪʵʹõĳ
* \param dwWidth
*   ʵʵ
* \param dwHeight
*   ʵʵ߶
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StringToLattice(IN const char *pString, IN const LPFontPara cFont, OUT void *buffer, IN_OUT DWORD *dwBuflen, OUT DWORD *dwWidth, OUT DWORD *dwHeight);


/*
* @brief
*	ģʽƽӿ
* @param dwScreenDev
*	0, 1234ֱspot1spot2spot3spot4
* @param dwUserID
*	ûID
* @param dwSplitNum
*	֧1-16
* @param pChanList
*	ͨбpChanListʾһDWORD飬16DWORDԱ磺dwSplitNumΪ4ʱܹ4
*	pChanList[0]Ϊ2ʾһԤͨ2Ƶźš
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetScreenSplitMode(IN HUSER hUser, IN const DWORD dwScreenDev, IN const DWORD dwSplitNum, IN DWORD* pChanList);


/*!
* \brief
*	ʹHTTPЭȡ˵Ϣ
* \param pURL
*	URL·,øʽ:
*	:			http://xxx.xxx.com
*	IPַ:		http://xxx.xxx.xxx.xxx
*	˿:		http://xxx.xxx.com:port
*	IPַ˿	http://xxx.xxx.xxx.xxx:port
* \param cConfig
*   HTTP豸
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetDeviceConfigFromHttp(IN const char *pURL, OUT LPDeviceConfigFromHttp cConfig);

/*!
* \brief
*	ʹHTTPЭȡ豸֧ʹЩЭIPC
* \param pURL
*	URL·,øʽ:
*	:			http://xxx.xxx.com
*	IPַ:		http://xxx.xxx.xxx.xxx
*	˿:		http://xxx.xxx.com:port
*	IPַ˿	http://xxx.xxx.xxx.xxx:port
* \param cConfig
*   HTTPЭ֧
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetProtCapFromHttp(IN const char *pURL, OUT SUPPORT_NETWORK_PROTOCOL_CAP* cConfig);

/*!
* \brief
*	̽豸,ָ̽ϢΧ̽豸
* \param cParameter
*	̽ò
* \param cbDeviceProbe
*	̽صӿ
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeStart(IN const LPDeviceProbeParameter cParameter, IN CB_DeviceProbe cbDeviceProbe);

/*!
* \brief
*	̽豸,ָ̽ϢΧ̽豸
* \param cParameter
*	̽ò
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeRefresh(IN const LPDeviceProbeParameter cParameter);

/*!
* \brief
*	ֹͣ̽豸
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeStop();

/*!
* \brief
*	̽豸,ָ̽ϢΧ̽豸
* \param cParameter
*	̽ò
* \param cbDeviceProbeV2
*	̽صӿ
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeStartV2(IN const LPDeviceProbeParameter cParameter, IN CB_DeviceProbeV2 cbDeviceProbeV2);

/*!
* \brief
*	̽豸,ָ̽ϢΧ̽豸
* \param cParameter
*	̽ò
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeRefreshV2(IN const LPDeviceProbeParameter cParameter);

/*!
* \brief
*	ֹͣ̽豸
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeStopV2();

/*!
* \brief
*	̽豸,ָ̽ϢΧ̽豸
*   ܹ̽ϰ汾豸ϢҲܹ̽⵽°汾豸Ϣ
* \param cParameter
*	̽ò
* \param cbDeviceProbeV3
*	̽صӿ
* \param dwUserdata
*	û. ݽڻصʱʹ
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeStartV3(IN const LPDeviceProbeParameter cParameter, IN CB_DeviceProbeV3 cbDeviceProbeV3, IN DWORD dwUserdata);



/*!
* \brief
*	豸߼߳
* \param cParameter
*	̽ò
* \param cbDeviceProbe
*	̽صӿ
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceOnlineStart(IN const LPDeviceProbeParameter cParameter, IN CB_DeviceNotifyOnline cbDeviceNotifyOnline);

/*!
* \brief
*	ǿĳ豸
* \param hUser
*	û
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceForceReconnect(IN const HUSER hUser);

/*!
* \brief
*	ֹͣ̽豸
* \return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceOnlineStop();


/*!
* \brief
*	ͨ̽ⷽʽ豸
* \param pMac
*	豸MACַ, ͬDeviceProbeConfigṹMACַϢ, Ϊ MAC_BINARY_ADDRESS_LEN
* \param wProbePort
*	豸̽˿
* \param cConfig
*	豸Ϣ
* \return
*	0ʾɹ, ʾ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeSetDeviceConfig(IN const BYTE *pMac, IN WORD wProbePort, IN const LPDeviceProbeConfig cConfig);

/*!
* \brief
*	ͨ̽ⷽʽָ̽˿ڷΧڵ豸
* \param cParameter
*	̽ò
* \param cConfig
*	豸Ϣ
* \return
*	0ʾɹ, ʾ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeSetAllDeviceConfig(IN const LPDeviceProbeParameter cParameter, IN const LPDeviceProbeConfig cConfig);

/*!
* \brief
*	ͨ̽ⷽʽ豸
* \param pMac
*	豸MACַ, ͬDeviceProbeConfigṹMACַϢ, Ϊ MAC_BINARY_ADDRESS_LEN
* \param wProbePort
*	豸̽˿
* \param cUser
*	豸ûϢ
* \param cConfig
*	豸Ϣ
* \return
*	0ʾɹ, ʾ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceProbeSetConfig(IN const BYTE *pMac, IN WORD wProbePort, IN const LPDeviceProbeUserLoginPara cUser, IN const LPDeviceProbeConfigInformation cConfig);


/*!
* \brief
*	ͨ̽ⷽʽȡ豸
* \param pMac
*	豸MACַ, ͬDeviceProbeConfigV2ṹMACַϢ, Ϊ MAC_BINARY_ADDRESS_LEN
* \param wProbePort
*	豸̽˿
* \param cUser
*	豸ûϢ
* \param cConfig
*	豸Ϣ
* \return
*	0ʾɹ, ʾ
*/
VNCLIENT_API int CALLSTACK VNCLIENT_API_DeviceProbeGetConfig(IN const BYTE *pMac, IN WORD wProbePort, IN const LPDeviceProbeUserLoginPara cUser, IN_OUT LPDeviceProbeConfigInformation cConfig);


/*
* @brief
*	ȡ״̬
* @param dwUserID
*	ûID
* @param cStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_PanelGetStatus(IN HUSER hUser, OUT LPPanelStatusInfo cStatus);

/*
* @brief
*	״̬
* @param dwUserID
*	ûID
* @param cStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_PanelSetStatus(IN HUSER hUser, IN LPPanelStatusInfo cStatus);

/*
* @brief
*	
* @param dwUserID
*	ûID
* @param cControl
*	Ʋ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_PanelControl(IN HUSER hUser, IN LPPanelControlParameter cControl);

/*!
* @brief
*	ԶûָɫĬϲ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param dwTimeSection
*	ʱαţɫõĸ߼ģʽɫȵ÷Ϊ4ʱΣ1ʾĬʱ(ָԶʱʱ)
*	248ֱʾ3ԶʱΡ
*	ͨԶԶʱνã(1|4)ʾĬʱκ͵2Զʱνá
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetChromaDefault(IN HUSER hUser,IN DWORD dwChannel, IN DWORD dwTimeSection);

/*
* @brief
*	Ĭļͷȡ
* @param inStreamID
*	ýID
* @param pBuffer
*	ĬļͷĻ
* @param pBufferLen
*	Ĭļͷ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetFileHeader(IN DWORD inStreamID,IN_OUT char* pBuffer,IN_OUT DWORD* pBufferLen);
#if 0
/*!
* @brief
*	ת
* @param hStream
*	ý,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cStreamPara
*	ӲϢ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*	ڽƵԴ豸ȡת洢豸.
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamTransferConnect(OUT HSTREAM *hStream, IN HUSER hUser, IN DWORD dwChannel, IN const LPStreamTransferPara cStreamPara);

/*!
* @brief
*	ýת
* @param hStream
*	ý,ͨתӻȡ
* @param cFrame
*	֡Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamTransferSend(IN HSTREAM hStream, IN const LPStreamTransferFrame cFrame);

/*!
* @brief
*	תϿ
* @param hStream
*	ý,ͨתӻȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_StreamTransferDisconnect(IN HSTREAM hStream);

/*!
* @brief
*	̬ý
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cStreamPara
*	ӲϢ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*	̬ýӲᱣ,豸ý岻Զ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderDynamicConnect(IN HUSER hUser, IN DWORD dwChannel, IN const LPDecoderDynamicInformation cStreamPara);

/*!
* @brief
*	̬ýϿ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderDynamicDisconnect(IN HUSER hUser, IN DWORD dwChannel);

/*!
* @brief
*	ýϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderSetConfig(IN HUSER hUser, IN const LPDecoderDeviceConfig cConfig);

/*!
* @brief
*	ȡϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetConfig(IN HUSER hUser, IN LPDecoderDeviceConfig cConfig);

/*!
* @brief
*	ýͨϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderSetChannelConfig(IN HUSER hUser, IN DWORD dwChannel, IN const LPDecoderChannelConfig cConfig);

/*!
* @brief
*	ȡͨϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetChannelConfig(IN HUSER hUser, IN DWORD dwChannel, IN LPDecoderChannelConfig cConfig);

/*!
* @brief
*	ýͨƵʽ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderSetVideoStandard(IN HUSER hUser, IN DWORD dwChannel, IN const LPDecoderVideoStandardConfig cConfig);

/*!
* @brief
*	ȡͨƵʽ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetVideoStandard(IN HUSER hUser, IN DWORD dwChannel, IN LPDecoderVideoStandardConfig cConfig);

/*!
* @brief
*	ýͨת
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderSetChannelLoopConfig(IN HUSER hUser, IN DWORD dwChannel, IN const LPDecoderChannelLoopConfig cConfig);

/*!
* @brief
*	ȡͨת
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetChannelLoopConfig(IN HUSER hUser, IN DWORD dwChannel, IN LPDecoderChannelLoopConfig cConfig);

/*!
* @brief
*	ýͨѯ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param eStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelSetLoopEnable(IN HUSER hUser, IN DWORD dwChannel, IN eDecoderChannelStatus eStatus);

/*!
* @brief
*	ȡͨѯ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param eStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelGetLoopEnable(IN HUSER hUser, IN DWORD dwChannel, IN eDecoderChannelStatus *eStatus);

/*!
* @brief
*	ȡͨѯ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param cStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetLoopEnable(IN HUSER hUser, IN LPDecoderLoopStatus cStatus);

/*!
* @brief
*	ȡͨϢ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cInformation
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetChannelInformation(IN HUSER hUser, IN DWORD dwChannel, IN LPDecoderChannelInformation cInformation);

/*!
* @brief
*	ȡͨ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param cStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelGetStatus(IN HUSER hUser, IN LPDecoderChannelStatus cStatus);

/*!
* @brief
*	ýͨ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cControl
*	Ʋ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelSetPlayStatus(IN HUSER hUser, IN DWORD dwChannel, IN LPDecoderSetPlayStatusParameter cControl);

/*!
* @brief
*	ȡͨ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param cControl
*	Ʋ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelGetPlayStatus(IN HUSER hUser, IN LPDecoderGetPlayStatusParameter cControl);

/*!
* @brief
*	ϴLOGOͼƬ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param cParameter
*	LOGOͼƬ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_UploadLogo(IN HUSER hUser, IN DWORD dwChannel, IN LPUploadLogoParameter cParameter);

/*!
* @brief
*	лͨLOGOͼƬ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwChannel
*	ͨ
* @param eOperationCode
*	롡
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelLogoSwitch(IN HUSER hUser, IN DWORD dwChannel, IN eDeviceChannelControl eOperationCode);

/*!
* @brief
*	ʾͨʾ״̬
* @param hUser
*	û,ͨû¼ȡľ
* @param dwDisplay
*	ʾͨ
* @param cStatus
*	״̬
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderChannelDisplayControl(IN HUSER hUser, IN DWORD dwDisplay, IN LPDecoderDisplayStatus cStatus);

/*!
* @brief
*	ʾ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwDisplay
*	ʾ豸
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderSetDisplayConfig(IN HUSER hUser, IN DWORD dwDisplay, IN const LPDecoderDisplayConfig cConfig);

/*!
* @brief
*	ȡʾ
* @param hUser
*	û,ͨû¼ȡľ
* @param dwDisplay
*	ʾ豸
* @param cConfig
*	
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DecoderGetDisplayConfig(IN HUSER hUser, IN DWORD dwDisplay, IN LPDecoderDisplayConfig cConfig);

/*!
* @brief
*	תʷѯӲֶ֧¼͵ϣ
* @param hStreamQuery
*	ʷѯ,Ӻӿþֵ
* @param hUser
*	û,ͨû¼ȡľ
* @param cStreamQueryFactor
*	ʷѯ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransmitHistoryStreamQueryConnect(OUT HSTREAM_QUERY *hStreamQuery, IN HUSER hUser, IN LPTransmitHistoryStreamQueryFactor cStreamQueryFactor);

/*!
* @brief
*	תʷѯϿ
* @param hStreamQuery
*	ʷѯ,ͨʷѯȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransmitHistoryStreamQueryDisconnect(IN HSTREAM_QUERY hStreamQuery);

/*!
* @brief
*	תʷѯһֵ֧һ¼ͺ¼ͣ
* @param hStreamQuery
*	ʷѯ,ͨʷѯȡ
* @param pStreamQueryResult
*	ʷѯһ¼
* @return
*	0ʾɹ, 2Ϊѯæ,3ΪѯѾ,ֵΪ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_TransmitHistoryStreamQueryNext(IN HSTREAM_QUERY hStreamQuery, OUT LPHistoryStreamMultiTypeQueryResult pStreamQueryResult);
#endif
/*!
* @brief
*	豸Ƿ
* @param cAddress
*	豸ַ
* @param dwCommandPort
*	豸˿
* @param dwTimeOut
*	ⳬʱʱ(),С100ʹĬʱ
* @return
*	0ʾɹ(), 1ʾʧ()
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DeviceIsOnline(IN const char *cAddress, IN DWORD dwCommandPort, IN DWORD dwTimeOut);

/*!
* @brief
*	ʶָ豸ʹ¾ɰ汾
*	
* @param sServerIP
*	豸IPַ
* @param dwCommandPort
*	˿ں
* @param dwTimeOut
*	ʱʱ(),Ϊ0ʹĬʱ10
* @param nType
*	İ汾
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_GetSDKVersion(IN const char *sServerIP, IN DWORD dwCommandPort, IN DWORD dwTimeOut, OUT eNetworkSDKVersion *nType);



//ʹôNVR豸˻ȡ̽豸бĽӿʱҪעĽӿڵõ˳,ȵVideoNetClient_DetectDeviceListStartӿڣȻٵVideoNetClient_SetDetectDeviceListFromNVRCBӿ
/*!
* @brief
*	ûȡ̽豸бĻص(NVR豸˻ȡ̽б)
*	
* @param hUser
*	豸ûID
* @param cbDeviceProbeFromNVR
*	ص
* @param dwUserData
*	û
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SetDetectDeviceListFromNVRCB(IN HUSER hUser,CB_DeviceProbeFromNVR cbDeviceProbeFromNVR,DWORD dwUserData);


/*!
* @brief
*	ʼ̽豸(NVR豸˻ȡ̽б)
*	
* @param hUser
*	豸ûID
* @param strPathFileName
*	ʱļ·+ļʹãҪȷȨ޲
* @param nPathFileNameLength
*	ʱļĴС
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DetectDeviceListStart(IN HUSER hUser,IN char * strPathFileName,IN int nPathFileNameLength);


/*!
* @brief
*	ˢ豸̽б(NVR豸˻ȡ̽б)
*	
* @param hUser
*	豸ûID
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DetectDeviceListRefresh(IN HUSER hUser);

/*!
* @brief
*	ֹͣ豸̽б(NVR豸˻ȡ̽б)
*	
* @param hUser
*	豸ûID
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_DetectDeviceListStop(IN HUSER hUser);

/*!
* @brief
*	Զ
* @param cRemoteDesktopPara
*	ԶӲ
* @param hStream
*	ԶӾ,ͨԶӻȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RemoteDesktopConnect(OUT HSTREAM *hStream, IN HUSER hUser, IN const LPRemoteDesktopStreamPara cRemoteDesktopPara);

/*!
* @brief
*	ýصӿ
* @param hStream
*	ý,ͨȡ
* @param cbRemoteDesktopMedia
*	ýصӿ,ֵΪ(NULL),ʾҪص
* @param dwUserData
*	ýصʱشӦò
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿýݻص,
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RemoteDesktopMediaCB(IN HSTREAM hStream, IN CB_StreamMedia cbRemoteDesktopMedia, IN VNC_USERDATA dwUserData);


/*!
* @brief
*	ϿԶ
* @param hStream
*	ԶӾ,ͨԶӻȡ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RemoteDesktopDisconnect(IN HSTREAM hStream);

/*!
* @brief
*	
* @param hStream
*	ý,ͨȡ
* @param cRemoteDesktopOperatePara
*	Զ
* @return
*	0ʾɹ, ʾ
* @note
*	Ӧòʹô˽ӿýݻص,
*	ڴ˻صýݽ̵߳,
*	Ϊ˱֤ʵʱ,뾡ܼڻصеʽ,Աֶ֡.
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_RemoteDesktopMouseOperate(IN HSTREAM hStream, IN const LPRemoteDesktopStreamOpereatePara cRemoteDesktopOperatePara);

/*!
* @brief
*	û¼ӿ,豸вҪȵ¼
*	
* @param hUser
*	û,¼ӿþֵ
* @param cUserLoginPara
*	û¼Ϣ
* @return
*	0ʾɹ, ʾ
* @note
*	ӿ: ʽ
*/
VNCLIENT_API int CALLSTACK VideoNetClient_SuperUserLogin(OUT HUSER *hUser, IN const LPUserLoginPara cUserLoginPara);


#endif
