// FileQueryDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
/*#include "../inc/VideoNetClientDemo_Common.h"*/
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/FileQueryDlg.h"

#include "../inc/Utility.h"
using namespace common;

#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;
// CFileQueryDlg Ի

IMPLEMENT_DYNAMIC(CFileQueryDlg, CDialog)

CFileQueryDlg::CFileQueryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileQueryDlg::IDD, pParent)
	, m_EDFileName(_T(""))
{

}

CFileQueryDlg::~CFileQueryDlg()
{
}

void CFileQueryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBFILETYPE, m_CBFileType);
	DDX_Control(pDX, IDC_STARTDATE, m_DTStartDate);
	DDX_Control(pDX, IDC_STOPDATE, m_DTStopDate);
	DDX_Control(pDX, IDC_LSRESULT, m_LSResult);
	DDX_Text(pDX, IDC_FILENAME, m_EDFileName);
}


BEGIN_MESSAGE_MAP(CFileQueryDlg, CDialog)
	ON_BN_CLICKED(IDC_BTCONFIRM, &CFileQueryDlg::OnBnClickedBtconfirm)
	ON_NOTIFY(NM_DBLCLK, IDC_LSRESULT, &CFileQueryDlg::OnNMDblclkLsresult)
END_MESSAGE_MAP()


// CFileQueryDlg Ϣ

BOOL CFileQueryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	ListView_SetExtendedListViewStyle(m_LSResult.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSResult.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSResult.InsertColumn(0, "channel", LVCFMT_LEFT, 70);//ʼб
	m_LSResult.InsertColumn(1, "lock", LVCFMT_LEFT, 60);
	m_LSResult.InsertColumn(2, "size", LVCFMT_LEFT, 70);
	m_LSResult.InsertColumn(3, "type", LVCFMT_LEFT, 60);
	m_LSResult.InsertColumn(4, "time", LVCFMT_LEFT, 70);
	m_LSResult.InsertColumn(5, "file", LVCFMT_LEFT, 200);

	CString	cChannel;
	cChannel.Format("All");
	m_CBChannel.AddString(cChannel);
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cFileType[] = {"Alarm", "Normal", "Manual", "Motion"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cFileType); count++)
	{
		m_CBFileType.AddString(cFileType[count]);
	}
	if (0 < m_CBFileType.GetCount())
	{
		m_CBFileType.SetCurSel(0);
	}

	// ʱؼ
	m_DTStartDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	m_DTStopDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CFileQueryDlg::OnBnClickedBtconfirm()
{
	// TODO: ڴӿؼ֪ͨ
	UpdateData();
	HFILE_QUERY hFileQuery;
	FileQueryFactor	cFactor;

	CUtility cUtility;
	SYSTEMTIME	systime;
	cUtility.TimeFormControl(systime, m_DTStartDate);
	cUtility.TimeToString(cFactor.cBeginTime, systime);
	cUtility.TimeFormControl(systime, m_DTStopDate);
	cUtility.TimeToString(cFactor.cEndTime, systime);
	cFactor.dwChannel = m_CBChannel.GetCurSel();
	cFactor.dwFileType = m_CBFileType.GetCurSel();

	if (CHECK_RET_FAILED(g_pMainDialog->FileQueryConnect(&hFileQuery, &cFactor)))
	{
		return;
	}
	m_LSResult.DeleteAllItems();
	FileQueryResult	cResult;

	CString str;
	int result = g_pMainDialog->FileQueryNext(hFileQuery, &cResult);
	while (result==0 || result == 2)   //2Ϊѯæsleep500msٲ
	{
		if (result==0)
		{
		int count = m_LSResult.InsertItem(0xFFFF, "");
		str.Format("%d", cResult.dwChannel);
		m_LSResult.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", cResult.dwLock);
		m_LSResult.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", cResult.dwDataSize);
		m_LSResult.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", cResult.dwFileType);
		m_LSResult.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cResult.cCreateTime);
		m_LSResult.SetItem(count, 4, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cResult.cFileName);
		m_LSResult.SetItem(count, 5, 1 , str, NULL, 0, 0, 0);
		}
		else
		{
			Sleep(500);
		}
		result = g_pMainDialog->FileQueryNext(hFileQuery, &cResult);
	}
	g_pMainDialog->FileQueryDisconnect(hFileQuery);
}

void CFileQueryDlg::OnNMDblclkLsresult(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ڴӿؼ֪ͨ
	int count = m_LSResult.GetSelectionMark();
	if (-1 != count)
	{
		m_EDFileName = m_LSResult.GetItemText(count, 5);
	}
	*pResult = 0;
}
