// VideoNetClientDemoDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemoDlg.h"
#include "../inc/DeviceDlg.h"
#include "../inc/UserDlg.h"
#include "../inc/UserEventDlg.h"
#include "../inc/RealStreamDlg.h"
#include "../inc/TalkStreamDlg.h"
#include "../inc/HistoryQueryDlg.h"
#include "../inc/HistoryStreamDlg.h"
#include "../inc/TransparentDlg.h"
#include "../inc/DownloadDlg.h"
#include "../inc/UploadDlg.h"
#include "../inc/HistoryQueryResultDlg.h"
#include "../inc/TransparentSendDlg.h"
#include "../inc/UserConfigDlg.h"
#include "../inc/ControlDlg.h"
#include "../inc/UserPTZControlDlg.h"
#include "../inc/LogQueryDlg.h"
#include "../inc/FileQueryDlg.h"
#include "../inc/SelectFontDlg.h"

#include "../inc/Utility.h"
using namespace common;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//TrackϢ
#define SIMPLE_TRACK					this->Output("[%s : %d] Track\n", __FUNCTION__, __LINE__)
//FailedϢ
#define SIMPLE_FAILED					this->Output("[%s : %d] Failed\n", __FUNCTION__, __LINE__)

//ʧʾϢ
#define NOTIFY_OPERATION_FAILED			SIMPLE_FAILED;MessageBox("Operation Failed.")
#define NOTIFY_OPERATION_FAILED_STRING(FuncString,nRet)			SIMPLE_FAILED;\
															CString strTemp;\
															strTemp.Format("Operation Failed. %s,nRet:%d",FuncString,nRet);\
															MessageBox(strTemp)


// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVideoNetClientDemoDlg Ի


CVideoNetClientDemoDlg	*g_pMainDialog = NULL;

CVideoNetClientDemoDlg::CVideoNetClientDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoNetClientDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	g_pMainDialog = this;
	m_iOutputMessage = 0;
	m_hHistoryQueryEvent = INVALID_HANDLE_VALUE;
	m_dwHistoryQuerySize = 0;
}

void CVideoNetClientDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE_DEVICE, m_TRDevice);
	DDX_Control(pDX, IDC_TREE_USER, m_TRUser);
	DDX_Control(pDX, IDC_LIST_REALSTREAM, m_LSRealStream);
	DDX_Control(pDX, IDC_LIST_HISTORYSTREAM, m_LSHistoryStream);
	DDX_Control(pDX, IDC_LIST_TALKSTREAM, m_LSTalkStream);
	DDX_Control(pDX, IDC_LIST_HISTORY_QUERY, m_LSHistoryQuery);
	DDX_Control(pDX, IDC_LIST_TRANSPARENT, m_LSTransparent);
	DDX_Control(pDX, IDC_LIST_DOWNLOAD, m_LSDownload);
	DDX_Control(pDX, IDC_LIST_UPLOAD, m_LSUpload);
	DDX_Control(pDX, IDC_EDOUTPUT, m_EDOutput);
}

BEGIN_MESSAGE_MAP(CVideoNetClientDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_DEVICEREGISTER,OnDeviceRegister)
	ON_COMMAND(ID_SERVICE_START, OnServiceStart)
	ON_COMMAND(ID_SERVICE_STOP, OnServiceStop)
	ON_COMMAND(ID_DEVICE_INSERT, OnDeviceInsert)
	ON_COMMAND(ID_DEVICE_REMOVE, OnDeviceRemove)
	ON_COMMAND(ID_USER_LOGIN, OnUserLogin)
	ON_COMMAND(ID_USER_LOGOUT, OnUserLogout)
	ON_COMMAND(ID_USER_EVENT, OnUserEvent)
	ON_COMMAND(ID_USER_CONFIG, OnUserConfig)
	ON_COMMAND(ID_USER_CONTROL, OnUserControl)
	ON_COMMAND(ID_USER_PTZCONTROL, OnUserPTZControl)
	ON_COMMAND(ID_USER_STRINGTOLATTICE, OnStringToLattice)
	ON_COMMAND(ID_REALSTREAM_CONNECT, OnRealStreamConnect)
	ON_COMMAND(ID_REALSTREAM_DISCONNECT, OnRealStreamDisconnect)
	ON_COMMAND(ID_REALSTREAM_START, OnRealStreamStart)
	ON_COMMAND(ID_REALSTREAM_STOP, OnRealStreamStop)
	ON_COMMAND(ID_REALSTREAM_STARTCYCLE, OnRealStreamStartCycle)
	ON_COMMAND(ID_REALSTREAM_STOPCYCLE, OnRealStreamStopCycle)
	ON_COMMAND(ID_TALKSTREAM_CONNECT, OnTalkStreamConnect)
	ON_COMMAND(ID_TALKSTREAM_DISCONNECT, OnTalkStreamDisconnect)
	ON_COMMAND(ID_TALKSTREAM_START, OnTalkStreamStart)
	ON_COMMAND(ID_TALKSTREAM_STOP, OnTalkStreamStop)
	ON_COMMAND(ID_HISTORYQUERY_CONNECT, OnHistoryQueryConnect)
	ON_COMMAND(ID_HISTORYQUERY_DISCONNECT, OnHistoryQueryDisconnect)
	ON_COMMAND(ID_HISTORYQUERY_QUERY, OnHistoryQueryQuery)
	ON_COMMAND(ID_HISTORYSTREAM_CONNECT, OnHistoryStreamConnect)
	ON_COMMAND(ID_HISTORYSTREAM_DISCONNECT, OnHistoryStreamDisconnect)
	ON_COMMAND(ID_HISTORYSTREAM_START, OnHistoryStreamStart)
	ON_COMMAND(ID_HISTORYSTREAM_STOP, OnHistoryStreamStop)
	ON_COMMAND(ID_HISTORYSTREAM_ASYNC, OnHistoryStreamAsync)
	ON_COMMAND(ID_TRANSPARENTCHANNEL_CONNECT, OnTransparentConnect)
	ON_COMMAND(ID_TRANSPARENTCHANNEL_DISCONNECT, OnTransparentDisconnect)
	ON_COMMAND(ID_TRANSPARENTCHANNEL_SEND, OnTransparentSend)
	ON_COMMAND(ID_FILEQUERY_QUERY, OnFileQuery)
	ON_COMMAND(ID_DOWNLOAD_CONNECT, OnDownloadConnect)
	ON_COMMAND(ID_DOWNLOAD_DISCONNECT, OnDownloadDisconnect)
	ON_COMMAND(ID_UPLOAD_CONNECT, OnUploadConnect)
	ON_COMMAND(ID_UPLOAD_DISCONNECT, OnUploadDisconnect)
	ON_COMMAND(ID_LOGQUERY_QUERY, OnLogQuery)
	ON_COMMAND(ID_INFORMATION_RECORD, OnInformationRecord)
	ON_COMMAND(ID_INFORMATION_COPY, OnInformationCopy)
	ON_COMMAND(ID_INFORMATION_SAVE, OnInformationSave)
	ON_COMMAND(ID_INFORMATION_CLEAR, OnInformationClear)
	//}}AFX_MSG_MAP
	ON_WM_CLOSE()
    ON_COMMAND(ID_INFORMATION_GETFILEHEADER, &CVideoNetClientDemoDlg::OnInformationGetfileheader)
	/*
	ON_COMMAND(ID_PASSIVITYCONNECT_SETCONFIG, &CVideoNetClientDemoDlg::OnPassivityconnectSetconfig)
	ON_COMMAND(ID_PASSIVITYCONNECT_GETCONFIG, &CVideoNetClientDemoDlg::OnPassivityconnectGetconfig)
	ON_COMMAND(ID_PASSIVITYCONNECT_GETCHANNELINFORMATION, &CVideoNetClientDemoDlg::OnPassivityconnectGetchannelinformation)
	ON_COMMAND(ID_PASSIVITYCONNECT_SETDISPLAYCONFIG, &CVideoNetClientDemoDlg::OnPassivityconnectSetdisplayconfig)
	ON_COMMAND(ID_PASSIVITYCONNECT_GETDISPLAYCONFIG, &CVideoNetClientDemoDlg::OnPassivityconnectGetdisplayconfig)
	ON_COMMAND(ID_STREAMTRANSFER_CONNECT, &CVideoNetClientDemoDlg::OnStreamtransferConnect)
	ON_COMMAND(ID_STREAMTRANSFER_DISCONNECT, &CVideoNetClientDemoDlg::OnStreamtransferDisconnect)
	ON_COMMAND(ID_STREAMTRANSFER_SEND, &CVideoNetClientDemoDlg::OnStreamtransferSend)
	ON_COMMAND(ID_DECODECHANNEL_SETCONFIG, &CVideoNetClientDemoDlg::OnDecodechannelSetconfig)
	ON_COMMAND(ID_DECODECHANNEL_GETCONFIG, &CVideoNetClientDemoDlg::OnDecodechannelGetconfig)
	ON_COMMAND(ID_DECODECHANNEL_SETVIDEOSTANDARD, &CVideoNetClientDemoDlg::OnDecodechannelSetvideostandard)
	ON_COMMAND(ID_DECODECHANNEL_GETVIDEOSTANDARD, &CVideoNetClientDemoDlg::OnDecodechannelGetvideostandard)
	ON_COMMAND(ID_DECODECHANNEL_GETSTATUS, &CVideoNetClientDemoDlg::OnDecodechannelGetstatus)
	ON_COMMAND(ID_DECODECHANNEL_SETPLAYSTATUS, &CVideoNetClientDemoDlg::OnDecodechannelSetplaystatus)
	ON_COMMAND(ID_DECODECHANNEL_GETPLAYSTATUS32843, &CVideoNetClientDemoDlg::OnDecodechannelGetplaystatus)
	ON_COMMAND(ID_DECODECHANNEL_LOGOSWITCH, &CVideoNetClientDemoDlg::OnDecodechannelLogoswitch)
	ON_COMMAND(ID_DECODECHANNEL_DISPLAYCONTROL32844, &CVideoNetClientDemoDlg::OnDecodechannelDisplaycontrol32844)
	ON_COMMAND(ID_DECODECHANNEL_LOGOUPLOAD32846, &CVideoNetClientDemoDlg::OnDecodechannelLogoupload32846)
	ON_COMMAND(ID_TRANSMITQUERY_CREATE, &CVideoNetClientDemoDlg::OnTransmitqueryCreate)
	ON_COMMAND(ID_TRANSMITQUERY_DISCONNECT, &CVideoNetClientDemoDlg::OnTransmitqueryDisconnect)
	ON_COMMAND(ID_TRANSMITQUERY_QUERY, &CVideoNetClientDemoDlg::OnTransmitqueryQuery)
	*/
	ON_COMMAND(ID_USER_GETFRONTDEVICE, &CVideoNetClientDemoDlg::OnUserGetfrontdevice)
	ON_COMMAND(ID_USER_SETFRONTDEVICE, &CVideoNetClientDemoDlg::OnUserSetfrontdevice)
	ON_COMMAND(ID_USER_GETPREVIEWLIST, &CVideoNetClientDemoDlg::OnUserGetpreviewlist)
	ON_COMMAND(ID_USER_SETPREVIEWLIST, &CVideoNetClientDemoDlg::OnUserSetpreviewlist)
	ON_COMMAND(ID_USER_FULLSCREENCHANNEL, &CVideoNetClientDemoDlg::OnUserFullscreenchannel)
	ON_COMMAND(ID_USER_RETURNFROMFULLSCREEN, &CVideoNetClientDemoDlg::OnUserReturnfromfullscreen)
	ON_COMMAND(ID_USER_S, &CVideoNetClientDemoDlg::OnUserS)
	ON_COMMAND(ID_USER_STOPCRUISE, &CVideoNetClientDemoDlg::OnUserStopcruise)
	ON_COMMAND(ID_USER_RETRIEVEMONITORCAPABILITY, &CVideoNetClientDemoDlg::OnUserRetrievemonitorcapability)
	ON_COMMAND(ID_USER_GETMONITORRESOLUTION, &CVideoNetClientDemoDlg::OnUserGetmonitorresolution)
	ON_COMMAND(ID_USER_SETMONITORRESOLUTION, &CVideoNetClientDemoDlg::OnUserSetmonitorresolution)
	ON_COMMAND(ID_USER_SETMOTIONMORETHAN32, &CVideoNetClientDemoDlg::OnUserSetmotionmorethan32)
	ON_COMMAND(ID_USER_GETMOTIONMORETHAN32, &CVideoNetClientDemoDlg::OnUserGetmotionmorethan32)
	ON_COMMAND(ID_USER_SETDEFROG, &CVideoNetClientDemoDlg::OnUserSetdefrog)
	ON_COMMAND(ID_USER_GETDEFROG, &CVideoNetClientDemoDlg::OnUserGetdefrog)
	ON_COMMAND(ID_USER_SETADVANCEDCHANNEL, &CVideoNetClientDemoDlg::OnUserSetadvancedchannel)
	ON_COMMAND(ID_USER_GETADVANCEDCHANNEL, &CVideoNetClientDemoDlg::OnUserGetadvancedchannel)
END_MESSAGE_MAP()

// CVideoNetClientDemoDlg Ϣ

BOOL CVideoNetClientDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ
	InitDialog();

	

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CVideoNetClientDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CVideoNetClientDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CVideoNetClientDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

int CVideoNetClientDemoDlg::InitDialog(void)
{
	ListView_SetExtendedListViewStyle(m_LSRealStream.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSRealStream.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSRealStream.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSRealStream.InsertColumn(1, "channel", LVCFMT_LEFT, 54);
	m_LSRealStream.InsertColumn(2, "protocol", LVCFMT_LEFT, 60);
	m_LSRealStream.InsertColumn(3, "stream", LVCFMT_LEFT, 54);
	m_LSRealStream.InsertColumn(4, "record", LVCFMT_LEFT, 170);
	m_LSRealStream.InsertColumn(5, "receive", LVCFMT_LEFT, 80);

	ListView_SetExtendedListViewStyle(m_LSTalkStream.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSTalkStream.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSTalkStream.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSTalkStream.InsertColumn(2, "protocol", LVCFMT_LEFT, 60);
	m_LSTalkStream.InsertColumn(3, "receive file", LVCFMT_LEFT, 140);
	m_LSTalkStream.InsertColumn(4, "send file", LVCFMT_LEFT, 120);
	m_LSTalkStream.InsertColumn(5, "receive", LVCFMT_LEFT, 80);

	ListView_SetExtendedListViewStyle(m_LSHistoryStream.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSHistoryStream.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSHistoryStream.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSHistoryStream.InsertColumn(1, "channel", LVCFMT_LEFT, 54);
	m_LSHistoryStream.InsertColumn(2, "protocol", LVCFMT_LEFT, 60);
	m_LSHistoryStream.InsertColumn(3, "query", LVCFMT_LEFT, 50);
	m_LSHistoryStream.InsertColumn(4, "start", LVCFMT_LEFT, 70);
	m_LSHistoryStream.InsertColumn(5, "stop", LVCFMT_LEFT, 70);
	m_LSHistoryStream.InsertColumn(6, "record", LVCFMT_LEFT, 50);
	m_LSHistoryStream.InsertColumn(7, "receive", LVCFMT_LEFT, 60);

	ListView_SetExtendedListViewStyle(m_LSHistoryQuery.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSHistoryQuery.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSHistoryQuery.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSHistoryQuery.InsertColumn(1, "channel", LVCFMT_LEFT, 54);
	m_LSHistoryQuery.InsertColumn(2, "query", LVCFMT_LEFT, 60);
	m_LSHistoryQuery.InsertColumn(3, "main", LVCFMT_LEFT, 60);
	m_LSHistoryQuery.InsertColumn(4, "assist", LVCFMT_LEFT, 60);
	m_LSHistoryQuery.InsertColumn(5, "start", LVCFMT_LEFT, 80);
	m_LSHistoryQuery.InsertColumn(6, "stop", LVCFMT_LEFT, 80);

	ListView_SetExtendedListViewStyle(m_LSTransparent.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSTransparent.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSTransparent.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSTransparent.InsertColumn(1, "channel type", LVCFMT_LEFT, 100);
	m_LSTransparent.InsertColumn(2, "serial", LVCFMT_LEFT, 60);
	m_LSTransparent.InsertColumn(3, "port", LVCFMT_LEFT, 60);
	m_LSTransparent.InsertColumn(4, "receive", LVCFMT_LEFT, 90);
	m_LSTransparent.InsertColumn(5, "send", LVCFMT_LEFT, 90);

	ListView_SetExtendedListViewStyle(m_LSDownload.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSDownload.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSDownload.InsertColumn(0, "index", LVCFMT_LEFT, 42);//ʼб
	m_LSDownload.InsertColumn(1, "download", LVCFMT_LEFT, 80);
	m_LSDownload.InsertColumn(2, "save", LVCFMT_LEFT, 80);

	ListView_SetExtendedListViewStyle(m_LSUpload.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSUpload.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSUpload.InsertColumn(0, "index", LVCFMT_LEFT, 60);//ʼб
	m_LSUpload.InsertColumn(1, "local", LVCFMT_LEFT, 100);

	//ʼϢ
	m_EDOutput.SetLimitText(0xFFFFFFFF);
	return 0;
}
int CVideoNetClientDemoDlg::DeviceRegisterIsRepeat(LPDeviceRegisterInfo pDeviceRegister)
{
	CString strCfgMac, strListMac;
	strCfgMac.Format("%02X:%02X:%02X:%02X:%02X:%02X",
		pDeviceRegister->cDeviceMAC[0], pDeviceRegister->cDeviceMAC[1],
		pDeviceRegister->cDeviceMAC[2], pDeviceRegister->cDeviceMAC[3],
		pDeviceRegister->cDeviceMAC[4], pDeviceRegister->cDeviceMAC[5]);
	for (list<DeviceRegisterInfo>::iterator iIter = m_lsDeviceRegistartInfo.begin();
		iIter != m_lsDeviceRegistartInfo.end(); iIter++)
	{
		strListMac.Format("%02X:%02X:%02X:%02X:%02X:%02X",
			iIter->cDeviceMAC[0], iIter->cDeviceMAC[1],
			iIter->cDeviceMAC[2], iIter->cDeviceMAC[3],
			iIter->cDeviceMAC[4], iIter->cDeviceMAC[5]);
		//豸Ѵ
		if (0 == strcmpi(strCfgMac, strListMac)) 
		{
			return -1;
		}
	}
	m_lsDeviceRegistartInfo.push_back(*pDeviceRegister);
	return 0;
}
LRESULT CVideoNetClientDemoDlg::OnDeviceRegister(WPARAM wParam,LPARAM lParam)
{
	int id = 0;
	DeviceInformation	info;
	LPDeviceRegisterInfo pDeviceRegister = (LPDeviceRegisterInfo)wParam;
	//ͨmacַжϲ豸Ƿظظ
	if(CHECK_RET_FAILED(DeviceRegisterIsRepeat(pDeviceRegister)))
	{
		return -1;
	}
	info.m_cDevice = pDeviceRegister->cDeviceIP;
	info.m_Command = pDeviceRegister->dwDeviceCmdPort;
	if (CHECK_RET_FAILED(m_cDeviceManager.Insert(id)))
	{
		NOTIFY_OPERATION_FAILED;
		return -2;
	}
	if (CHECK_RET_FAILED(m_cDeviceManager.SetDeviceInfo(id, info)))
	{
		m_cDeviceManager.Remove(id);
		NOTIFY_OPERATION_FAILED;
		return -3;
	}
	HTREEITEM item = m_TRDevice.InsertItem(info.m_cDevice.c_str());
	if (CHECK_POINT_NULL(item))
	{
		m_cDeviceManager.Remove(id);
		NOTIFY_OPERATION_FAILED;
		return -4;
	}
	m_TRDevice.SetItemData(item, id);
	if (CHECK_POINT_NULL(m_TRDevice.GetSelectedItem()))
	{
		m_TRDevice.SelectItem(item);
	}
	return 0;
}

int CVideoNetClientDemoDlg::CBF_DeviceRegister(LPDeviceRegisterInfo pDeviceRegister)
{
	::SendMessage(g_pMainDialog->m_hWnd,WM_DEVICEREGISTER,(WPARAM)pDeviceRegister,NULL);
	return 0;
}

int CVideoNetClientDemoDlg::InitRegisterDevServer(void)
{
	int nRet = 0;
	//ûص
	SIMPLE_TRACK;
	if(CHECK_POINT_NULL(CBF_DeviceRegister))
	{
		MessageBox("DeviceRegister callback function is NULL\n");
		return -1;
	}
	nRet = VideoNetClient_DeviceRegisterCB(CBF_DeviceRegister);
	if(CHECK_RET_FAILED(nRet))
	{
		MessageBox("register DeviceRegister callback function is failed\n");
		return nRet;
	}

	nRet = VideoNetClient_DeviceRegisterListenStart(NULL,DEVICEREGISTERPORT);
	if(CHECK_RET_FAILED(nRet))
	{
		MessageBox("start register DeviceRegister Server is failed\n");
		return nRet;
	}
	SIMPLE_TRACK;
	return nRet;
}
int CVideoNetClientDemoDlg::Output(const char *format, ...)
{
	static char buf[MAX_OUTPUT_STRING_LEN*2];
	va_list ap;

	va_start(ap, format);
	int ilen = _vsnprintf(buf, sizeof(buf), format, ap);
	va_end(ap);

	//Ϣ
	OutputInformation(buf);
	//ϢDebug
	OutputDebugString(buf);
	return 0;
}

int CVideoNetClientDemoDlg::OutputInformation(CString info)
{
	m_iOutputMessage += 1;

	if (MAX_OUTPUT_MESSAGE_NUMBER < m_iOutputMessage)
	{
		OnInformationClear();
	}

	CString time;
	SYSTEMTIME systime;
	GetLocalTime(&systime);
	time.Format("[%04d-%02d-%02d %02d:%02d:%02d.%03d] %s",
		systime.wYear,systime.wMonth, systime.wDay, systime.wHour, systime.wMinute, systime.wSecond, systime.wMilliseconds, info);

	m_EDOutput.SetSel(0xFFFFFFFF);
	m_EDOutput.ReplaceSel(time);
	//Ϣļ
	m_cOutputToFile.Output(time, time.GetLength());
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectDevice(int &id)
{
	HTREEITEM item = m_TRDevice.GetSelectedItem();
	if (CHECK_POINT_NULL(item))
	{
		SIMPLE_FAILED;
		return 1;
	}
	id = m_TRDevice.GetItemData(item);
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUser(HUSER &user)
{
	HTREEITEM useritem = m_TRUser.GetSelectedItem();
	if (CHECK_POINT_NULL(useritem))
	{
		SIMPLE_FAILED;
		return 1;
	}
	user = (HUSER)m_TRUser.GetItemData(useritem);
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserManager(UserManager **user)
{
	HTREEITEM devitem = m_TRDevice.GetSelectedItem();
	if (CHECK_POINT_NULL(devitem))
	{
		SIMPLE_FAILED;
		return 1;
	}
	int id = m_TRDevice.GetItemData(devitem);
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, user)) || CHECK_POINT_NULL(user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserManager(HUSER &hUser, UserManager **user)
{
	HTREEITEM devitem = m_TRDevice.GetSelectedItem();
	if (CHECK_POINT_NULL(devitem))
	{
		SIMPLE_FAILED;
		return 1;
	}
	int id = m_TRDevice.GetItemData(devitem);
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, user)) || CHECK_POINT_NULL(*user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	HTREEITEM useritem = m_TRUser.GetSelectedItem();
	if (CHECK_POINT_NULL(useritem))
	{
		SIMPLE_FAILED;
		return 1;
	}
	hUser = (HUSER)m_TRUser.GetItemData(useritem);
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserRealStreamManager(HUSER &hUser, RealStreamManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetRealStream(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserTalkStreamManager(HUSER &hUser, TalkStreamManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetTalkStream(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserHistoryQueryManager(HUSER &hUser, HistoryQueryManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetHistoryQuery(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserHistoryStreamManager(HUSER &hUser, HistoryStreamManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetHistoryStream(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserTransparentManager(HUSER &hUser, TransparentManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetTransparent(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserDownloadManager(HUSER &hUser, DownloadManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetDownload(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetSelectUserUploadManager(HUSER &hUser, UploadManager **hStream, string *sDevice)
{
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(hUser, &user)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(user->GetUpload(hUser, hStream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_POINT_NO_NULL(sDevice))
	{
		user->GetDevice(*sDevice);
	}
	return 0;
}

int CVideoNetClientDemoDlg::StreamMediaControl(HSTREAM hStream, eTaskControl control)
{
	//
	if (CHECK_RET_FAILED(VideoNetClient_StreamMediaControl(hStream, control)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, RealStreamInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSRealStream.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Channel);
	m_LSRealStream.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Protocol);
	m_LSRealStream.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Stream);
	m_LSRealStream.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
	m_LSRealStream.SetItem(count, 4, 1 , info.m_cRecord.c_str(), NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, TalkStreamInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSTalkStream.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Protocol);
	m_LSTalkStream.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_cSendFile);
	m_LSTalkStream.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_cRecvFile);
	m_LSTalkStream.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, HistoryQueryInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSHistoryQuery.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Channel);
	m_LSHistoryQuery.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_QueryType);
	m_LSHistoryQuery.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_MainType);
	m_LSHistoryQuery.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_AssistType);
	m_LSHistoryQuery.SetItem(count, 4, 1 , str, NULL, 0, 0, 0);
	CUtility	cUtility;
	cUtility.TimeToString(&str, info.m_StartTime);
	m_LSHistoryQuery.SetItem(count, 5, 1 , str, NULL, 0, 0, 0);
	cUtility.TimeToString(&str, info.m_StopTime);
	m_LSHistoryQuery.SetItem(count, 6, 1 , str, NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, HistoryStreamInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSHistoryStream.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Channel);
	m_LSHistoryStream.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_Protocol);
	m_LSHistoryStream.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_QueryType);
	m_LSHistoryStream.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
	CUtility	cUtility;
	cUtility.TimeToString(&str, info.m_StartTime);
	m_LSHistoryStream.SetItem(count, 4, 1 , str, NULL, 0, 0, 0);
	cUtility.TimeToString(&str, info.m_StopTime);
	m_LSHistoryStream.SetItem(count, 5, 1 , str, NULL, 0, 0, 0);
	m_LSHistoryStream.SetItem(count, 6, 1 , info.m_Record.c_str(), NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, TransparentInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSTransparent.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_ChannelType);
	m_LSTransparent.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_SerialType);
	m_LSTransparent.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
	str.Format("%d", info.m_SerialPort);
	m_LSTransparent.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
	m_LSTransparent.SetItem(count, 4, 1 , info.m_cRecvFile.c_str(), NULL, 0, 0, 0);
	m_LSTransparent.SetItem(count, 5, 1 , info.m_cSendFile.c_str(), NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, DownloadInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSDownload.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	m_LSDownload.SetItem(count, 1, 1 , info.m_cDownloadFile.c_str(), NULL, 0, 0, 0);
	m_LSDownload.SetItem(count, 2, 1 , info.m_cSaveFile.c_str(), NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::RefreshStreamInfo(int count, HSTREAM stream, UploadInformation &info)
{
	CString str;
	str.Format("%d", stream);
	m_LSUpload.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
	m_LSUpload.SetItem(count, 1, 1 , info.m_cUploadFile.c_str(), NULL, 0, 0, 0);
	return 0;
}

int CVideoNetClientDemoDlg::GetListSelectItem(int &count, int &data, CListCtrl *pList)
{
	if (CHECK_POINT_NULL(pList))
	{
		SIMPLE_FAILED;
		return 1;
	}
	count = pList->GetSelectionMark();
	if (-1 == count)
	{
		SIMPLE_FAILED;
		return 1;
	}
	data = pList->GetItemData(count);
	return 0;
}

int CVideoNetClientDemoDlg::RealStreamConnect(HUSER hUser, string device, RealStreamManager *stream, RealStreamInformation &cInfo, bool start)
{
	HSTREAM hStream = INVALID_HANDLE_VALUE;
	RealStreamPara	para;
	int nRet = 0;
	para.dwChannel = cInfo.m_Channel;
	para.eTransferMode = (eStreamTransferMode)(cInfo.m_Protocol);
	para.eMediaType = (eStreamMediaType)(cInfo.m_Stream + 1);
	//
	if (CHECK_RET_FAILED(VideoNetClient_RealStreamConnect(&hStream, hUser, &para)))
	{
		NOTIFY_OPERATION_FAILED;
		return 1;
	}
// 	nRet = VideoNetClient_RealStreamConnect(&hStream, hUser, &para);
// 	if(0 != nRet)
// 	{
// 		NOTIFY_OPERATION_FAILED_STRING("RealStreamConnect",nRet);
// 		return 1;
// 	}
	//ݻص
	if (CHECK_RET_FAILED(VideoNetClient_StreamMediaCB(hStream, RealStreamCallback, (DWORD)hUser)))
	{
		NOTIFY_OPERATION_FAILED;
		return 1;
	}
// 	nRet = VideoNetClient_StreamMediaCB(hStream, RealStreamCallback, (DWORD)hUser);
// 	if(0 != nRet)
// 	{
// 		NOTIFY_OPERATION_FAILED_STRING("StreamMediaCB",nRet);
// 		return 1;
// 	}
	//
	if (CHECK_RET_FAILED(stream->Insert(hStream)))
	{
		VideoNetClient_RealStreamDisconnect(hStream);
		NOTIFY_OPERATION_FAILED;
		return 1;
	}
	RealStreamInfoManager *info = NULL;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		VideoNetClient_RealStreamDisconnect(hStream);
		stream->Remove(hStream);
		NOTIFY_OPERATION_FAILED;
		return 1;
	}

	info->m_StreamInfo = cInfo;
	CString strInfo(info->m_StreamInfo.m_cRecord.c_str());
	CUtility	cUtility;
	cUtility.BuildRecordFile(strInfo, device.c_str(), para.dwChannel, "prv");
	info->m_StreamInfo.m_cRecord = strInfo;

	int count = m_LSRealStream.InsertItem(0xFFFF, "");
	if (-1 == count)
	{
		VideoNetClient_RealStreamDisconnect(hStream);
		stream->Remove(hStream);
		NOTIFY_OPERATION_FAILED;
		return 1;
	}
	//ýϢ
	if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, info->m_StreamInfo)))
	{
		VideoNetClient_RealStreamDisconnect(hStream);
		stream->Remove(hStream);
		m_LSRealStream.DeleteItem(count);
		NOTIFY_OPERATION_FAILED;
		return 1;
	}
	//Ƿ
	if (start)
	{
		if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStart)))
		{
			VideoNetClient_RealStreamDisconnect(hStream);
			stream->Remove(hStream);
			m_LSRealStream.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return 1;
		}
	}
	m_LSRealStream.SetItemData(count, (DWORD)hStream);
	if (-1 == m_LSRealStream.GetSelectionMark())
	{
		m_LSRealStream.SetSelectionMark(count);
	}
	return 0;
}

int CVideoNetClientDemoDlg::RealStreamConnect(HSTREAM &stream, HUSER hUser, const LPRealStreamPara para)
{
	//
	if (CHECK_RET_FAILED(VideoNetClient_RealStreamConnect(&stream, hUser, para)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ݻص
	if (CHECK_RET_FAILED(VideoNetClient_StreamMediaCB(stream, RealStreamCallback, (DWORD)hUser)))
	{
		SIMPLE_FAILED;
	}
	//
	if (CHECK_RET_FAILED(StreamMediaControl(stream, eTaskStart)))
	{
		SIMPLE_FAILED;
	}
	return 0;
}

int CVideoNetClientDemoDlg::RealStreamDisconnect(HSTREAM stream)
{
	if (CHECK_HANDLE_INVALID(stream))
	{
		return 1;
	}
	//ֹͣ
	if (CHECK_RET_FAILED(StreamMediaControl(stream, eTaskStop)))
	{
		SIMPLE_FAILED;
	}
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_RealStreamDisconnect(stream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::LogQueryConnect(HLOG_QUERY *hFileQuery, LPLogQueryFactor pLogQueryFactor)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_HistoryLogQueryConnect(hFileQuery, hUser, pLogQueryFactor)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::LogQueryNext(HLOG_QUERY hFileQuery, LPLogQueryResult pLogQueryResult)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_HistoryLogQueryNext(hFileQuery, pLogQueryResult)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::LogQueryDisconnect(HLOG_QUERY hFileQuery)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_HistoryLogQueryDisconnect(hFileQuery)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}


int CVideoNetClientDemoDlg::FileQueryConnect(HFILE_QUERY *hFileQuery, LPFileQueryFactor pFileQueryFactor)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_FileQueryConnect(hFileQuery, hUser, pFileQueryFactor)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::FileQueryNext(HFILE_QUERY hFileQuery, LPFileQueryResult pFileQueryResult)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return VideoNetClient_FileQueryNext(hFileQuery, pFileQueryResult);
}

int CVideoNetClientDemoDlg::FileQueryDisconnect(HFILE_QUERY hFileQuery)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_FileQueryDisconnect(hFileQuery)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::ForceIFrame(DWORD channel)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_ForceIFrame(hUser, channel)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::CaptureImage(DWORD channel, eImageFormat format)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	ImageFileInfo cInfo;

	DWORD dwChanNum;
	DWORD dwStateBits;
	int ret = VideoNetClient_AlarmoutStateGet(hUser, &dwChanNum, &dwStateBits);

	if (CHECK_RET_FAILED(VideoNetClient_ImageCapture(hUser, channel, format, &cInfo)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	CString strInfo;
	strInfo.Format("CaptureImage User:%d, ch:%d format:%d size:%d time:%s file:%s\n", hUser, channel, format, cInfo.m_dwFileSize, cInfo.m_sCreateTime, cInfo.m_sFileName);
	//ϢDebug
	OutputDebugString(strInfo);
	strInfo.Format("AlarmoutStateGet User:%d, ChanNum:%d StateBits:0x%x\n", hUser, dwChanNum, dwStateBits);
	//ϢDebug
	OutputDebugString(strInfo);
	return 0;
}

int CVideoNetClientDemoDlg::ClearAlarm(DWORD channel, DWORD type)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_AlarmClear(hUser, channel, type)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::RecordControl(DWORD channel, DWORD type)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_RecordControl(hUser, channel, type)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetRecordState(DWORD channel)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//δʵ
	/*ConfigInformation	cConfig;
	cConfig.dwMainCommand = VIDEONETCLIENT_GET_RECORDCFG;
	cConfig.dwAssistCommand = RECORDCFG_ALL;
	if (CHECK_RET_FAILED(VideoNetClient_GetConfig(hUser, &cConfig)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	LPVIDEONETCLIENT_RECORD_SCHED cRecord = (LPVIDEONETCLIENT_RECORD_SCHED)cConfig.sConfig;
	if (channel >= DVR_MAX_VIDEOIN_NUM || !cRecord->struRecordCtlState.bValid)
	{
		SIMPLE_FAILED;
		return 1;
	}
	CString strRecordState[] = {"Manual Record", "Schedule Record", "No Record"};
	//0ʾֶ¼,1ʾԶ¼,2ʾر¼
	AfxMessageBox(strRecordState[cRecord->struRecordCtlState.uRecordMode[channel]]);*/
	return 0;
}

int CVideoNetClientDemoDlg::AlarmOut(DWORD channel, DWORD type)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_AlarmoutControl(hUser, channel, type)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::GetAlarmOutState()
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
    DWORD channel = -1;
	DWORD dwState = -1;
    CString strState;
	if (CHECK_RET_FAILED(VideoNetClient_AlarmoutStateGet(hUser, &channel, &dwState)))
	{
		SIMPLE_FAILED;
		return 1;
	}
    Output("[VideoNetClient_AlarmoutStateGet]\t");
    for (int i = 0; i < channel; i++)
    {
        if (dwState == 0)
        {
            strState.Format("channel%d[open]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
            continue;
        }
        if (dwState & 0x1)
        {
            strState.Format("channel%d[close]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
        }
        else
        {
            strState.Format("channel%d[open]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
        }
        dwState = dwState>>1;
    }
    m_EDOutput.SetSel(0xFFFFFFFF);
    m_EDOutput.ReplaceSel("\n");
	return 0;
}

int CVideoNetClientDemoDlg::GetAlarmInState()
{
    HUSER hUser = INVALID_HANDLE_VALUE;
    if (CHECK_RET_FAILED(GetSelectUser(hUser)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    DWORD channel = -1;
    DWORD dwState = -1;
    CString strState;
    if (CHECK_RET_FAILED(VideoNetClient_AlarminStateGet(hUser, &channel, &dwState)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    Output("[VideoNetClient_AlarminStateGet]\t");
    for (int i = 0; i < channel; i++)
    {
        if (dwState == 0)
        {
            strState.Format("channel%d[open]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
            continue;
        }
        if (dwState & 0x1)
        {
            strState.Format("channel%d[close]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
        }
        else
        {
            strState.Format("channel%d[open]\t",i);
            m_EDOutput.SetSel(0xFFFFFFFF);
            m_EDOutput.ReplaceSel(strState);
        }
        dwState = dwState>>1;
    }
    m_EDOutput.SetSel(0xFFFFFFFF);
    m_EDOutput.ReplaceSel("\n");
    return 0;
}

int CVideoNetClientDemoDlg::PTZControl(DWORD channel, DWORD command, DWORD Para1, DWORD Para2, DWORD Para3, DWORD Para4)
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_PTZControl(hUser, channel, (ePTZControlCmdCode)command, Para1, Para2, Para3, Para4)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::Reboot()
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_DeviceControl(hUser, eDeviceReboot)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::Shutdown()
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_DeviceControl(hUser, eDeviceHalt)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::SetDefense()
{
    HUSER hUser = INVALID_HANDLE_VALUE;
    if (CHECK_RET_FAILED(GetSelectUser(hUser)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    if (CHECK_RET_FAILED(VideoNetClient_DeviceControl(hUser, eDeviceSetDefense)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    return 0;
}

int CVideoNetClientDemoDlg::UnsetDefense()
{
    HUSER hUser = INVALID_HANDLE_VALUE;
    if (CHECK_RET_FAILED(GetSelectUser(hUser)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    if (CHECK_RET_FAILED(VideoNetClient_DeviceControl(hUser, eDeviceUnsetDefense)))
    {
        SIMPLE_FAILED;
        return 1;
    }
    return 0;
}

int CVideoNetClientDemoDlg::DiskGroupManage()
{
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	if (CHECK_RET_FAILED(VideoNetClient_DiskGroupManage(hUser, (eDiskGroupOperation)1,2,3,4)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::ReceiveUserEvent(HUSER hUser, DWORD eEvent, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwUserData)
{
	CString strInfo;
	strInfo.Format("User : %d, Event: %d, dwParam1: %d, dwParam2:%d,  dwParam3:%d, UserData : %d\n", hUser, eEvent, dwParam1, dwParam2, dwParam3, dwUserData);
	//ϢDebug
	OutputDebugString(strInfo);
	//¼Ϣ϶,InformationڿܻϢ.
	//ʷѯ¼
	if (eEvent & USEREVENT_HISTORYSTREAM_NOTICE)
	{
		//ʷѯ¼
		if (1 == dwParam1 && (HUSER)dwUserData == hUser && INVALID_HANDLE_VALUE != m_hHistoryQueryEvent)
		{
			//ݴС
			m_dwHistoryQuerySize = dwParam3;
			//ʷѯ¼
			::SetEvent(m_hHistoryQueryEvent);
		}
	}
	return 0;
}

int CVideoNetClientDemoDlg::ReceiveRealStream(HSTREAM hStream, const StreamMediaFrame cFrame, DWORD dwUserData)
{
	/*CString strInfo;
	strInfo.Format("[%s : %d] len:%d ch:%d type:%d %d-%d-%d %d:%d:%d.%d\n", __FUNCTION__, __LINE__,
		cFrame.cFrameBuffer.dwBufLen, cFrame.dwChannel, cFrame.dwFrameType,
		cFrame.cFrameTime.wYear, cFrame.cFrameTime.wMonth, cFrame.cFrameTime.wDay,
		cFrame.cFrameTime.wHour, cFrame.cFrameTime.wMinute, cFrame.cFrameTime.wSecond, cFrame.cFrameTime.wMillisecond);
	//ϢDebug
	OutputDebugString(strInfo);*/
	//Ϣ϶,InformationڿܻϢ.

	//תе¼
	if (CHECK_RET_SUCCESS(m_cCycleRealStream.CheckStream(hStream)))
	{
		return 0;
	}

	HUSER hUser = (HUSER)dwUserData;
	RealStreamManager *stream = NULL;
	UserManager *user = NULL;
	int id = 0;
	if (CHECK_RET_FAILED(m_cDeviceManager.Search(id, hUser)))
	{
		return 1;
	}
	//ȡû
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, &user)) || CHECK_POINT_NULL(user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡ
	if (CHECK_RET_FAILED(user->GetRealStream(hUser, &stream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//
	if (CHECK_RET_FAILED(stream->Stream(hStream, (char*)cFrame.cFrameBuffer.pBuffer, cFrame.cFrameBuffer.dwBufLen)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::ReceiveTalkStream(HSTREAM hStream, eVoiceStreamSource eSource, const StreamVoiceFrame cFrame, DWORD dwUserData)
{
	HUSER hUser = (HUSER)dwUserData;
	TalkStreamManager *stream = NULL;
	UserManager *user = NULL;
	int id = 0;
	//ȡ豸
	if (CHECK_RET_FAILED(m_cDeviceManager.Search(id, hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡû
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, &user)) || CHECK_POINT_NULL(user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡ
	if (CHECK_RET_FAILED(user->GetTalkStream(hUser, &stream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//
	if (CHECK_RET_FAILED(stream->Stream(hStream, (char*)cFrame.cFrameBuffer.pBuffer, cFrame.cFrameBuffer.dwBufLen)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::ReceiveHistoryStream(HSTREAM hStream, const StreamMediaFrame cFrame, DWORD dwUserData)
{
	HUSER hUser = (HUSER)dwUserData;
	HistoryStreamManager *stream = NULL;
	UserManager *user = NULL;
	int id = 0;
	//ȡ豸
	if (CHECK_RET_FAILED(m_cDeviceManager.Search(id, hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡû
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, &user)) || CHECK_POINT_NULL(user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡ
	if (CHECK_RET_FAILED(user->GetHistoryStream(hUser, &stream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//
	if (CHECK_RET_FAILED(stream->Stream(hStream, (char*)cFrame.cFrameBuffer.pBuffer, cFrame.cFrameBuffer.dwBufLen)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::ReceiveTransparent(HTRANSPARENT hTransparent, const LPBuffer pBuffer, DWORD dwUserData)
{
	HUSER hUser = (HUSER)dwUserData;
	TransparentManager *stream = NULL;
	UserManager *user = NULL;
	int id = 0;

	char outbyte[10*1024];
	memset(outbyte, 0, sizeof(outbyte));
	sprintf(outbyte,"͸ͨ: %d ֽ\n", pBuffer->dwBufLen);
	for(int loop=0;loop<pBuffer->dwBufLen;loop++)
	{
		sprintf(outbyte,"%s 0x%02x",  outbyte, pBuffer->pBuffer[loop]);
	}
	sprintf(outbyte,"%s\n",outbyte);
	this->Output(outbyte);

	m_cOutputToFileTrans.Output((char*)pBuffer->pBuffer, pBuffer->dwBufLen);
	//ȡ豸
	if (CHECK_RET_FAILED(m_cDeviceManager.Search(id, hUser)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡû
	if (CHECK_RET_FAILED(m_cDeviceManager.GetUser(id, &user)) || CHECK_POINT_NULL(user))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//ȡ
	if (CHECK_RET_FAILED(user->GetTransparent(hUser, &stream)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	//
	if (CHECK_RET_FAILED(stream->Stream(hTransparent, (char*)pBuffer->pBuffer, pBuffer->dwBufLen)))
	{
		SIMPLE_FAILED;
		return 1;
	}
	return 0;
}

int CALLBACK CVideoNetClientDemoDlg::UserEventCallback(HUSER hUser, DWORD eEvent, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwUserData)
{
	return g_pMainDialog->ReceiveUserEvent(hUser, eEvent, dwParam1, dwParam2, dwParam3, dwUserData);
}

int CALLBACK CVideoNetClientDemoDlg::RealStreamCallback(HSTREAM hStream, const StreamMediaFrame *cFrame, DWORD dwUserData)
{
	return g_pMainDialog->ReceiveRealStream(hStream, *cFrame, dwUserData);
}

int CALLBACK CVideoNetClientDemoDlg::TalkStreamCallback(HSTREAM hStream, eVoiceStreamSource eSource, const StreamVoiceFrame *cFrame, DWORD dwUserData)
{
	return g_pMainDialog->ReceiveTalkStream(hStream, eSource, *cFrame, dwUserData);
}

int CALLBACK CVideoNetClientDemoDlg::HistoryStreamCallback(HSTREAM hStream, const StreamMediaFrame *cFrame, DWORD dwUserData)
{
	return g_pMainDialog->ReceiveHistoryStream(hStream, *cFrame, dwUserData);
}

int CALLBACK CVideoNetClientDemoDlg::TransparentCallback(HTRANSPARENT hTransparent, const LPBuffer pBuffer, DWORD dwUserData)
{
	return g_pMainDialog->ReceiveTransparent(hTransparent, pBuffer, dwUserData);
}

int CVideoNetClientDemoDlg::TransparentSend(HTRANSPARENT h, BYTE *buffer, int length)
{
	Buffer	cBuffer;
	DWORD	dwLength = length;
	cBuffer.dwBufLen = dwLength;
	cBuffer.pBuffer = buffer;
	int nRet = 0;
	char outbyte[10*1024];
	memset(outbyte, 0, sizeof(outbyte));
	sprintf(outbyte,"͸ͨ: %d ֽ\n", length);
	for(int loop=0;loop<length;loop++)
	{
		sprintf(outbyte,"%s 0x%02x",  outbyte, buffer[loop]);
	}
	sprintf(outbyte,"%s\n",outbyte);
	this->Output(outbyte);
	nRet = VideoNetClient_TransparentChannelWrite(h, &cBuffer);
	if (0 != nRet)
	{
		NOTIFY_OPERATION_FAILED;
		//NOTIFY_OPERATION_FAILED_STRING("TransparentChannelWrite",nRet);
		return 1;
	}
	return 0;
}

int CVideoNetClientDemoDlg::TalkSend(HSTREAM h, BYTE *buffer, int length)
{
	int nRet = 0;
	Buffer	cBuffer;
	DWORD	dwLength = length;
	cBuffer.dwBufLen = dwLength;
	cBuffer.pBuffer = buffer;
	nRet = VideoNetClient_VoiceStreamSend(h, &cBuffer);
	if (0 != nRet)
	{
		NOTIFY_OPERATION_FAILED;
		//NOTIFY_OPERATION_FAILED_STRING("VoiceStreamSend",nRet);
		return 1;
	}
	return nRet;
}

void myCB_DeviceProbe(IN LPDeviceProbeConfig cConfig)
{
	//NOTIFY_OPERATION_FAILED_STRING("");
}

void CVideoNetClientDemoDlg::OnServiceStart()
{
	int nRet = 0;
	SIMPLE_TRACK;
	nRet = VideoNetClient_Start();
	if (0 != nRet)
	{
		//NOTIFY_OPERATION_FAILED;
		if (eErrorAlreadyRun == nRet)
		{
			NOTIFY_OPERATION_FAILED_STRING("VideoNetClient_Start failed, Please do not repeat the call",nRet);
		}else{
			NOTIFY_OPERATION_FAILED_STRING("VideoNetClient_Start",nRet);
		}
		return ;
	}

#if 0
	DeviceProbeParameter dpp;
	dpp.m_wBeginPort = 5555;
	dpp.m_wEndPort = 5555;
	nRet = VideoNetClient_DeviceProbeStart(&dpp, myCB_DeviceProbe);
	
	if (MB_OK == MessageBox("ֹͣ?"))
	{

	}
#endif



// 	WSADATA wsaData;
// 	WORD wVersionRequested = MAKEWORD(2,2);							//-,-汾
// 	WSAStartup(wVersionRequested,&wsaData);

// 	nRet = InitRegisterDevServer();
// 	if(CHECK_RET_FAILED(nRet))
// 	{
// 		return;
// 	}
// 	SIMPLE_TRACK;


	return;
}

void CVideoNetClientDemoDlg::OnServiceStop()
{
	int nRet = 0;
	SIMPLE_TRACK;
	nRet = VideoNetClient_Stop();
	if (0 != nRet)
	{
		NOTIFY_OPERATION_FAILED;
		//NOTIFY_OPERATION_FAILED_STRING("VideoNetClient_Stop",nRet);
		return;
	}
// 	nRet = VideoNetClient_DeviceRegisterListenStop();
// 	if(CHECK_RET_FAILED(nRet))
// 	{
// 		MessageBox("DeviceRegisterListen stop fail");
// 		return;
// 	}
// 	SIMPLE_TRACK;
	return;
}

void CVideoNetClientDemoDlg::OnDeviceInsert()
{
	SIMPLE_TRACK;
	CDeviceDlg	cDeviceDlg;
	eNetworkSDKVersion nType;
	int nRet = 0;
	if (IDOK == cDeviceDlg.DoModal())
	{
		if (cDeviceDlg.m_EDAddress.IsEmpty() || cDeviceDlg.m_EDCommand.IsEmpty())
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		int id = 0;
		DeviceInformation	info;
		info.m_cDevice = cDeviceDlg.m_EDAddress;
		info.m_Command = atoi(cDeviceDlg.m_EDCommand);
		if (CHECK_RET_FAILED(m_cDeviceManager.Insert(id)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		if (CHECK_RET_FAILED(m_cDeviceManager.SetDeviceInfo(id, info)))
		{
			m_cDeviceManager.Remove(id);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		HTREEITEM item = m_TRDevice.InsertItem(info.m_cDevice.c_str());
		if (CHECK_POINT_NULL(item))
		{
			m_cDeviceManager.Remove(id);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_TRDevice.SetItemData(item, id);
		if (CHECK_POINT_NULL(m_TRDevice.GetSelectedItem()))
		{
			m_TRDevice.SelectItem(item);
		}
		/*nRet = VideoNetClient_GetSDKVersion(cDeviceDlg.m_EDAddress, info.m_Command, 2000, &nType);
		if (nRet)
		{
			CString strTemp;
			strTemp.Format("nRet : %d",nRet);
			MessageBox(strTemp);
		}
		else
		{
			CString strTemp;
			strTemp.Format("nType : %d",nType);
			MessageBox(strTemp);
		}*/
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnDeviceRemove()
{
	SIMPLE_TRACK;
	HTREEITEM item = m_TRDevice.GetSelectedItem();
	if (CHECK_POINT_NULL(item))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int id = m_TRDevice.GetItemData(item);
	m_TRDevice.DeleteItem(item);
	if (CHECK_RET_FAILED(m_cDeviceManager.Remove(id)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUserLogin()
{
	SIMPLE_TRACK;
	int nRet = 0;
	UserManager *user = NULL;
	if (CHECK_RET_FAILED(GetSelectUserManager(&user)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CUserDlg	cUserDlg;
	if (IDOK == cUserDlg.DoModal())
	{
		HTREEITEM item = m_TRDevice.GetSelectedItem();
		if (CHECK_POINT_NULL(item))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		int id = m_TRDevice.GetItemData(item);
		DeviceInformation device;
		//ȡ豸Ϣ
		if (CHECK_RET_FAILED(m_cDeviceManager.GetDeviceInfo(id, device)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		HUSER	h = INVALID_HANDLE_VALUE;
		UserLoginPara	para;
		para.dwCommandPort = device.m_Command;
		strcpy(para.sServerIP, device.m_cDevice.c_str());
		strcpy(para.sUName, cUserDlg.m_EDUserName);
		strcpy(para.sUPass, cUserDlg.m_EDPassWord);
		//û¼
// 		if (CHECK_RET_FAILED(VideoNetClient_UserLogin(&h, &para)))
// 		{
// 			NOTIFY_OPERATION_FAILED;
// 			return;
// 		}
		nRet = VideoNetClient_UserLogin(&h, &para);
		if(0 != nRet)
		{
// 			CString strTemp;
// 			strTemp.Format("UserLogin fail,nRet : %d",nRet);
// 			MessageBox(strTemp);
			NOTIFY_OPERATION_FAILED_STRING("UserLogin",nRet);
			return;
		}
		//û
		if (CHECK_RET_FAILED(user->Insert(h)))
		{
			VideoNetClient_UserLogout(h);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		if (CHECK_RET_FAILED(m_cDeviceManager.Insert(id, h)))
		{
			VideoNetClient_UserLogout(h);
			user->Remove(h);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		UserInfoManager *info = NULL;
		//ûϢ
		if (CHECK_RET_FAILED(user->GetUserInfo(h, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_UserLogout(h);
			user->Remove(h);
			m_cDeviceManager.Remove(id);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		string sDevice;
		user->GetDevice(sDevice);
		info->m_cUserInformation.m_cUserName = cUserDlg.m_EDUserName;
		info->m_cUserInformation.m_cPassWord = cUserDlg.m_EDPassWord;
		CString strInfo;
		strInfo.Format("%d_%s_%s", h, sDevice.c_str(), info->m_cUserInformation.m_cUserName.c_str());
		item = m_TRUser.InsertItem(strInfo);
		if (CHECK_POINT_NULL(item))
		{
			VideoNetClient_UserLogout(h);
			user->Remove(h);
			m_cDeviceManager.Remove(id);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_TRUser.SetItemData(item, (DWORD)h);
		if (CHECK_POINT_NULL(m_TRUser.GetSelectedItem()))
		{
			m_TRUser.SelectItem(item);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUserLogout()
{
	SIMPLE_TRACK;
	int nRet = 0;
	UserManager *user = NULL;
	HUSER h = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserManager(&user)) || CHECK_RET_FAILED(GetSelectUser(h)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HTREEITEM item = m_TRDevice.GetSelectedItem();
	if (CHECK_POINT_NULL(item))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int id = m_TRDevice.GetItemData(item);
	HTREEITEM useritem = m_TRUser.GetSelectedItem();
	if (CHECK_POINT_NULL(useritem))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	//ûע
// 	if (CHECK_RET_FAILED(VideoNetClient_UserLogout(h)))
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
	nRet = VideoNetClient_UserLogout(h);
	if(0 != nRet)
	{
		NOTIFY_OPERATION_FAILED_STRING("UserLogout",nRet);
		return;
	}
	//Ƴû
	if (CHECK_RET_FAILED(user->Remove(h)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	if (CHECK_RET_FAILED(m_cDeviceManager.Remove(id, h)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_TRUser.DeleteItem(useritem);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUserEvent()
{
	int nRet = 0;
	SIMPLE_TRACK;
	UserManager *user = NULL;
	HUSER h = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserManager(&user)) || CHECK_RET_FAILED(GetSelectUser(h)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CUserEventDlg	cUserEventDlg;
	UserInfoManager *info = NULL;
	//ûϢ
	if (CHECK_RET_FAILED(user->GetUserInfo(h, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	cUserEventDlg.m_cEventInfo = info->m_cUserEventInformation;
	if (IDOK == cUserEventDlg.DoModal())
	{
		DWORD dwEvent = 0;
		dwEvent |= USEREVENT_ALARM_NOTICE;
		info->m_cUserEventInformation = cUserEventDlg.m_cEventInfo;
		if (info->m_cUserEventInformation.m_EventSubscribe[0])
		{
			nRet = VideoNetClient_SubscribeEvent(h, dwEvent, UserEventCallback, 1);
			if (0 != nRet)
			{
				NOTIFY_OPERATION_FAILED_STRING("SubscribeEvent",nRet);
				return;
			}
		}else{
			nRet = VideoNetClient_UnSubscribeEvent(h, dwEvent);
			if (0 != nRet)
			{
				NOTIFY_OPERATION_FAILED_STRING("UnSubscribeEvent",nRet);
				return;
			}
		}
		if (info->m_cUserEventInformation.m_EventSubscribe[1])
		{
// 			if (CHECK_RET_FAILED(VideoNetClient_SubscribeEvent(h, dwEvent, UserEventCallback, 2)))
// 			{
// 				NOTIFY_OPERATION_FAILED;
// 			}
			nRet = VideoNetClient_SubscribeEvent(h, dwEvent, UserEventCallback, 1);
			if (0 != nRet)
			{
				NOTIFY_OPERATION_FAILED_STRING("SubscribeEvent",nRet);
				return;
			}
	
		}else{
// 			if (CHECK_RET_FAILED(VideoNetClient_UnSubscribeEvent(h, dwEvent)))
// 			{
// 				NOTIFY_OPERATION_FAILED;
// 			}
			nRet = VideoNetClient_UnSubscribeEvent(h, dwEvent);
			if (0 != nRet)
			{
				NOTIFY_OPERATION_FAILED_STRING("UnSubscribeEvent",nRet);
				return;
			}
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUserConfig()
{
	SIMPLE_TRACK;
	/*UserManager *user = NULL;
	HUSER h = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserManager(&user)) || CHECK_RET_FAILED(GetSelectUser(h)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	ConfigInformation	cConfig;
	cConfig.dwMainCommand = eSystemCfg;
	cConfig.dwAssistCommand = eTimeInfoCfg;
	if (CHECK_RET_FAILED(VideoNetClient_GetConfig(h, &cConfig)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	ConfigSystemTime cTime;
	if (sizeof(cTime) != cConfig.dwConfigLen)
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	memcpy(&cTime, cConfig.sConfig, sizeof(cTime));
	CUserConfigDlg	cDialog;
	cDialog.m_info = cTime;
	if (IDOK == cDialog.DoModal())
	{
		cTime = cDialog.m_info;
		cConfig.dwMainCommand = eSystemCfg;
		cConfig.dwAssistCommand = eTimeInfoCfg;
		memcpy(cConfig.sConfig, &cTime, sizeof(cTime));
		cConfig.dwConfigLen = sizeof(cTime);
		if (CHECK_RET_FAILED(VideoNetClient_SetConfig(h, &cConfig)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
	}*/
	UserManager *user = NULL;
	HUSER h = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserManager(&user)) || CHECK_RET_FAILED(GetSelectUser(h)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}

	//ISPûȡ
// 	ConfigInformation	cConfig;
// 	VIDEONETCLIENT_NXP8850ISP_CFG struConfig;
// 	memset(&struConfig,0,sizeof(struConfig));
// 	struConfig.bValid = 1;
// 	struConfig.struTemplate[0].bValid = 1;
// 	struConfig.struTemplate[0].struAEWindow[0].bValid = 1;
// 	struConfig.struTemplate[0].struAEWindow[0].nHeight = 2;
// 	struConfig.struTemplate[0].struAEWindow[0].nWidth = 3;
// 	cConfig.dwMainCommand = VIDEONETCLIENT_SET_NXP8850ISP;
// 	cConfig.dwAssistCommand = NXP8850ISP_ALL;
// 	memcpy(cConfig.sConfig,&struConfig,sizeof(struConfig));
// 	cConfig.dwConfigLen = sizeof(struConfig);
// 	if (CHECK_RET_FAILED(VideoNetClient_SetConfig(h, &cConfig)))
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 		return;
// 	}
}

void CVideoNetClientDemoDlg::OnUserControl()
{
	SIMPLE_TRACK;
	CControlDlg	cDialog;
	cDialog.DoModal();
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUserPTZControl()
{
	SIMPLE_TRACK;
	CUserPTZControlDlg	cDialog;
	cDialog.DoModal();
	SIMPLE_TRACK;
}

//תϢ
void CVideoNetClientDemoDlg::ChangeFontInfo(FontPara &lfont, const LOGFONT &rfont)
{
	lfont.lfHeight = rfont.lfHeight;
	lfont.lfWidth = rfont.lfWidth;
	lfont.lfEscapement = rfont.lfEscapement;
	lfont.lfOrientation = rfont.lfOrientation;
	lfont.lfWeight = rfont.lfWeight;
	lfont.lfItalic = rfont.lfItalic;
	lfont.lfUnderline = rfont.lfUnderline;
	lfont.lfStrikeOut = rfont.lfStrikeOut;
	lfont.lfCharSet = rfont.lfCharSet;
	lfont.lfOutPrecision = rfont.lfOutPrecision;
	lfont.lfClipPrecision = rfont.lfClipPrecision;
	lfont.lfQuality = rfont.lfQuality;
	lfont.lfPitchAndFamily = rfont.lfPitchAndFamily;
	strcpy(lfont.lfFaceName, rfont.lfFaceName);
}

#define DVR_MAX_LATTICE_LINE	(2)
#define DVR_MAX_LATTICE_BUFSIZE ((24) * (24 * DVR_MAX_LATTICE_LINE) * 10 / 8)

void CVideoNetClientDemoDlg::OnStringToLattice()
{
	int nRet = 0;
	CString str("01\r\n012354");
	CSelectFontDlg	cFontDlg(str);
	if (IDOK == cFontDlg.DoModal())
	{
		char Buffer[DVR_MAX_LATTICE_BUFSIZE] = "\0";
		DWORD dwBuflen = sizeof(Buffer);
		LOGFONT cLogFont;
		FontPara cFontPara;
		DWORD dwWidth = 0;
		DWORD dwHeight = 0;
		cFontDlg.GetSelectFont(cLogFont);
		ChangeFontInfo(cFontPara, cLogFont);
		nRet = VideoNetClient_StringToLattice(str, &cFontPara, Buffer, &dwBuflen, &dwWidth, &dwHeight);
		if (0 != nRet)
		{
			NOTIFY_OPERATION_FAILED_STRING("StringToLattice",nRet);
			return;
		}
	}
}

void CVideoNetClientDemoDlg::OnRealStreamConnect()
{
	SIMPLE_TRACK;
	int nRet = 0;
	string device;
	RealStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserRealStreamManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CRealStreamDlg	cRealStreamDlg;
	if (IDOK == cRealStreamDlg.DoModal())
	{
		if (MAX_CHANNEL_NUMBER == cRealStreamDlg.m_info.m_Channel)
		{
			for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
			{
				cRealStreamDlg.m_info.m_Channel = count;
// 				if (CHECK_RET_FAILED(RealStreamConnect(hUser, device, stream, cRealStreamDlg.m_info, true)))
// 				{
// 					return;
// 				}
				nRet = RealStreamConnect(hUser, device, stream, cRealStreamDlg.m_info, true);
				if(0 != nRet)
				{
// 					CString strTemp;
// 					strTemp.Format("RealStreamConnect fail,nRet : %d",nRet);
// 					MessageBox(strTemp);
				//NOTIFY_OPERATION_FAILED;
					return;
				}
			}
		}else{
			nRet = RealStreamConnect(hUser, device, stream, cRealStreamDlg.m_info);
			if(0 != nRet)
			{
				CString strTemp;
				strTemp.Format("RealStreamConnect fail,nRet : %d",nRet);
				MessageBox(strTemp);
				NOTIFY_OPERATION_FAILED;
				return;
			}
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnRealStreamDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSRealStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	RealStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserRealStreamManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_RealStreamDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSRealStream.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnRealStreamStart()
{
	SIMPLE_TRACK;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSRealStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStart)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnRealStreamStop()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSRealStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStop)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnRealStreamStartCycle()
{
	SIMPLE_TRACK;
	string device;
	RealStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserRealStreamManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CRealStreamDlg	cRealStreamDlg;
	if (IDOK == cRealStreamDlg.DoModal())
	{
		//Ϣ
		if (CHECK_RET_FAILED(m_cCycleRealStream.SetInformation(hUser, cRealStreamDlg.m_info)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ת
		if (CHECK_RET_FAILED(m_cCycleRealStream.Start(DEFAULT_CYCLE_INTERVAL)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnRealStreamStopCycle()
{
	SIMPLE_TRACK;
	//ֹͣת
	if (CHECK_RET_FAILED(m_cCycleRealStream.Stop()))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTalkStreamConnect()
{
	SIMPLE_TRACK;
	string device;
	TalkStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserTalkStreamManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CTalkStreamDlg	cTalkStreamDlg;
	if (IDOK == cTalkStreamDlg.DoModal())
	{
		HSTREAM hStream = INVALID_HANDLE_VALUE;
		VoiceStreamPara	para;
		para.dwChannel = 0;
		para.eMode = eVoiceG726;
		para.eTransferMode = (eStreamTransferMode)cTalkStreamDlg.m_info.m_Protocol;
		//
		if (CHECK_RET_FAILED(VideoNetClient_VoiceStreamConnect(&hStream, hUser, &para)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		if (CHECK_RET_FAILED(VideoNetClient_VoiceStreamCB(hStream, TalkStreamCallback, (DWORD)hUser)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_VoiceStreamDisconnect(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		TalkStreamInfoManager *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_VoiceStreamDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		info->m_StreamInfo = cTalkStreamDlg.m_info;
		info->m_hStream = hStream;
		CString strInfo(info->m_StreamInfo.m_cRecvFile.c_str());
		CUtility	cUtility;
		cUtility.BuildRecordFile(strInfo, device.c_str(), para.dwChannel, "wav");
		info->m_StreamInfo.m_cRecvFile = strInfo;

		int count = m_LSTalkStream.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_VoiceStreamDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, info->m_StreamInfo)))
		{
			VideoNetClient_VoiceStreamDisconnect(hStream);
			stream->Remove(hStream);
			m_LSTalkStream.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSTalkStream.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSTalkStream.GetSelectionMark())
		{
			m_LSTalkStream.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTalkStreamDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSTalkStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserTalkStreamManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamInfoManager *info = NULL;
	HSTREAM hStream = (HSTREAM)id;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_VoiceStreamDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSTalkStream.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTalkStreamStart()
{
	SIMPLE_TRACK;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSTalkStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamManager *stream = NULL;
	if (CHECK_RET_FAILED(GetSelectUserTalkStreamManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamInfoManager *info = NULL;
	HSTREAM hStream = (HSTREAM)id;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStart)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	//
	if (CHECK_RET_FAILED(info->Start()))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTalkStreamStop()
{
	SIMPLE_TRACK;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSTalkStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamManager *stream = NULL;
	if (CHECK_RET_FAILED(GetSelectUserTalkStreamManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TalkStreamInfoManager *info = NULL;
	HSTREAM hStream = (HSTREAM)id;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	if (CHECK_RET_FAILED(info->Stop()))
	{
		NOTIFY_OPERATION_FAILED;
	}
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStop)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryQueryConnect()
{
	SIMPLE_TRACK;
	HistoryQueryManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserHistoryQueryManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CUtility	cUtility;
	CHistoryQueryDlg	cOperationDlg;
	if (IDOK == cOperationDlg.DoModal())
	{
		HSTREAM_QUERY hStream = INVALID_HANDLE_VALUE;
		HistoryStreamQueryFactor	para;
		para.dwChannel = cOperationDlg.m_info.m_Channel;
		para.dwDiskGroup = cOperationDlg.m_info.m_DiskGroup + 1;
		para.eStreamType = (eHistoryStreamType)(cOperationDlg.m_info.m_QueryType + 1);
		cUtility.TimeToString(para.cBeginTime, cOperationDlg.m_info.m_StartTime);
		cUtility.TimeToString(para.cEndTime, cOperationDlg.m_info.m_StopTime);

		//
		if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamQueryConnect(&hStream, hUser, &para)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_VoiceStreamDisconnect(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		HistoryQueryInformation *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_HistoryStreamQueryDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		(*info) = cOperationDlg.m_info;

		int count = m_LSHistoryQuery.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_HistoryStreamQueryDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, *info)))
		{
			VideoNetClient_HistoryStreamQueryDisconnect(hStream);
			stream->Remove(hStream);
			m_LSHistoryQuery.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSHistoryQuery.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSHistoryQuery.GetSelectionMark())
		{
			m_LSHistoryQuery.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryQueryDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSHistoryQuery)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HistoryQueryManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserHistoryQueryManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM_QUERY hStream = (HSTREAM_QUERY)id;
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamQueryDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSHistoryQuery.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryQueryQuery()
{
	SIMPLE_TRACK;
	string device;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSHistoryQuery)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HistoryQueryInformation	*info = NULL;
	HistoryQueryManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserHistoryQueryManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM_QUERY hStream = (HSTREAM_QUERY)id;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CHistoryQueryResultDlg	cHistoryQueryResultDlg;
	HistoryStreamQueryResult	cResult;
	CString strInfo(info->m_Record.c_str());
	CUtility	cUtility;
	cUtility.BuildRecordFile(strInfo, device.c_str(), info->m_Channel, "txt");
	COutputToFile file;
	if (0 != file.Open(LPCSTR(strInfo)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	count = 0;
	//ѯ
	while (CHECK_RET_SUCCESS(VideoNetClient_HistoryStreamQueryNext(hStream, &cResult)))
	{
		strInfo.Format("Index:%6d  %2d  %2d  %12d  %s  %s\n", count, (DWORD)cResult.eStreamType, cResult.dwChannel, cResult.dwStreamSize, cResult.cBeginTime, cResult.cEndTime);
		file.Output(strInfo, strInfo.GetLength());
		cHistoryQueryResultDlg.m_lsQueryResult.push_back(cResult);
		count += 1;
	}
	file.Close();
	//Ĳѯ¼
	if (0 < cHistoryQueryResultDlg.m_lsQueryResult.size() && CHECK_RET_SUCCESS(VideoNetClient_SubscribeEvent(hUser,(DWORD)USEREVENT_HISTORYSTREAM_NOTICE, &CVideoNetClientDemoDlg::UserEventCallback, (DWORD)hUser)))
	{
		//ѯ¼
		if (INVALID_HANDLE_VALUE == m_hHistoryQueryEvent)
		{
			m_hHistoryQueryEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		}
		if (INVALID_HANDLE_VALUE != m_hHistoryQueryEvent)
		{
			//ЧݴС
			DWORD dwInvalidDataSize = 0;
			//ͨ
			DWORD dwChannelBits = 1L;
			if(info->m_Channel)
				dwChannelBits = dwChannelBits << info->m_Channel;
			//ѯݴС
			for (CHistoryQueryResultDlg::ListQueryResult::iterator iter = cHistoryQueryResultDlg.m_lsQueryResult.begin();
				iter != cHistoryQueryResultDlg.m_lsQueryResult.end(); ++iter)
			{
				m_dwHistoryQuerySize = 0;
				//ȡʷƬδС
				if (CHECK_RET_SUCCESS(VideoNetClient_GetMultiTypeDataSize(hUser, dwChannelBits, eDiskGroupNormal, eAllStreamMedia, iter->cBeginTime, iter->cEndTime, (DWORD)hUser, &dwInvalidDataSize)))
				{
					//ȴݴСѯ¼
					::WaitForSingleObject(m_hHistoryQueryEvent, 30 * 1000);
					//ݴС
					iter->dwStreamSize = m_dwHistoryQuerySize;
				}
			}
			::CloseHandle(m_hHistoryQueryEvent);
			m_hHistoryQueryEvent = INVALID_HANDLE_VALUE;
		}
		//˶ѯ¼
		VideoNetClient_UnSubscribeEvent(hUser, USEREVENT_HISTORYSTREAM_NOTICE);
	}
	cHistoryQueryResultDlg.DoModal();
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryStreamConnect()
{
	SIMPLE_TRACK;
	string device;
	HistoryStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserHistoryStreamManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CHistoryStreamDlg	cOperationDlg;
	if (IDOK == cOperationDlg.DoModal())
	{
		CUtility	cUtility;
		HSTREAM hStream = INVALID_HANDLE_VALUE;
		HistoryStreamPara	para;
		para.dwChannel = cOperationDlg.m_info.m_Channel;
		para.dwDiskGroup = cOperationDlg.m_info.m_Group;
		para.eStreamType = (eHistoryStreamType)cOperationDlg.m_info.m_QueryType;
		para.eTransferMode = (eStreamTransferMode)cOperationDlg.m_info.m_Protocol;
		cUtility.TimeToTimeInfo(para.cBeginTime, cOperationDlg.m_info.m_StartTime);
		cUtility.TimeToTimeInfo(para.cEndTime, cOperationDlg.m_info.m_StopTime);
		para.dwEnableEndTime = 0;

		//
		if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamCreate(&hStream, hUser, &para, 0)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_HistoryStreamDestroy(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		HistoryStreamInfoManager *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_HistoryStreamDestroy(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		info->m_StreamInfo = cOperationDlg.m_info;
		CString strInfo(info->m_StreamInfo.m_Record.c_str());
		cUtility.BuildRecordFile(strInfo, device.c_str(), para.dwChannel, "prv");
		info->m_StreamInfo.m_Record = strInfo;

		int count = m_LSHistoryStream.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_HistoryStreamDestroy(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, info->m_StreamInfo)))
		{
			VideoNetClient_HistoryStreamDestroy(hStream);
			stream->Remove(hStream);
			m_LSHistoryStream.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSHistoryStream.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSHistoryStream.GetSelectionMark())
		{
			m_LSHistoryStream.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryStreamDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSHistoryStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HistoryStreamManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserHistoryStreamManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamDestroy(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSHistoryStream.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryStreamStart()
{
	SIMPLE_TRACK;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUser(hUser)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSHistoryStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStart)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamCB(hStream, HistoryStreamCallback, (DWORD)hUser)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryStreamStop()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSHistoryStream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HSTREAM hStream = (HSTREAM)id;
	if (CHECK_RET_FAILED(VideoNetClient_HistoryStreamCB(hStream, HistoryStreamCallback, 0)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	if (CHECK_RET_FAILED(StreamMediaControl(hStream, eTaskStop)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnHistoryStreamAsync()
{
	SIMPLE_TRACK;
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTransparentConnect()
{
	SIMPLE_TRACK;
	string device;
	TransparentManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserTransparentManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CTransparentDlg	cOperationDlg;
	if (IDOK == cOperationDlg.DoModal())
	{
		HTRANSPARENT hStream = INVALID_HANDLE_VALUE;
		TransparentChannelPara	para;
		para.dwMajorType = cOperationDlg.m_info.m_SerialType;
		para.dwMinorType = cOperationDlg.m_info.m_SerialPort;
		//
		if (CHECK_RET_FAILED(VideoNetClient_TransparentChannelConnect(&hStream, hUser, &para)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}

//add lsj
		CString strInfo1;
		CString strTime;
		SYSTEMTIME systime;
		GetLocalTime(&systime);
		//TimeToString(&strTime, systime);
		strTime.Format("%04d%02d%02d%02d%02d%02d", systime.wYear,systime.wMonth, systime.wDay, systime.wHour, systime.wMinute, systime.wSecond);
		strInfo1.Format("c:\\Transparent_User%d_%s.txt", (DWORD)hUser,strTime);

		if (0 != m_cOutputToFileTrans.Open(LPCSTR(strInfo1),true))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}


		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_TransparentChannelDisconnect(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		TransparentInfoManager *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_TransparentChannelDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		info->m_StreamInfo = cOperationDlg.m_info;
		info->m_hStream = hStream;
		CString strInfo(info->m_StreamInfo.m_cRecvFile.c_str());
		CUtility	cUtility;
		cUtility.BuildRecordFile(strInfo, device.c_str(), 0, "txt");
		info->m_StreamInfo.m_cRecvFile = strInfo;

		//עݻص
		if (CHECK_RET_FAILED(VideoNetClient_TransparentChannelCB(hStream, TransparentCallback, (DWORD)hUser)))
		{
			VideoNetClient_TransparentChannelDisconnect(hStream);
			m_cOutputToFileTrans.Close();
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		int count = m_LSTransparent.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_TransparentChannelDisconnect(hStream);
			m_cOutputToFileTrans.Close();
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, info->m_StreamInfo)))
		{
			VideoNetClient_TransparentChannelDisconnect(hStream);
			m_cOutputToFileTrans.Close();
			stream->Remove(hStream);
			m_LSTransparent.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSTransparent.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSTransparent.GetSelectionMark())
		{
			m_LSTransparent.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTransparentDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;

	m_cOutputToFileTrans.Close();
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSTransparent)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TransparentManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserTransparentManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HTRANSPARENT hStream = (HTRANSPARENT)id;
	TransparentInfoManager	*info = NULL;
	//Ϣ
	if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_TransparentChannelDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	info->Stop();
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSTransparent.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnTransparentSend()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSTransparent)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	TransparentManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserTransparentManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CTransparentSendDlg	cTransparentSendDlg(this, (HTRANSPARENT)id);
	if (IDOK == cTransparentSendDlg.DoModal())
	{
		HTRANSPARENT hStream = (HTRANSPARENT)id;
		TransparentInfoManager	*info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		info->m_StreamInfo.m_cSendFile = cTransparentSendDlg.m_EDSendFile;
		info->Stop();
		if (CHECK_RET_FAILED(info->Start()))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnLogQuery()
{
	SIMPLE_TRACK;
	CLogQueryDlg	cDialog;
	cDialog.DoModal();
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnFileQuery()
{
	SIMPLE_TRACK;
	CFileQueryDlg	cDialog;
	cDialog.DoModal();
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnDownloadConnect()
{
	SIMPLE_TRACK;
	string device;
	DownloadManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserDownloadManager(hUser, &stream, &device)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CDownloadDlg	cOperationDlg;
	if (IDOK == cOperationDlg.DoModal())
	{
		HFILE_TRANSFER hStream = INVALID_HANDLE_VALUE;
		FileDownloadPara	para;

		CString strInfo(cOperationDlg.m_info.m_cSaveFile.c_str());
		CUtility	cUtility;
		cUtility.BuildRecordFile(strInfo, device.c_str(), 0, "txt");
		cOperationDlg.m_info.m_cSaveFile = strInfo;
		strcpy(para.strRemoteFilePath, cOperationDlg.m_info.m_cDownloadFile.c_str());
		strcpy(para.strLocalFilePath, cOperationDlg.m_info.m_cSaveFile.c_str());

		//
		if (CHECK_RET_FAILED(VideoNetClient_FileDownloadConnect(&hStream, hUser, &para)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		if(CHECK_RET_FAILED(VideoNetClient_FileDownloadControl(hStream,eFileTransferStart)));
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_FileDownloadDisconnect(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		DownloadInformation *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_FileDownloadDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		(*info) = cOperationDlg.m_info;

		int count = m_LSDownload.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_FileDownloadDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, *info)))
		{
			VideoNetClient_FileDownloadDisconnect(hStream);
			stream->Remove(hStream);
			m_LSDownload.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSDownload.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSDownload.GetSelectionMark())
		{
			m_LSDownload.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnDownloadDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSDownload)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	DownloadManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserDownloadManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HFILE_TRANSFER hStream = (HFILE_TRANSFER)id;
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_FileDownloadDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSDownload.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUploadConnect()
{
	SIMPLE_TRACK;
	UploadManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserUploadManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	CUploadDlg	cOperationDlg;
	if (IDOK == cOperationDlg.DoModal())
	{
		HFILE_TRANSFER hStream = INVALID_HANDLE_VALUE;
		FileUploadPara	para;
		strcpy(para.strRemoteFilePath, "/root/edvr/upload.txt");
		strcpy(para.strLocalFilePath, cOperationDlg.m_info.m_cUploadFile.c_str());
		//
		if (CHECK_RET_FAILED(VideoNetClient_FileUploadConnect(&hStream, hUser, &para)))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//
		if (CHECK_RET_FAILED(stream->Insert(hStream)))
		{
			VideoNetClient_FileUploadDisconnect(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		UploadInformation *info = NULL;
		//Ϣ
		if (CHECK_RET_FAILED(stream->GetInfo(hStream, &info)) || CHECK_POINT_NULL(info))
		{
			VideoNetClient_FileUploadDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}

		(*info) = cOperationDlg.m_info;

		int count = m_LSUpload.InsertItem(0xFFFF, "");
		if (-1 == count)
		{
			VideoNetClient_FileUploadDisconnect(hStream);
			stream->Remove(hStream);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		//ýϢ
		if (CHECK_RET_FAILED(RefreshStreamInfo(count, hStream, *info)))
		{
			VideoNetClient_FileUploadDisconnect(hStream);
			stream->Remove(hStream);
			m_LSUpload.DeleteItem(count);
			NOTIFY_OPERATION_FAILED;
			return;
		}
		m_LSUpload.SetItemData(count, (DWORD)hStream);
		if (-1 == m_LSUpload.GetSelectionMark())
		{
			m_LSUpload.SetSelectionMark(count);
		}
	}
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnUploadDisconnect()
{
	SIMPLE_TRACK;
	int count = 0;
	int id = 0;
	if (CHECK_RET_FAILED(GetListSelectItem(count, id, &m_LSUpload)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	UploadManager *stream = NULL;
	HUSER hUser = INVALID_HANDLE_VALUE;
	if (CHECK_RET_FAILED(GetSelectUserUploadManager(hUser, &stream)))
	{
		NOTIFY_OPERATION_FAILED;
		return;
	}
	HFILE_TRANSFER hStream = (HFILE_TRANSFER)id;
	//Ͽ
	if (CHECK_RET_FAILED(VideoNetClient_FileUploadDisconnect(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	//Ƴ
	if (CHECK_RET_FAILED(stream->Remove(hStream)))
	{
		NOTIFY_OPERATION_FAILED;
	}
	m_LSUpload.DeleteItem(count);
	SIMPLE_TRACK;
}

void CVideoNetClientDemoDlg::OnInformationRecord()
{
	CString strFile;
	CUtility	cUtility;
	if (0 == cUtility.SelectFile(strFile))
	{
		m_cOutputToFile.Close();
		m_cOutputToFile.Open(LPCSTR(strFile));
	}else{
		m_cOutputToFile.Close();
	}
}

void CVideoNetClientDemoDlg::OnInformationCopy()
{
#if 0
	m_EDOutput.SetSel(0, -1);
	m_EDOutput.Copy();
	m_EDOutput.SetSel(0xFFFFFFFF);
#else
	CString strOutput;
	m_EDOutput.GetWindowText(strOutput);
	//򿪼
	if(OpenClipboard())
	{
		EmptyClipboard();
		HGLOBAL clipbuffer = GlobalAlloc(GMEM_DDESHARE, strOutput.GetLength() + 1);
		char *buffer = (char*)GlobalLock(clipbuffer);
		if (CHECK_POINT_NULL(buffer))
		{
			NOTIFY_OPERATION_FAILED;
			return;
		}
		strcpy(buffer, LPCSTR(strOutput));
		GlobalUnlock(clipbuffer);
		SetClipboardData(CF_TEXT, clipbuffer);
		CloseClipboard();
	}else{
		NOTIFY_OPERATION_FAILED;
	}
#endif
}

void CVideoNetClientDemoDlg::OnInformationSave()
{
	CString strFile;
	CString strOutput;
	m_EDOutput.GetWindowText(strOutput);
	CUtility	cUtility;
	if (0 == cUtility.SelectFile(strFile))
	{
		fstream file;
		file.open(strFile, ios_base::out | ios_base::trunc);
		int iLength = strOutput.GetLength() + 1;
		file.write(strOutput, iLength);
		file.close();
	}
}

void CVideoNetClientDemoDlg::OnInformationClear()
{
#if 0
	m_EDOutput.Clear();
#else
	m_EDOutput.SetWindowText("");
#endif
	m_iOutputMessage = 0;
}

void CVideoNetClientDemoDlg::OnClose()
{
	// TODO: ڴϢ/Ĭֵ
	VideoNetClient_DeviceRegisterListenStop();
	VideoNetClient_Stop();

	CDialog::OnClose();
}
void CVideoNetClientDemoDlg::OnInformationGetfileheader()
{
    // TODO: ڴ
    char cHeader[64] = {0};
    DWORD  dwLength = 0;
    CString strHeader,strTmp;
    strHeader = "File Header :";
    VideoNetClient_GetFileHeader(0,cHeader,&dwLength);
    for (int i = 0; i < dwLength; i++)
    {
        strTmp.Format(" 0x%2x ",(BYTE)cHeader[i]);
        strHeader +=strTmp;
    }   
    OutputDebugString(strHeader);
}

// void CVideoNetClientDemoDlg::OnPassivityconnectSetconfig()
// {
// 	// TODO: ڴ
// 	DecoderDeviceConfig cConfig;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cConfig.dwDecoderChannelNumber = 16;
// 	cConfig.eDecodeMode = eResolutionModeQCIF;
// 	int result = VideoNetClient_DecoderSetConfig(hUser,&cConfig);
//}

// void CVideoNetClientDemoDlg::OnPassivityconnectGetconfig()
// {
// 	// TODO: ڴ
// 	DecoderDeviceConfig cConfig;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	int result = VideoNetClient_DecoderGetConfig(hUser,&cConfig);
//}

// void CVideoNetClientDemoDlg::OnPassivityconnectGetchannelinformation()
// {
// 	// TODO: ڴ
// 	DecoderChannelInformation cInformation;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	int result = VideoNetClient_DecoderGetChannelInformation(hUser,dwChannel,&cInformation);
//}

// void CVideoNetClientDemoDlg::OnPassivityconnectSetdisplayconfig()
// {
// 	// TODO: ڴ
// 	DecoderDisplayConfig cConfig;
// 	DWORD dwDisplay = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	for(int iCount = 0; iCount < MAX_DISPLAY_SCREEN_NUMBER; iCount++)
// 	{
// 		cConfig.dwDecoderChannel[iCount] = iCount;
// 	}
// 	cConfig.dwEnlargeWindow = 1001;
// 	cConfig.eScreenControlStatusValue = eScreenControlStatusSplitSingle;
// 	cConfig.eVGAResolution = VGA_SXGA_1280x1024_60HZ;
// 	int result = VideoNetClient_DecoderSetDisplayConfig(hUser,dwDisplay,&cConfig);
//}

// void CVideoNetClientDemoDlg::OnPassivityconnectGetdisplayconfig()
// {
// 	// TODO: ڴ
// 	DecoderDisplayConfig cConfig;
// 	DWORD dwDisplay = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	int result = VideoNetClient_DecoderGetDisplayConfig(hUser,dwDisplay,&cConfig);
//}

HSTREAM g_hStream;

// void CVideoNetClientDemoDlg::OnStreamtransferConnect()
// {
	// TODO: ڴ
// 	StreamTransferPara cStreamPara;
// 	HSTREAM hStream = INVALID_HANDLE_VALUE;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);	
// 		
// 	DWORD dwChannel = 0;
// 	cStreamPara.eTransferMode = eGeneralTCP;
// 	cStreamPara.eVideoCodecValue = eVideoCodecH264;
// 	cStreamPara.eResolutionValue = eResolutionModeCIF;
// 	cStreamPara.eStreamSourceValue = eStreamSourceTypeReal;
// 	cStreamPara.eVoiceCodecValue = eVoiceG711U;
// 	strcpy(cStreamPara.cOSDInfo.cOSDText,"channel 0");
// 	cStreamPara.cOSDInfo.dwEnable = 1;
// 	int result = VideoNetClient_StreamTransferConnect(&g_hStream, hUser, dwChannel, &cStreamPara);
// 	Sleep(5000);
//	VideoNetClient_Stop();
/*	for(int i=0; i<3; i++)
	{
		DWORD dwChannel = i;
		cStreamPara.eTransferMode = eGeneralTCP;
		cStreamPara.eVideoCodecValue = eVideoCodecH264;
		cStreamPara.eResolutionValue = eResolutionModeCIF;
		cStreamPara.eStreamSourceValue = eStreamSourceTypeReal;
		cStreamPara.eVoiceCodecValue = eVoiceG711U;
		sprintf(cStreamPara.cOSDInfo.cOSDText,"channel %d",i);
		cStreamPara.cOSDInfo.dwEnable = 1;
		int result = VideoNetClient_StreamTransferConnect(&hStream, hUser, dwChannel, &cStreamPara);
		g_hStream[i] = hStream;
		Output("VideoNetClient_StreamTransferConnect g_hStream : %d\n",hStream);
	}
*/
//}

// void CVideoNetClientDemoDlg::OnStreamtransferDisconnect()
// {
	// TODO: ڴ
/*	for(int i=0; i<3; i++)
	{
		Output("VideoNetClient_StreamTransferDisconnect hStream : %d\n",g_hStream[i]);
		VideoNetClient_StreamTransferDisconnect(g_hStream[i]);
	}
*/

	
//	VideoNetClient_StreamTransferDisconnect(g_hStream);
//}

// void CVideoNetClientDemoDlg::OnStreamtransferSend()
// {
// 	// TODO: ڴ
// 	StreamTransferFrame cFrame;
// 	cFrame.eFrameTypeInfo = eFrameIFrames;
// 	cFrame.cAbsoluteTime.wYear = 2010;
// 	cFrame.cAbsoluteTime.wMonth = 10;
// 	cFrame.cAbsoluteTime.wDay = 11;
// 	cFrame.cAbsoluteTime.wHour = 14;
// 	cFrame.cAbsoluteTime.wMinute = 6;
// 	cFrame.cAbsoluteTime.wSecond = 50;
// 	cFrame.cAbsoluteTime.wMillisecond = 500;
// 	cFrame.cAbsoluteTime.wWeek = 2;
// 	cFrame.dwFrameNumber = 1000;
// 	cFrame.dwTimeStamp = 298389;
// 	cFrame.cFrameBuffer.pBuffer = (BYTE*)"23456789";
// 	cFrame.cFrameBuffer.dwBufLen = sizeof("23456789");
// 	Output("VideoNetClient_StreamTransferSend g_hStream : %d\n",g_hStream);
// 	int result = VideoNetClient_StreamTransferSend(g_hStream,&cFrame);
//}

// void CVideoNetClientDemoDlg::OnDecodechannelSetconfig()
// {
// 	// TODO: ڴ
// 	DecoderChannelConfig cConfig;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cConfig.dwDecChanScaleStatus = 1;
// 	cConfig.cChannelChromaConfig.dwBrightness = 50;
// 	cConfig.cChannelChromaConfig.dwContrast = 100;
// 	cConfig.cChannelChromaConfig.dwHue = 150;
// 	cConfig.cChannelChromaConfig.dwSaturation = 200;
// 	if(0 == VideoNetClient_DecoderSetChannelConfig(hUser,dwChannel,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelGetconfig()
// {
// 	// TODO: ڴ
// 	DecoderChannelConfig cConfig;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	if(0 == VideoNetClient_DecoderGetChannelConfig(hUser,dwChannel,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelSetvideostandard()
// {
// 	// TODO: ڴ
// 	DecoderVideoStandardConfig cConfig;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cConfig.dwVideoStandard = 3;
// 	if(0 == VideoNetClient_DecoderSetVideoStandard(hUser,dwChannel,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelGetvideostandard()
// {
// 	// TODO: ڴ
// 	DecoderVideoStandardConfig cConfig;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	if(0 == VideoNetClient_DecoderGetVideoStandard(hUser,dwChannel,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelGetstatus()
// {
// 	// TODO: ڴ
// 	DecoderChannelStatus cStatus;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	if(0 == VideoNetClient_DecoderChannelGetStatus(hUser,&cStatus))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelSetplaystatus()
// {
// 	// TODO: ڴ
// 	DecoderSetPlayStatusParameter cConfig;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cConfig.ePlayControlStatus = eStreamPlayControlFast;
// 	for(int i=0; i<MAX_PLAY_CONTROL_PARAMETER; i++)
// 	{
// 		cConfig.dwParameter[i] = 10 + 4*i;
// 	}
// 	if(0 == VideoNetClient_DecoderChannelSetPlayStatus(hUser,dwChannel,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelGetplaystatus()
// {
// 	// TODO: ڴ
// 	DecoderGetPlayStatusParameter cConfig;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	if(0 == VideoNetClient_DecoderChannelGetPlayStatus(hUser,&cConfig))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelLogoswitch()
// {
// 	// TODO: ڴ
// 	eDeviceChannelControl cControl;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cControl = eDeviceChannelControlShowLogo;
// 
// 	if(0 == VideoNetClient_DecoderChannelLogoSwitch(hUser,dwChannel,cControl))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelDisplaycontrol32844()
// {
// 	// TODO: ڴ
// 	DecoderDisplayStatus cStatus;
// 	DWORD dwDisplay = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cStatus.dwWindow = 7;
// 	cStatus.eDisplayControlStatusValue = eDisplayControlStatusEnlarge;
// 
// 	if(0 == VideoNetClient_DecoderChannelDisplayControl(hUser,dwDisplay,&cStatus))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnDecodechannelLogoupload32846()
// {
// 	// TODO: ڴ
// 	BYTE bytTest[] = {0x02,0x06,0x00,0x00,0x03,0x08,0x00,0x09,0x00};
// 	UploadLogoParameter cParameter;
// 	DWORD dwChannel = 1;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cParameter.eLogoPictureValue = eLogoPictureTypeDecoderChannel;
// 	for(int i=0; i<MAX_LOGO_PICTURE_PARAMETER; i++)
// 	{
// 		cParameter.dwParameter[i] = i;
// 	}
// 	cParameter.cBuffer.pBuffer = bytTest;
// 	cParameter.cBuffer.dwBufLen = sizeof(bytTest);
// 
// 	if(0 == VideoNetClient_UploadLogo(hUser,dwChannel,&cParameter))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// HANDLE g_hQuery = (HANDLE)-1;
// void CVideoNetClientDemoDlg::OnTransmitqueryCreate()
// {
// 	// TODO: ڴ
// 	TransmitHistoryStreamQueryFactor cStreamQueryFactor;
// 	HUSER hUser = INVALID_HANDLE_VALUE;
// 	GetSelectUser(hUser);
// 	cStreamQueryFactor.cFactor.dwChannel = 8;
// 	cStreamQueryFactor.cFactor.dwDiskGroup = 2;
// 	cStreamQueryFactor.cFactor.dwStreamType = 5;
// 	strcpy(cStreamQueryFactor.cFactor.cBeginTime, "201010230830");
// 	strcpy(cStreamQueryFactor.cFactor.cEndTime, "201010260000");
// 	cStreamQueryFactor.cUserLoginPara.dwCommandPort = 5050;
// 	strcpy(cStreamQueryFactor.cUserLoginPara.sServerIP, "172.1.10.55");
// 	strcpy(cStreamQueryFactor.cUserLoginPara.sUName, "higheasy");
// 	strcpy(cStreamQueryFactor.cUserLoginPara.sUPass, "123456");
// 	cStreamQueryFactor.eDeviceProtocolValue = eDeviceProtocolTypeClassics;
// 
// 	if(0 == VideoNetClient_TransmitHistoryStreamQueryConnect(&g_hQuery, hUser,&cStreamQueryFactor))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
// }

// void CVideoNetClientDemoDlg::OnTransmitqueryDisconnect()
// {
	// TODO: ڴ
// 	if(0 == VideoNetClient_TransmitHistoryStreamQueryDisconnect(g_hQuery))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

// void CVideoNetClientDemoDlg::OnTransmitqueryQuery()
// {
	// TODO: ڴ
// 	HistoryStreamMultiTypeQueryResult cStreamQueryResult;
// 	memset(&cStreamQueryResult,0,sizeof(HistoryStreamMultiTypeQueryResult));
// 
// 	if(0 == VideoNetClient_TransmitHistoryStreamQueryNext(g_hQuery,&cStreamQueryResult))
// 	{
// 		SIMPLE_TRACK;
// 	}
// 	else
// 	{
// 		NOTIFY_OPERATION_FAILED;
// 	}
//}

void CVideoNetClientDemoDlg::OnUserGetfrontdevice()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	// list of front device
	VIDEONETCLIENT_FRONT_DEVICE_LIST front_device_list;
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_GET_DEVICES_CONNECT_LIST & (32<<16);
	config.dwAssistCommand = DEVICES_CONNECT_LIST_ALL;
	GetSelectUser(hUser);
	ret = VideoNetClient_GetConfig(hUser, &config);
	if (0 == ret)
	{
		memcpy(&front_device_list, config.sConfig, sizeof(front_device_list));

		for (int i=0; i<MAX_DEVICE_COUNT; i++)
		{
			printf("no[%d] ip = [%s]", i, front_device_list.struFrontDeviceInfo[i].strDevIp);
		}
	}
}

void CVideoNetClientDemoDlg::OnUserSetfrontdevice()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserGetpreviewlist()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserSetpreviewlist()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserFullscreenchannel()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserReturnfromfullscreen()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserS()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserStopcruise()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserRetrievemonitorcapability()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	// list of front device
	VIDEONETCLIENT_RESOLUTION_CAP cap;
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_GET_MONITOR_RESOLUTION;
	config.dwAssistCommand = MONITOR_CAP;
	GetSelectUser(hUser);
	ret = VideoNetClient_GetConfig(hUser, &config);
	if (0 == ret)
	{
		memcpy(&cap, config.sConfig, sizeof(cap));
	}

	
}

void CVideoNetClientDemoDlg::OnUserGetmonitorresolution()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	// list of front device
	VIDEONETCLIENT_RESOLUTION_LIST cap;
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_GET_MONITOR_RESOLUTION;
	config.dwAssistCommand = MONITOR_CONFIG;
	GetSelectUser(hUser);
	ret = VideoNetClient_GetConfig(hUser, &config);
	if (0 == ret)
	{
		memcpy(&cap, config.sConfig, sizeof(cap));
	}
}

void CVideoNetClientDemoDlg::OnUserSetmonitorresolution()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	// list of front device
	VIDEONETCLIENT_RESOLUTION_LIST cap;
	cap.bValid = 1;
	for (int i=0; i<DVR_MAX_VGARESOLVING_NUM; i++)
	{
		cap.acResolutionList[i].bValid = 1;
		sprintf(cap.acResolutionList[i].acResolutionDesc, "%dx%d", i+10, i+10);
	}
	
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_SET_MONITOR_RESOLUTION;
	config.dwAssistCommand = MONITOR_CONFIG;
	config.dwConfigLen = sizeof(cap);
	GetSelectUser(hUser);
	memcpy(config.sConfig, &cap, sizeof(cap));
	ret = VideoNetClient_SetConfig(hUser, &config);
	if (0 == ret)
	{
		//memcpy(&cap, config.sConfig, sizeof(cap));
	}
}

void CVideoNetClientDemoDlg::OnUserSetmotionmorethan32()
{
	int ret = 0;
	ConfigInformationV3 config;
	memset(&config, 0, sizeof(config));

	// list of front device
	VIDEONETCLIET_EVENT_ACTION action;
	action.bValid = 1;
	for (int i=0; i<DVR_MAX_VIDEOIN_NUM; i++)
	{
		action.struAction[i].bValid = 1;
		action.struAction[i].dwHandleType = (i<<16) | (1<<i);
		action.struAction[i].struPtzHandle->nPtzAction = (i<<16) | i;
		action.struAction[i].struPtzHandle->nPtzIndex = (i<<16) | (i+1);

		for (int j=0; j<32; j++)
		{
			action.struAction[i].nRecordChannelMask[j] = (i<<16) | (j+1);
			action.struAction[i].nSnapshotChannelMask[j] = (i<<16) | (j+2);
			action.struAction[i].nAlarmOutChannelMask[j] = (i<<16) | (j+3);
			action.struAction[i].nMonitorMask[j] = (i<<16) | (j+4);
		}
	}

	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_SET_PICCFG;
	config.dwAssistCommand = PICCFG_MOTION_ACTION_CONF;
	config.dwConfigLen = sizeof(action);
	config.dwBeginChannel = 0;
	GetSelectUser(hUser);
	memcpy(config.sConfig, &action, sizeof(action));
	ret = VideoNetClient_SetConfigV3(hUser, &config);
	if (0 == ret)
	{
		//memcpy(&cap, config.sConfig, sizeof(cap));
	}
}

void CVideoNetClientDemoDlg::OnUserGetmotionmorethan32()
{
	int ret = 0;
	ConfigInformationV3 config;
	memset(&config, 0, sizeof(config));

	VIDEONETCLIET_EVENT_ACTION action;
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_GET_PICCFG;
	config.dwAssistCommand = PICCFG_MOTION_ACTION_CONF;
	config.dwBeginChannel = 0;
	GetSelectUser(hUser);
	ret = VideoNetClient_GetConfigV3(hUser, &config);
	if (0 == ret)
	{
		memcpy(&action, config.sConfig, sizeof(action));
	}
}

void CVideoNetClientDemoDlg::OnUserSetdefrog()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	VIDEONETCLIENT_ADVANCED_CHANNEL_CFG cap;

	memset(&cap, 0, sizeof(cap));
	cap.bValid = 1;
	for (int i=0; i<DVR_MAX_VIDEOIN_NUM; i++)
	{
		//cap.nVideoCodecMode[i] = 1;
		//cap.nEnableCorridorMode[i] = 1;

		cap.struShelter[i].bValid = 1;
		cap.struShelter[i].nEnable = 1;

		cap.struShelter[i].struSchedTime.bValid = 1;
		cap.struShelter[i].struSchedTime.byState = 1;
		cap.struShelter[i].struSchedTime.bySetType[0][0] = 2;
		cap.struShelter[i].struSchedTime.bySetType[6][23] = 3;

		cap.struShelter[i].struShelterArea[0].bValid = 1;
		cap.struShelter[i].struShelterArea[0].bEnable = 1;
		cap.struShelter[i].struShelterArea[0].nHideAreaTopLeftX = 100;
		cap.struShelter[i].struShelterArea[0].nHideAreaTopLeftY = 100;

		cap.struShelter[i].struShelterArea[1].bValid = 1;
		cap.struShelter[i].struShelterArea[1].bEnable = 1;
		cap.struShelter[i].struShelterArea[1].nHideAreaTopLeftX = 200;
		cap.struShelter[i].struShelterArea[1].nHideAreaTopLeftY = 200;

	}
	
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_SET_PICCFG;
	config.dwAssistCommand = PICCFG_ADVANCED_CONF;
	config.dwConfigLen = sizeof(cap);
	GetSelectUser(hUser);
	memcpy(config.sConfig, &cap, sizeof(cap));
	ret = VideoNetClient_SetConfig(hUser, &config);
	if (0 == ret)
	{
		//memcpy(&cap, config.sConfig, sizeof(cap));
	}
}

void CVideoNetClientDemoDlg::OnUserGetdefrog()
{
	int ret = 0;
	ConfigInformation config;
	memset(&config, 0, sizeof(config));

	VIDEONETCLIENT_ADVANCED_CHANNEL_CFG action;
	HUSER hUser;
	config.dwMainCommand = VIDEONETCLIENT_GET_PICCFG;
	config.dwAssistCommand = PICCFG_ADVANCED_CONF;
	GetSelectUser(hUser);
	ret = VideoNetClient_GetConfig(hUser, &config);
	if (0 == ret)
	{
		memcpy(&action, config.sConfig, sizeof(action));
	}
}

void CVideoNetClientDemoDlg::OnUserSetadvancedchannel()
{
	// TODO: ڴ
}

void CVideoNetClientDemoDlg::OnUserGetadvancedchannel()
{
	// TODO: ڴ
}
